namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *cell_compute_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_RNN_CELL_COMPUTE_H)==""\n"
R"==(#define GPU_INTEL_OCL_RNN_CELL_COMPUTE_H)==""\n"
R"==(#include "gpu/intel/ocl/ocl_conversion.h")==""\n"
R"==(#include "gpu/intel/ocl/rnn/rnn_common.h")==""\n"
R"==(#if CELL_COMP_ENABLED)==""\n"
R"==(#define DHC_TG get_local_size(0))==""\n"
R"==(#define DHC_LOCAL (CELL_DHC_THR * DHC_TG))==""\n"
R"==(#define BATCH_TG get_local_size(1))==""\n"
R"==(#define BATCH_LOCAL (CELL_BATCH_THR * BATCH_TG))==""\n"
R"==(#define M_THR_BLOCK CELL_BATCH_THR)==""\n"
R"==(#define N_THR_BLOCK CELL_DHC_THR)==""\n"
R"==(#define N_OUTER_BLOCK n_gates)==""\n"
R"==(#define K_TG_BLOCK SUBGROUP_SIZE)==""\n"
R"==(#define K_THR_BLOCK 1)==""\n"
R"==(const int gemm_k_block = SUBGROUP_SIZE;)==""\n"
R"==(typedef int64_t cell_offset_t;)==""\n"
R"==(typedef int64_t grid_offset_t;)==""\n"
R"==(typedef dim_t cell_dim_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(cell_dim_t m;)==""\n"
R"==(cell_dim_t k;)==""\n"
R"==(cell_dim_t n_inner;)==""\n"
R"==(cell_dim_t n_outer;)==""\n"
R"==(} gemm_dims_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(bool m;)==""\n"
R"==(bool k;)==""\n"
R"==(bool n;)==""\n"
R"==(} gemm_overflow_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(cell_offset_t mb;)==""\n"
R"==(cell_offset_t slc;)==""\n"
R"==(cell_offset_t sic;)==""\n"
R"==(} cell_strides_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(grid_offset_t iter;)==""\n"
R"==(cell_strides_t cell;)==""\n"
R"==(} grid_strides_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global const WEI_LAYER_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} const_wei_layer_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global const WEI_ITER_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} const_wei_iter_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global AUX_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} aux_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global const AUX_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} const_aux_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global WS_STATE_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} ws_state_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(__global const WS_STATE_DATA_T *ptr;)==""\n"
R"==(cell_strides_t strides;)==""\n"
R"==(} const_ws_state_cell_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(cell_dim_t mb;)==""\n"
R"==(cell_dim_t dhc;)==""\n"
R"==(cell_dim_t slc;)==""\n"
R"==(cell_dim_t sic;)==""\n"
R"==(} cell_dims_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(union {)==""\n"
R"==(struct {)==""\n"
R"==(float alpha;)==""\n"
R"==(__global BIAS_DATA_T *bias;)==""\n"
R"==(__global float *tm_scales;)==""\n"
R"==(} rnn;)==""\n"
R"==(struct {)==""\n"
R"==(__global AUX_DATA_T *c_states;)==""\n"
R"==(__global const AUX_DATA_T *c_states_iter;)==""\n"
R"==(__global BIAS_DATA_T *bias;)==""\n"
R"==(__global float *tm_scales;)==""\n"
R"==(float tm_cscale;)==""\n"
R"==(} lstm;)==""\n"
R"==(};)==""\n"
R"==(} cell_ctx_t;)==""\n"
R"==(typedef struct {)==""\n"
R"==(cell_dim_t mb;)==""\n"
R"==(cell_dim_t dhc;)==""\n"
R"==(} cell_loops_t;)==""\n"
R"==(#define NEED_SCRATCH_GATES \)==""\n"
R"==((!(CELL_COMPUTE_GEMM_LAYER && CELL_COMPUTE_GEMM_ITER)))==""\n"
R"==(inline void __attribute__((overloadable)))==""\n"
R"==(load(float *s, const __global float *data, bool is_valid) {)==""\n"
R"==(*s = is_valid ? data[get_sub_group_local_id()] : 0;)==""\n"
R"==(})==""\n"
R"==(inline void __attribute__((overloadable)))==""\n"
R"==(load(float *s, const __global half *data, bool is_valid) {)==""\n"
R"==(*s = is_valid ? into_float(data[get_sub_group_local_id()]) : 0;)==""\n"
R"==(})==""\n"
R"==(inline void __attribute__((overloadable)))==""\n"
R"==(load(float *s, const __global ushort *data, bool is_valid) {)==""\n"
R"==(*s = is_valid ? into_float(as_bf16(data[get_sub_group_local_id()])) : 0;)==""\n"
R"==(})==""\n"
R"==(inline float __attribute__((overloadable)) sg_get(float s, int offset) {)==""\n"
R"==(return intel_sub_group_shuffle(s, offset);)==""\n"
R"==(})==""\n"
R"==(inline bool __attribute__((overloadable)))==""\n"
R"==(sg_get(bool s[gemm_k_block / SUBGROUP_SIZE], int offset) {)==""\n"
R"==(return intel_sub_group_shuffle()==""\n"
R"==(s[offset / SUBGROUP_SIZE], offset % SUBGROUP_SIZE);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}