namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *custom_reorder_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#undef cl_future_bf16_cvt)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/reorder_common.h")==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void custom_reorder(__global SRC_DATA_T *restrict src,)==""\n"
R"==(__global DST_DATA_T *restrict dst, __global float *restrict src_scales,)==""\n"
R"==(__global int *restrict src_zps, __global float *restrict dst_scales,)==""\n"
R"==(__global int *restrict dst_zps, float sum_scale, int sum_zp) {)==""\n"
R"==(const int src_zp = GET_SRC_ZP(src_zps);)==""\n"
R"==(const int dst_zp = GET_DST_ZP(dst_zps);)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES == 1)==""\n"
R"==(float src_scale = src_scales[0];)==""\n"
R"==(#else)==""\n"
R"==(float src_scale = 1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES == 1)==""\n"
R"==(float dst_scale = dst_scales[0];)==""\n"
R"==(#else)==""\n"
R"==(float dst_scale = 1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(src += SRC_OFFSET0;)==""\n"
R"==(dst += DST_OFFSET0;)==""\n"
R"==(#if UNALIGNED)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1_blk_start = GWS_GET_D1();)==""\n"
R"==(const int d2_blk_start = GWS_GET_D2();)==""\n"
R"==(const int d3_blk_start = GWS_GET_D3();)==""\n"
R"==(const int d4_blk_start = GWS_GET_D4();)==""\n"
R"==(const int d5_blk_start = GWS_GET_D5();)==""\n"
R"==(const int d1_blk_end = d1_blk_start + GWS_GET_D1_BLOCK();)==""\n"
R"==(const int d2_blk_end = d2_blk_start + GWS_GET_D2_BLOCK();)==""\n"
R"==(const int d3_blk_end = d3_blk_start + GWS_GET_D3_BLOCK();)==""\n"
R"==(const int d4_blk_end = d4_blk_start + GWS_GET_D4_BLOCK();)==""\n"
R"==(const int d5_blk_end = d5_blk_start + GWS_GET_D5_BLOCK();)==""\n"
R"==(for_(int d1 = d1_blk_start; d1 < d1_blk_end; ++d1))==""\n"
R"==(for_(int d2 = d2_blk_start; d2 < d2_blk_end; ++d2))==""\n"
R"==(for_(int d3 = d3_blk_start; d3 < d3_blk_end; ++d3))==""\n"
R"==(for_(int d4 = d4_blk_start; d4 < d4_blk_end; ++d4))==""\n"
R"==(for (int d5 = d5_blk_start; d5 < d5_blk_end; ++d5) {)==""\n"
R"==(const int src_off = SRC_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(#if PAD_FILL_ZERO == 1)==""\n"
R"==(int pad_d0 = d0 >= SRC_D0;)==""\n"
R"==(int pad_d1 = NDIMS > 1 && d1 >= SRC_D1;)==""\n"
R"==(int pad_d2 = NDIMS > 2 && d2 >= SRC_D2;)==""\n"
R"==(int pad_d3 = NDIMS > 3 && d3 >= SRC_D3;)==""\n"
R"==(int pad_d4 = NDIMS > 4 && d4 >= SRC_D4;)==""\n"
R"==(int pad_d5 = NDIMS > 5 && d5 >= SRC_D5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(dst[dst_off] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES > 1)==""\n"
R"==(src_scale = src_scales[SCALE_OFF(SRC, d0, d1, d2, d3, d4, d5)];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES > 1)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d0, d1, d2, d3, d4, d5)];)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst[dst_off], src[src_off], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(})==""\n"
R"==(#elif ALT_OFFSETS)==""\n"
R"==(const int d0 = get_global_id(0);)==""\n"
R"==(const int d1 = get_global_id(1);)==""\n"
R"==(const int d2 = get_global_id(2);)==""\n"
R"==(#ifdef LIMIT_MAX_D0)==""\n"
R"==(if (d0 >= LIMIT_MAX_D0) { return; })==""\n"
R"==(#endif)==""\n"
R"==(const int src_base = S0 * d0 + S1 * d1 + S2 * d2;)==""\n"
R"==(const int dst_base = D0 * d0 + D1 * d1 + D2 * d2;)==""\n"
R"==(for (int db = 0; db < BLK; ++db) {)==""\n"
R"==(const int src_off = src_base + db * SB;)==""\n"
R"==(const int dst_off = dst_base + db * DB;)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst[dst_off], src[src_off], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(})==""\n"
R"==(#elif PLAIN_xFxE_TO_ABCDEF)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(#define SUM_OUTPUT 1)==""\n"
R"==(#else)==""\n"
R"==(#define SUM_OUTPUT 0)==""\n"
R"==(#endif)==""\n"
R"==(const unsigned sglid = get_sub_group_local_id();)==""\n"
R"==(#define REORDER_BLOCK(block_size, src_memory, src_swap, src_offset) \)==""\n"
R"==({ \)==""\n"
R"==(unroll_for(unsigned sidx = 0; sidx < block_size; ++sidx) { \)==""\n"
R"==(const unsigned src_off \)==""\n"
R"==(= SRC_OFF(d0, d1, d2, d3, d4, sidx + src_offset); \)==""\n"
R"==(src_memory[sidx] = SRC_BLOCK_READ(&src[src_off]); \)==""\n"
R"==(} \)==""\n"
R"==(unroll_for(int j = 0; j < SUB_GROUP_SIZE; j++) \)==""\n"
R"==(unroll_for(int i = 0; i < block_size; i++) { \)==""\n"
R"==(unsigned x = (i + j * block_size) / SUB_GROUP_SIZE; \)==""\n"
R"==(unsigned y = (i + j * block_size) % SUB_GROUP_SIZE; \)==""\n"
R"==(unsigned sg_src = (i + j * block_size) / block_size; \)==""\n"
R"==(src_swap[x][y] = intel_sub_group_shuffle(src_mem[i], sg_src); \)==""\n"
R"==(} \)==""\n"
R"==(\)==""\n"
R"==(DST_DATA_T dst_tmp; \)==""\n"
R"==(unsigned dst_off; \)==""\n"
R"==(if (block_size < 16) dst_off = DST_OFF(d0, d1, d2, d3, d4, 0); \)==""\n"
R"==(\)==""\n"
R"==(unroll_for(unsigned sidx = 0; sidx < block_size; ++sidx) { \)==""\n"
R"==(if (block_size >= 16) \)==""\n"
R"==(dst_off = DST_OFF(d0, d1, d2, d3, d4 + sidx, src_offset); \)==""\n"
R"==(if (SUM_OUTPUT) dst_tmp = DST_BLOCK_READ(&dst[dst_off]); \)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, src_swap[sidx][sglid], src_scale, \)==""\n"
R"==(dst_scale, sum_scale, src_zp, dst_zp, sum_zp); \)==""\n"
R"==(DST_BLOCK_WRITE(&dst[dst_off], dst_tmp); \)==""\n"
R"==(if (block_size < 16) dst_off += SUB_GROUP_SIZE; \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#if DST_D5 > 16)==""\n"
R"==(unsigned block_size = 16;)==""\n"
R"==(#else)==""\n"
R"==(unsigned block_size = DST_D5;)==""\n"
R"==(#endif)==""\n"
R"==(SRC_DATA_T src_mem[16];)==""\n"
R"==(SRC_DATA_T src_all[16][SUB_GROUP_SIZE];)==""\n"
R"==(REORDER_BLOCK(block_size, src_mem, src_all, d5);)==""\n"
R"==(#elif TRANSPOSE_NXN || LOCAL_NXN)==""\n"
R"==(#define BATCH_SIZE SUB_GROUP_SIZE)==""\n"
R"==(int sgId = get_sub_group_local_id();)==""\n"
R"==(int sg_off = get_sub_group_id() * SUB_GROUP_SIZE * BATCH_SIZE;)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(const int d0_block = GWS_GET_D0_BLOCK();)==""\n"
R"==(const int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(const int d2_block = GWS_GET_D2_BLOCK();)==""\n"
R"==(const int d3_block = GWS_GET_D3_BLOCK();)==""\n"
R"==(const int d4_block = GWS_GET_D4_BLOCK();)==""\n"
R"==(const int d5_block = GWS_GET_D5_BLOCK();)==""\n"
R"==(#ifdef TRANSPOSE_NXN)==""\n"
R"==(SRC_DATA_T src_buf[SUB_GROUP_SIZE];)==""\n"
R"==(SRC_DATA_T dst_buf[SUB_GROUP_SIZE];)==""\n"
R"==(#else)==""\n"
R"==(__local SRC_DATA_T tmp[SG_PER_WG * BATCH_SIZE];)==""\n"
R"==(#endif)==""\n"
R"==(SRC_DATA_T send_buf;)==""\n"
R"==(#if PAD_FILL_ZERO == 1)==""\n"
R"==(const int pad_d0 = d0 >= SRC_D0;)==""\n"
R"==(const int pad_d1 = NDIMS > 1 && d1 >= SRC_D1;)==""\n"
R"==(const int pad_d2 = NDIMS > 2 && d2 >= SRC_D2;)==""\n"
R"==(const int pad_d3 = NDIMS > 3 && d3 >= SRC_D3;)==""\n"
R"==(const int pad_d4 = NDIMS > 4 && d4 >= SRC_D4;)==""\n"
R"==(const int pad_d5 = NDIMS > 5 && d5 >= SRC_D5;)==""\n"
R"==(const int pad = pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5;)==""\n"
R"==(#else)==""\n"
R"==(const int pad = 0;)==""\n"
R"==(#endif)==""\n"
R"==(if (!pad) {)==""\n"
R"==(for_(int d0i = 0; d0i < d0_block; d0i++))==""\n"
R"==(for_(int d1i = 0; d1i < d1_block; d1i++))==""\n"
R"==(for_(int d2i = 0; d2i < d2_block; d2i++))==""\n"
R"==(for_(int d3i = 0; d3i < d3_block; d3i++))==""\n"
R"==(for_(int d4i = 0; d4i < d4_block; d4i++))==""\n"
R"==(for (int d5i = 0; d5i < d5_block; d5i++) {)==""\n"
R"==(const int iter = d0i + d1i + d2i + d3i + d4i + d5i;)==""\n"
R"==(const int src_off = SRC_OFF()==""\n"
R"==(d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5 + d5i);)==""\n"
R"==(#ifdef TRANSPOSE_NXN)==""\n"
R"==(src_buf[iter] = SRC_BLOCK_READ(&src[src_off]);)==""\n"
R"==(#else)==""\n"
R"==(tmp[sg_off + iter * SUB_GROUP_SIZE + sgId])==""\n"
R"==(= SRC_BLOCK_READ(&src[src_off]);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#ifdef TRANSPOSE_NXN)==""\n"
R"==(dst_buf[sgId] = src_buf[sgId];)==""\n"
R"==(for (int i = 1; i < SUB_GROUP_SIZE; i++) {)==""\n"
R"==(send_buf = src_buf[(i + sgId) % BATCH_SIZE];)==""\n"
R"==(dst_buf[(BATCH_SIZE + sgId - i) % BATCH_SIZE])==""\n"
R"==(= intel_sub_group_shuffle()==""\n"
R"==(send_buf, (BATCH_SIZE + sgId - i) % BATCH_SIZE);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(for_(int d0i = 0; d0i < d0_block; d0i++))==""\n"
R"==(for_(int d1i = 0; d1i < d1_block; d1i++))==""\n"
R"==(for_(int d2i = 0; d2i < d2_block; d2i++))==""\n"
R"==(for_(int d3i = 0; d3i < d3_block; d3i++))==""\n"
R"==(for_(int d4i = 0; d4i < d4_block; d4i++))==""\n"
R"==(for (int d5i = 0; d5i < d5_block; d5i++) {)==""\n"
R"==(const int iter = d0i + d1i + d2i + d3i + d4i + d5i;)==""\n"
R"==(#if DST_BLOCK_DIM == 0)==""\n"
R"==(const int dst_off = DST_OFF(d0 + iter, d1, d2, d3, d4, d5);)==""\n"
R"==(#elif DST_BLOCK_DIM == 1)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1 + iter, d2, d3, d4, d5);)==""\n"
R"==(#elif DST_BLOCK_DIM == 2)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2 + iter, d3, d4, d5);)==""\n"
R"==(#elif DST_BLOCK_DIM == 3)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3 + iter, d4, d5);)==""\n"
R"==(#elif DST_BLOCK_DIM == 4)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3, d4 + iter, d5);)==""\n"
R"==(#elif DST_BLOCK_DIM == 5)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3, d4, d5 + iter);)==""\n"
R"==(#endif)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(if (!pad) {)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES > 1)==""\n"
R"==(src_scale = src_scales[SCALE_OFF(SRC, d0, d1, d2, d3, d4, d5)];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES > 1)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d0, d1, d2, d3, d4, d5)];)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef TRANSPOSE_NXN)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, dst_buf[iter], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(#else)==""\n"
R"==(send_buf = tmp[sg_off + sgId * SUB_GROUP_SIZE + iter];)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, send_buf, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(#endif)==""\n"
R"==(} else {)==""\n"
R"==(dst_tmp = 0;)==""\n"
R"==(})==""\n"
R"==(DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(#elif REORDER_NCHW)==""\n"
R"==(#define BIGGER_THAN_16 (SRC_D1 >= 16))==""\n"
R"==(int sgId = get_sub_group_local_id();)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(SRC_DATA_T src_buf[SUB_GROUP_SIZE];)==""\n"
R"==(SRC_DATA_T dst_buf[SUB_GROUP_SIZE];)==""\n"
R"==(#if BIGGER_THAN_16)==""\n"
R"==(SRC_DATA_T send_buf;)==""\n"
R"==(#else)==""\n"
R"==(SRC_DATA_T exch_buf[d1_block][SUB_GROUP_SIZE];)==""\n"
R"==(#endif)==""\n"
R"==(#if BIGGER_THAN_16)==""\n"
R"==(#define STRIDE_S SRC_D1)==""\n"
R"==(#else)==""\n"
R"==(#define STRIDE_S 16)==""\n"
R"==(#endif)==""\n"
R"==(#define STRIDE_D (SRC_D2 * SRC_D3))==""\n"
R"==(for (int i = 0; i < d1_block; i++) {)==""\n"
R"==(int src_off = SRC_OFF(d0, d1, d2, d3, 0, 0) + STRIDE_S * i;)==""\n"
R"==(src_buf[i] = SRC_BLOCK_READ(&src[src_off]);)==""\n"
R"==(})==""\n"
R"==(#if BIGGER_THAN_16)==""\n"
R"==(for (int i = 0; i < SUB_GROUP_SIZE; i++) {)==""\n"
R"==(send_buf = src_buf[(i + sgId) % 16];)==""\n"
R"==(dst_buf[(16 + sgId - i) % 16])==""\n"
R"==(= intel_sub_group_shuffle(send_buf, (16 + sgId - i) % 16);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < d1_block; i++) {)==""\n"
R"==(for (int sg = 0; sg < SUB_GROUP_SIZE; sg++) {)==""\n"
R"==(exch_buf[i][sg] = intel_sub_group_shuffle(src_buf[i], sg);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < d1_block; i++) {)==""\n"
R"==(int ofs = i + sgId * d1_block;)==""\n"
R"==(dst_buf[i] = exch_buf[ofs / SUB_GROUP_SIZE][ofs % SUB_GROUP_SIZE];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < d1_block; i++) {)==""\n"
R"==(int dst_off = DST_OFF(d0, d1, d2, d3, 0, 0) + STRIDE_D * i;)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, dst_buf[i], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(#elif PLAIN_TO_ABCD84A42B)==""\n"
R"==(const int sglid = get_sub_group_local_id();)==""\n"
R"==(const int sg = get_sub_group_id();)==""\n"
R"==(#define SRC_D3_ALIGNED (SRC_D3 % SUB_GROUP_SIZE == 0))==""\n"
R"==(#define IS_SRC_ABCD_LAYOUT (SRC_S3_0 == 1))==""\n"
R"==(#define IS_SRC_ACDB_LAYOUT (SRC_S3_0 != 1))==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d0_block = GWS_GET_D0_BLOCK();)==""\n"
R"==(const int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(const int d01_block = d0_block * d1_block;)==""\n"
R"==(__local SRC_DATA_T loc_buf[SG_PER_WG][d01_block][SUB_GROUP_SIZE];)==""\n"
R"==(for (int d0_inner = 0; d0_inner < d0_block; d0_inner++) {)==""\n"
R"==(for (int d1_inner = 0; d1_inner < d1_block; d1_inner++) {)==""\n"
R"==(if (SRC_D0 % d0_block != 0 && d0 + d0_inner >= SRC_D0) {)==""\n"
R"==(loc_buf[sg][d0_inner * d1_block + d1_inner][sglid] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(if (SRC_D1 % d1_block != 0 && d1 + d1_inner >= SRC_D1) {)==""\n"
R"==(loc_buf[sg][d0_inner * d1_block + d1_inner][sglid] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(if (IS_SRC_ABCD_LAYOUT)==""\n"
R"==(&& (SRC_D3_ALIGNED || d3 + SUB_GROUP_SIZE < SRC_D3)) {)==""\n"
R"==(const int src_off)==""\n"
R"==(= SRC_OFF(d0 + d0_inner, d1 + d1_inner, d2, d3, 0, 0);)==""\n"
R"==(loc_buf[sg][d0_inner * d1_block + d1_inner][sglid])==""\n"
R"==(= src[src_off + sglid];)==""\n"
R"==(} else {)==""\n"
R"==(if (SRC_D3_ALIGNED || d3 + sglid < SRC_D3) {)==""\n"
R"==(const int src_off = SRC_OFF()==""\n"
R"==(d0 + d0_inner, d1 + d1_inner, d2, d3 + sglid, 0, 0);)==""\n"
R"==(loc_buf[sg][d0_inner * d1_block + d1_inner][sglid])==""\n"
R"==(= src[src_off];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(if (SRC_D3_ALIGNED || d3 + SUB_GROUP_SIZE < SRC_D3) {)==""\n"
R"==(for (int d = 0; d < SUB_GROUP_SIZE; d += 8) {)==""\n"
R"==(SRC_DATA8_T src_tmp;)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(src_tmp[i] = loc_buf[sg][sglid][d + i];)==""\n"
R"==(})==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3 + d, 0, 0);)==""\n"
R"==(DST_DATA8_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(for (int n = 0; n < 8; n++) {)==""\n"
R"==(dst_tmp[n] = dst[dst_off + sglid + n * SUB_GROUP_SIZE];)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst_tmp, src_tmp, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(for (int n = 0; n < 8; n++) {)==""\n"
R"==(dst[dst_off + sglid + n * SUB_GROUP_SIZE] = dst_tmp[n];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(for (int d = 0; d < SUB_GROUP_SIZE; d++) {)==""\n"
R"==(if (d3 + d < SRC_D3) {)==""\n"
R"==(const SRC_DATA_T src_tmp = loc_buf[sg][sglid][d];)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, d2, d3 + d, 0, 0);)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp[n] = dst[dst_off + sglid];)==""\n"
R"==(#endif )==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, src_tmp, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(dst[dst_off + sglid] = dst_tmp;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#elif PLAIN_TO_AB_XX_8AYB)==""\n"
R"==(int sgId = get_sub_group_local_id();)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d0b = GWS_GET_D0_BLOCK();)==""\n"
R"==(const int d1b = GWS_GET_D1_BLOCK();)==""\n"
R"==(SRC_DATA_T src_buf[d0b];)==""\n"
R"==(DST_DATA_T dst_buf[d0b];)==""\n"
R"==(for (int d0i = 0; d0i < d0b; ++d0i) {)==""\n"
R"==(const int src_off = SRC_OFF(d0 + d0i, d1, 0, 0, 0, 0);)==""\n"
R"==(src_buf[d0i] = SRC_BLOCK_READ(&src[src_off]);)==""\n"
R"==(})==""\n"
R"==(SRC_DATA_T tmp_buf[d0b][SUB_GROUP_SIZE];)==""\n"
R"==(for (int i = 0; i < d0b; i++) {)==""\n"
R"==(for (int sg = 0; sg < SUB_GROUP_SIZE; sg++) {)==""\n"
R"==(tmp_buf[i][sg] = intel_sub_group_shuffle(src_buf[i], sg);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if BLK_L == 4)==""\n"
R"==(for (int d0i = 0; d0i < d0b; ++d0i) {)==""\n"
R"==(dst_buf[d0i] = tmp_buf[(d0i % 2 * BLK_L) + sgId / BLK_L])==""\n"
R"==([(d0i / 2) * BLK_L + sgId % BLK_L];)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(for (int d0i = 0; d0i < d0b; ++d0i) {)==""\n"
R"==(dst_buf[d0i] = tmp_buf[sgId / BLK_L][d0i * BLK_L + sgId % BLK_L];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(for (int d0i = 0; d0i < d0b; ++d0i) {)==""\n"
R"==(const int dst_off = DST_OFF(d0, d1, 0, 0, 0, 0) + SUB_GROUP_SIZE * d0i;)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, dst_buf[d0i], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(#elif VECTORIZE_LAST_DIM)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(const int d0_block = GWS_GET_D0_BLOCK();)==""\n"
R"==(const int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(const int d2_block = GWS_GET_D2_BLOCK();)==""\n"
R"==(const int d3_block = GWS_GET_D3_BLOCK();)==""\n"
R"==(const int d4_block = GWS_GET_D4_BLOCK();)==""\n"
R"==(for_(int d0i = 0; d0i < d0_block; d0i++))==""\n"
R"==(for_(int d1i = 0; d1i < d1_block; d1i++))==""\n"
R"==(for_(int d2i = 0; d2i < d2_block; d2i++))==""\n"
R"==(for_(int d3i = 0; d3i < d3_block; d3i++))==""\n"
R"==(for (int d4i = 0; d4i < d4_block; d4i++) {)==""\n"
R"==(int src_off)==""\n"
R"==(= SRC_OFF(d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5);)==""\n"
R"==(SRC_DATA_T src_tmp = SRC_BLOCK_READ(&src[src_off]);)==""\n"
R"==(int dst_off)==""\n"
R"==(= DST_OFF(d0 + d0i, d1 + d1i, d2 + d2i, d3 + d3i, d4 + d4i, d5);)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, src_tmp, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(DST_BLOCK_WRITE(&dst[dst_off], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(#elif PAD_INNERMOST)==""\n"
R"==(const int sgId = get_sub_group_local_id();)==""\n"
R"==(int d[6];)==""\n"
R"==(int blk[6];)==""\n"
R"==(int b[6] = {0, 0, 0, 0, 0, 0};)==""\n"
R"==(d[0] = GWS_GET_D0();)==""\n"
R"==(d[1] = GWS_GET_D1();)==""\n"
R"==(d[2] = GWS_GET_D2();)==""\n"
R"==(d[3] = GWS_GET_D3();)==""\n"
R"==(d[4] = GWS_GET_D4();)==""\n"
R"==(d[5] = GWS_GET_D5();)==""\n"
R"==(blk[0] = GWS_GET_D0_BLOCK();)==""\n"
R"==(blk[1] = GWS_GET_D1_BLOCK();)==""\n"
R"==(blk[2] = GWS_GET_D2_BLOCK();)==""\n"
R"==(blk[3] = GWS_GET_D3_BLOCK();)==""\n"
R"==(blk[4] = GWS_GET_D4_BLOCK();)==""\n"
R"==(blk[5] = GWS_GET_D5_BLOCK();)==""\n"
R"==(__local SRC_DATA_T cache[SG_PER_WG * GROUP * GROUP * VECT_SIZE];)==""\n"
R"==(const int sg_off = get_sub_group_id() * VECT_SIZE * (GROUP * GROUP);)==""\n"
R"==(for (int i = 0; i < blk[SRC_LOOP_DIM]; i++) {)==""\n"
R"==(b[SRC_LOOP_DIM] = i;)==""\n"
R"==(const int src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(unroll_for(int j = 0; j < GROUP; j++) {)==""\n"
R"==(const int coff = sg_off + VECT_SIZE * GROUP * i + VECT_SIZE * j;)==""\n"
R"==(const int soff = src_off + INNERMOST_SIZE * j;)==""\n"
R"==(#if NON_INNERMOST_PADDING == 1)==""\n"
R"==(const int pad_d0 = d[0] + b[0] >= SRC_D0;)==""\n"
R"==(const int pad_d1 = NDIMS > 1 && d[1] + b[1] >= SRC_D1;)==""\n"
R"==(const int pad_d2 = NDIMS > 2 && d[2] + b[2] >= SRC_D2;)==""\n"
R"==(const int pad_d3 = NDIMS > 3 && d[3] + b[3] >= SRC_D3;)==""\n"
R"==(const int pad_d4 = NDIMS > 4 && d[4] + b[4] >= SRC_D4;)==""\n"
R"==(const int pad_d5 = NDIMS > 5 && d[5] + b[5] >= SRC_D5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(cache[coff + sgId] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(if (sgId < INNERMOST_SIZE) {)==""\n"
R"==(cache[coff + sgId] = src[soff + sgId];)==""\n"
R"==(} else {)==""\n"
R"==(cache[coff + sgId] = 0;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(b[SRC_LOOP_DIM] = 0;)==""\n"
R"==(for (int i = 0; i < blk[DST_LOOP_DIM]; i++) {)==""\n"
R"==(b[DST_LOOP_DIM] = i;)==""\n"
R"==(const int dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES > 1)==""\n"
R"==(src_scale = src_scales[SCALE_OFF(SRC, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES > 1)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(unroll_for(int j = 0; j < GROUP; j++) {)==""\n"
R"==(const int coff = sg_off + VECT_SIZE * GROUP * j + VECT_SIZE * i;)==""\n"
R"==(const int doff = dst_off + VECT_SIZE * j;)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = dst[doff + sgId * DST_INNERMOST_STRIDE];)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, cache[coff + sgId], src_scale,)==""\n"
R"==(dst_scale, sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(dst[doff + sgId * DST_INNERMOST_STRIDE] = dst_tmp;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#elif VECTORIZE_GROUPS)==""\n"
R"==(int d[6];)==""\n"
R"==(int blk[6];)==""\n"
R"==(int b[6] = {0, 0, 0, 0, 0, 0};)==""\n"
R"==(d[0] = GWS_GET_D0();)==""\n"
R"==(d[1] = GWS_GET_D1();)==""\n"
R"==(d[2] = GWS_GET_D2();)==""\n"
R"==(d[3] = GWS_GET_D3();)==""\n"
R"==(d[4] = GWS_GET_D4();)==""\n"
R"==(d[5] = GWS_GET_D5();)==""\n"
R"==(blk[0] = GWS_GET_D0_BLOCK();)==""\n"
R"==(blk[1] = GWS_GET_D1_BLOCK();)==""\n"
R"==(blk[2] = GWS_GET_D2_BLOCK();)==""\n"
R"==(blk[3] = GWS_GET_D3_BLOCK();)==""\n"
R"==(blk[4] = GWS_GET_D4_BLOCK();)==""\n"
R"==(blk[5] = GWS_GET_D5_BLOCK();)==""\n"
R"==(SRC_DATA_T cache[GROUP * GROUP];)==""\n"
R"==(int coeff = (VECT_DIM == SRC_LOOP_DIM ? get_sub_group_size() : 1);)==""\n"
R"==(for (int i = 0; i < blk[SRC_LOOP_DIM]; i++) {)==""\n"
R"==(b[SRC_LOOP_DIM] = coeff * i;)==""\n"
R"==(const int src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(unroll_for(int j = 0; j < GROUP; j++) {)==""\n"
R"==(int cidx = GROUP * i + j;)==""\n"
R"==(int sidx = src_off + get_sub_group_size() * j;)==""\n"
R"==(#if PAD_FILL_ZERO == 1)==""\n"
R"==(int pad_d0 = d[0] + b[0] >= SRC_D0;)==""\n"
R"==(int pad_d1 = NDIMS > 1 && d[1] + b[1] >= SRC_D1;)==""\n"
R"==(int pad_d2 = NDIMS > 2 && d[2] + b[2] >= SRC_D2;)==""\n"
R"==(int pad_d3 = NDIMS > 3 && d[3] + b[3] >= SRC_D3;)==""\n"
R"==(int pad_d4 = NDIMS > 4 && d[4] + b[4] >= SRC_D4;)==""\n"
R"==(int pad_d5 = NDIMS > 5 && d[5] + b[5] >= SRC_D5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(cache[cidx] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(cache[cidx] = SRC_BLOCK_READ(&src[sidx]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(b[SRC_LOOP_DIM] = 0;)==""\n"
R"==(coeff = (VECT_DIM == DST_LOOP_DIM ? get_sub_group_size() : 1);)==""\n"
R"==(for (int i = 0; i < blk[DST_LOOP_DIM]; i++) {)==""\n"
R"==(b[DST_LOOP_DIM] = coeff * i;)==""\n"
R"==(const int dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(int pad_d0 = d[0] + b[0] >= DST_PD0;)==""\n"
R"==(int pad_d1 = NDIMS > 1 && d[1] + b[1] >= DST_PD1;)==""\n"
R"==(int pad_d2 = NDIMS > 2 && d[2] + b[2] >= DST_PD2;)==""\n"
R"==(int pad_d3 = NDIMS > 3 && d[3] + b[3] >= DST_PD3;)==""\n"
R"==(int pad_d4 = NDIMS > 4 && d[4] + b[4] >= DST_PD4;)==""\n"
R"==(int pad_d5 = NDIMS > 5 && d[5] + b[5] >= DST_PD5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(unroll_for(int j = 0; j < GROUP; j++) {)==""\n"
R"==(int cidx = i + j * GROUP;)==""\n"
R"==(int didx = dst_off + get_sub_group_size() * j;)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[didx]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES > 1)==""\n"
R"==(src_scale = src_scales[SCALE_OFF(SRC, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES > 1)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, cache[cidx], src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(DST_BLOCK_WRITE(&dst[didx], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#elif USE_DENSE_VECT)==""\n"
R"==(const int d0_blk_start = GWS_GET_D0();)==""\n"
R"==(const int d0_blk_end = d0_blk_start + (GWS_GET_D0_BLOCK() * 16);)==""\n"
R"==(for (int d0 = d0_blk_start; d0 < d0_blk_end; d0 += 128) {)==""\n"
R"==(SRC_DATA8_T src_tmp = SRC_BLOCK_READ8(&src[d0]);)==""\n"
R"==(DST_DATA8_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ8(&dst[d0]);)==""\n"
R"==(#endif)==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst_tmp, src_tmp, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[d0], dst_tmp);)==""\n"
R"==(})==""\n"
R"==(#elif XAB_XBA)==""\n"
R"==(const int sgId = get_sub_group_local_id();)==""\n"
R"==(const int sgNr = get_sub_group_id();)==""\n"
R"==(const int wgId)==""\n"
R"==(= get_group_id(0) + 10 * get_group_id(1) + 100 * get_group_id(2);)==""\n"
R"==(int d[6];)==""\n"
R"==(int blk[6];)==""\n"
R"==(int b[6] = {0, 0, 0, 0, 0, 0};)==""\n"
R"==(d[0] = GWS_GET_D0();)==""\n"
R"==(d[1] = GWS_GET_D1();)==""\n"
R"==(d[2] = GWS_GET_D2();)==""\n"
R"==(d[3] = GWS_GET_D3();)==""\n"
R"==(d[4] = GWS_GET_D4();)==""\n"
R"==(d[5] = GWS_GET_D5();)==""\n"
R"==(blk[0] = GWS_GET_D0_BLOCK();)==""\n"
R"==(blk[1] = GWS_GET_D1_BLOCK();)==""\n"
R"==(blk[2] = GWS_GET_D2_BLOCK();)==""\n"
R"==(blk[3] = GWS_GET_D3_BLOCK();)==""\n"
R"==(blk[4] = GWS_GET_D4_BLOCK();)==""\n"
R"==(blk[5] = GWS_GET_D5_BLOCK();)==""\n"
R"==(__local SRC_DATA_T tmp[SG_PER_WG * SUB_GROUP_SIZE * BLOCK_SIZE];)==""\n"
R"==(SRC_DATA_T data;)==""\n"
R"==(const int sgLs = SUB_GROUP_SIZE * BLOCK_SIZE;)==""\n"
R"==(const int wg_off = sgNr * sgLs;)==""\n"
R"==(for (int i = 0; i < blk[SRC_BLK_DIM]; i++) {)==""\n"
R"==(b[SRC_BLK_DIM] = SRC_OFF_COEFF * i;)==""\n"
R"==(const int src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(#if PAD_FILL_ZERO == 1)==""\n"
R"==(const int pad_d0 = d[0] + b[0] >= SRC_D0;)==""\n"
R"==(const int pad_d1 = NDIMS > 1 && d[1] + b[1] >= SRC_D1;)==""\n"
R"==(const int pad_d2 = NDIMS > 2 && d[2] + b[2] >= SRC_D2;)==""\n"
R"==(const int pad_d3 = NDIMS > 3 && d[3] + b[3] >= SRC_D3;)==""\n"
R"==(const int pad_d4 = NDIMS > 4 && d[4] + b[4] >= SRC_D4;)==""\n"
R"==(const int pad_d5 = NDIMS > 5 && d[5] + b[5] >= SRC_D5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(tmp[wg_off + SUB_GROUP_SIZE * i + sgId] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(data = src[src_off + sgId];)==""\n"
R"==(tmp[wg_off + SUB_GROUP_SIZE * i + sgId] = data;)==""\n"
R"==(})==""\n"
R"==(b[SRC_BLK_DIM] = 0;)==""\n"
R"==(for (int i = 0; i < blk[SRC_BLK_DIM]; i++) {)==""\n"
R"==(b[DST_BLK_DIM] = DST_OFF_COEFF * i;)==""\n"
R"==(const int dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(#if XB_TO_XAB)==""\n"
R"==(SRC_DATA_T data = tmp[wg_off + (sgId % (SUB_GROUP_SIZE / BLOCK_SIZE)))==""\n"
R"==(+ (sgId / (SUB_GROUP_SIZE / BLOCK_SIZE)) * SUB_GROUP_SIZE)==""\n"
R"==(+ (SUB_GROUP_SIZE / BLOCK_SIZE) * i];)==""\n"
R"==(#else )==""\n"
R"==(SRC_DATA_T data = tmp[wg_off + (sgId % BLOCK_SIZE) * SUB_GROUP_SIZE)==""\n"
R"==(+ sgId / BLOCK_SIZE + (SUB_GROUP_SIZE / BLOCK_SIZE) * i];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE && SRC_NUM_SCALES > 1)==""\n"
R"==(src_scale = src_scales[SCALE_OFF(SRC, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE && DST_NUM_SCALES > 1)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5])];)==""\n"
R"==(#endif)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = dst[dst_off + sgId];)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, data, src_scale, dst_scale, sum_scale,)==""\n"
R"==(src_zp, dst_zp, sum_zp);)==""\n"
R"==(dst[dst_off + sgId] = dst_tmp;)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D4();)==""\n"
R"==(const int d5 = GWS_GET_D5();)==""\n"
R"==(const int local_id = get_sub_group_local_id();)==""\n"
R"==(#if SRC_16A16B || DST_16A16B || SRC_16B16A || DST_16B16A)==""\n"
R"==(src += SRC_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(dst += DST_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(SRC_DATA8_T in0, in1;)==""\n"
R"==(#if SRC_16A16B || SRC_16B16A)==""\n"
R"==(in0 = SRC_BLOCK_READ8(&src[0]);)==""\n"
R"==(in1 = SRC_BLOCK_READ8(&src[8 * 16]);)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if DST_16B16A)==""\n"
R"==(in0[i] = src[SRC_OFF(local_id, i, 0, 0, 0, 0)];)==""\n"
R"==(in1[i] = src[SRC_OFF(local_id, i + 8, 0, 0, 0, 0)];)==""\n"
R"==(#else)==""\n"
R"==(in0[i] = src[SRC_OFF(i, local_id, 0, 0, 0, 0)];)==""\n"
R"==(in1[i] = src[SRC_OFF(i + 8, local_id, 0, 0, 0, 0)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(DST_DATA8_T dst0, dst1;)==""\n"
R"==(#if (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A))==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16B16A)==""\n"
R"==(dst0[i] = dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)];)==""\n"
R"==(dst1[i] = dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)];)==""\n"
R"==(#else)==""\n"
R"==(dst0[i] = dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)];)==""\n"
R"==(dst1[i] = dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#elif DST_16A16B || DST_16B16A)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst0 = DST_BLOCK_READ8(&dst[0]);)==""\n"
R"==(dst1 = DST_BLOCK_READ8(&dst[8 * 16]);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16B16A)==""\n"
R"==(dst0[i] = dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)];)==""\n"
R"==(dst1[i] = dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)];)==""\n"
R"==(#else)==""\n"
R"==(dst0[i] = dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)];)==""\n"
R"==(dst1[i] = dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst0, in0, src_scale, dst_scale, sum_scale, src_zp,)==""\n"
R"==(dst_zp, sum_zp);)==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst1, in1, src_scale, dst_scale, sum_scale, src_zp,)==""\n"
R"==(dst_zp, sum_zp);)==""\n"
R"==(#if (SRC_16A16B || SRC_16B16A) && (DST_16A16B || DST_16B16A))==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16B16A)==""\n"
R"==(dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)] = dst0[i];)==""\n"
R"==(dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)] = dst1[i];)==""\n"
R"==(#else)==""\n"
R"==(dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)] = dst0[i];)==""\n"
R"==(dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)] = dst1[i];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#elif DST_16A16B || DST_16B16A)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[0], dst0);)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[8 * 16], dst1);)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16B16A)==""\n"
R"==(dst[DST_OFF(local_id, i + 0, 0, 0, 0, 0)] = dst0[i];)==""\n"
R"==(dst[DST_OFF(local_id, i + 8, 0, 0, 0, 0)] = dst1[i];)==""\n"
R"==(#else)==""\n"
R"==(dst[DST_OFF(i + 0, local_id, 0, 0, 0, 0)] = dst0[i];)==""\n"
R"==(dst[DST_OFF(i + 8, local_id, 0, 0, 0, 0)] = dst1[i];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#elif SRC_16B || DST_16B)==""\n"
R"==(SRC_DATA_T src_tmp;)==""\n"
R"==(#if SRC_16B)==""\n"
R"==(src += SRC_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(src_tmp = SRC_BLOCK_READ(&src[0]);)==""\n"
R"==(#else)==""\n"
R"==(src += SRC_OFF(d0, d1 + local_id, d2, d3, d4, d5);)==""\n"
R"==(src_tmp = src[0];)==""\n"
R"==(#endif )==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(#if DST_16B)==""\n"
R"==(dst += DST_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = DST_BLOCK_READ(&dst[0]);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(dst += DST_OFF(d0, d1 + local_id, d2, d3, d4, d5);)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = dst[0];)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, src_tmp, src_scale, dst_scale, sum_scale,)==""\n"
R"==(src_zp, dst_zp, sum_zp);)==""\n"
R"==(#if DST_16B)==""\n"
R"==(DST_BLOCK_WRITE(&dst[0], dst_tmp);)==""\n"
R"==(#else)==""\n"
R"==(dst[0] = dst_tmp;)==""\n"
R"==(#endif )==""\n"
R"==(#elif SRC_16B16C || DST_16B16C || SRC_16C16B || DST_16C16B)==""\n"
R"==(const int g = d0;)==""\n"
R"==(SRC_DATA8_T in0, in1;)==""\n"
R"==(#if SRC_16B16C || SRC_16C16B)==""\n"
R"==(src += SRC_OFF_G(g, d1, d2, d3, d4, d5);)==""\n"
R"==(in0 = SRC_BLOCK_READ8(&src[0]);)==""\n"
R"==(in1 = SRC_BLOCK_READ8(&src[8 * 16]);)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if DST_16C16B)==""\n"
R"==(in0[i] = src[SRC_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];)==""\n"
R"==(in1[i] = src[SRC_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];)==""\n"
R"==(#else)==""\n"
R"==(in0[i] = src[SRC_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(in1[i] = src[SRC_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(DST_DATA8_T dst0, dst1;)==""\n"
R"==(#if (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B))==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16C16B)==""\n"
R"==(dst0[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];)==""\n"
R"==(dst1[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];)==""\n"
R"==(#else)==""\n"
R"==(dst0[i] = dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(dst1[i] = dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#elif DST_16B16C || DST_16C16B)==""\n"
R"==(dst += DST_OFF_G(g, d1, d2, d3, d4, d5);)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst0 = DST_BLOCK_READ8(&dst[0]);)==""\n"
R"==(dst1 = DST_BLOCK_READ8(&dst[8 * 16]);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16C16B)==""\n"
R"==(dst0[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)];)==""\n"
R"==(dst1[i] = dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)];)==""\n"
R"==(#else)==""\n"
R"==(dst0[i] = dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(dst1[i] = dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst0, in0, src_scale, dst_scale, sum_scale, src_zp,)==""\n"
R"==(dst_zp, sum_zp);)==""\n"
R"==(REORDER8(DEFAULT_ROUND, dst1, in1, src_scale, dst_scale, sum_scale, src_zp,)==""\n"
R"==(dst_zp, sum_zp);)==""\n"
R"==(#if (SRC_16B16C || SRC_16C16B) && (DST_16B16C || DST_16C16B))==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16C16B)==""\n"
R"==(dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)] = dst0[i];)==""\n"
R"==(dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)] = dst1[i];)==""\n"
R"==(#else)==""\n"
R"==(dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)] = dst0[i];)==""\n"
R"==(dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)] = dst1[i];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#elif DST_16B16C || DST_16C16B)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[0], dst0);)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[8 * 16], dst1);)==""\n"
R"==(#else)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(#if SRC_16C16B)==""\n"
R"==(dst[DST_OFF_G(g, d1 + local_id, d2 + i + 0, d3, d4, d5)] = dst0[i];)==""\n"
R"==(dst[DST_OFF_G(g, d1 + local_id, d2 + i + 8, d3, d4, d5)] = dst1[i];)==""\n"
R"==(#else)==""\n"
R"==(dst[DST_OFF_G(g, d1 + i + 0, d2 + local_id, d3, d4, d5)] = dst0[i];)==""\n"
R"==(dst[DST_OFF_G(g, d1 + i + 8, d2 + local_id, d3, d4, d5)] = dst1[i];)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}