namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *deconv_backward_bias_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(__kernel void deconv_backward_bias()==""\n"
R"==(__global DST_DATA_T *diff_dst, __global BIA_DATA_T *diff_bias) {)==""\n"
R"==(const int g = get_global_id(0) / OC;)==""\n"
R"==(const int oc = get_global_id(0) % OC;)==""\n"
R"==(ACC_DATA_T db = 0;)==""\n"
R"==(for (int mb = 0; mb < MB; ++mb))==""\n"
R"==(for (int od = 0; od < OD; ++od))==""\n"
R"==(for (int oh = 0; oh < OH; ++oh))==""\n"
R"==(for (int ow = 0; ow < OW; ++ow) {)==""\n"
R"==(uint diff_dst_off = DST_OFF(mb, g * OC + oc, od, oh, ow);)==""\n"
R"==(db += DST_TO_REF(diff_dst[diff_dst_off]);)==""\n"
R"==(})==""\n"
R"==(diff_bias[g * OC + oc] = TO_BIA(db);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}