namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gemm_post_ops_inner_product_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#ifdef DST_DT_F32)==""\n"
R"==(#define DST_TO_ACC(x) (x))==""\n"
R"==(#else)==""\n"
R"==(#define DST_TO_ACC(x) TO_DEF_ACC_DATA_T(x))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BIAS_DT_F32)==""\n"
R"==(#define BIAS_TO_ACC(x) (x))==""\n"
R"==(#else)==""\n"
R"==(#define BIAS_TO_ACC(x) TO_DEF_ACC_DATA_T(x))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef SRC_DT_F32)==""\n"
R"==(#define SRC_TO_ACC(x) (x))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_TO_ACC(x) TO_DEF_ACC_DATA_T(x))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void gemm_post_ops_inner_product(__global SRC_DATA_T *src,)==""\n"
R"==(__global BIAS_DATA_T *bias, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global SPAD_DATA_T *scratchpad) {)==""\n"
R"==(const size_t mb = get_global_id(0) / OC;)==""\n"
R"==(const size_t oc = get_global_id(0) % OC;)==""\n"
R"==(const size_t data_idx = mb * OC + oc;)==""\n"
R"==(#if USE_TEMP_DST == 1)==""\n"
R"==(ACC_DATA_T acc = SRC_TO_ACC(scratchpad[data_idx]);)==""\n"
R"==(#else)==""\n"
R"==(ACC_DATA_T acc = SRC_TO_ACC(src[data_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_BIAS == 1)==""\n"
R"==(acc += BIAS_TO_ACC(bias[oc]);)==""\n"
R"==(#endif)==""\n"
R"==(float sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = DST_TO_ACC(dst[data_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(float accumulator = acc;)==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D()==""\n"
R"==(accumulator, float, sum_src, float, mb, 1, oc, 1);)==""\n"
R"==(dst[data_idx] = TO_DST(accumulator);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}