namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_binary_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/binary_common.h")==""\n"
R"==(#if IS_PLAIN_LAYOUT)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_binary(__global SRC0_DATA_T *src0,)==""\n"
R"==(__global SRC1_DATA_T *src1, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global float *src0_scale, __global float *src1_scale) {)==""\n"
R"==(int dims0[6] = {0};)==""\n"
R"==(int local_id = get_sub_group_local_id();)==""\n"
R"==(unsigned mid_dim = GWS_GET_MIXED_DIM();)==""\n"
R"==(dims0[5] = mid_dim % DST_D5;)==""\n"
R"==(mid_dim /= DST_D5;)==""\n"
R"==(dims0[4] = mid_dim % DST_D4;)==""\n"
R"==(mid_dim /= DST_D4;)==""\n"
R"==(dims0[3] = mid_dim % DST_D3;)==""\n"
R"==(mid_dim /= DST_D3;)==""\n"
R"==(dims0[2] = mid_dim % DST_D2;)==""\n"
R"==(mid_dim /= DST_D2;)==""\n"
R"==(dims0[1] = mid_dim % DST_D1;)==""\n"
R"==(mid_dim /= DST_D1;)==""\n"
R"==(dims0[0] = mid_dim;)==""\n"
R"==(#if HAS_TAIL)==""\n"
R"==(if (dims0[0] > (DST_D0 - 1)) { return; })==""\n"
R"==(#endif)==""\n"
R"==(int src0_off = SRC0_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(src0 += src0_off;)==""\n"
R"==(int src1_off = SRC1_OFF(dims0[0] * (!BCAST_DIM0), dims0[1] * (!BCAST_DIM1),)==""\n"
R"==(dims0[2] * (!BCAST_DIM2), dims0[3] * (!BCAST_DIM3),)==""\n"
R"==(dims0[4] * (!BCAST_DIM4), dims0[5] * (!BCAST_DIM5));)==""\n"
R"==(src1 += src1_off;)==""\n"
R"==(int dst_off = DST_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(dst += dst_off;)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(#define src0_scale_val src0_scale[0])==""\n"
R"==(#else)==""\n"
R"==(#define src0_scale_val 1)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(#define src1_scale_val src1_scale[0])==""\n"
R"==(#else)==""\n"
R"==(#define src1_scale_val 1)==""\n"
R"==(#endif)==""\n"
R"==(float tmp_src0[NVECT];)==""\n"
R"==(READ_DATA(NVECT, SRC0, (&src0[0]), (&tmp_src0[0]), src0_scale_val);)==""\n"
R"==(#if BCAST_AT_INNERMOST_DIM)==""\n"
R"==(float tmp_src1[1];)==""\n"
R"==(tmp_src1[0] = src1_scale_val * CONVERT_FLOAT_T(src1[0]);)==""\n"
R"==(#define SRC1_IDX_MASK 0)==""\n"
R"==(#else)==""\n"
R"==(float tmp_src1[NVECT];)==""\n"
R"==(READ_DATA(NVECT, SRC1, (&src1[0]), (&tmp_src1[0]), src1_scale_val);)==""\n"
R"==(#define SRC1_IDX_MASK 1)==""\n"
R"==(#endif)==""\n"
R"==(float tmp[NVECT];)==""\n"
R"==(unroll_for(unsigned idx = 0; idx < NVECT; ++idx) {)==""\n"
R"==(tmp[idx] = binary_op()==""\n"
R"==(BINARY_ALG, tmp_src0[idx], tmp_src1[idx * SRC1_IDX_MASK]);)==""\n"
R"==(})==""\n"
R"==(float dst_data[NVECT];)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(READ_DATA(NVECT, DST, (&dst[0]), (&dst_data[0]), 1);)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_TAIL)==""\n"
R"==(unsigned gws_dim = get_global_id(0);)==""\n"
R"==(int po_dims0[6] = {0};)==""\n"
R"==(po_dims0[5] = gws_dim % DST_D5;)==""\n"
R"==(gws_dim /= DST_D5;)==""\n"
R"==(po_dims0[4] = gws_dim % DST_D4;)==""\n"
R"==(gws_dim /= DST_D4;)==""\n"
R"==(po_dims0[3] = gws_dim % DST_D3;)==""\n"
R"==(gws_dim /= DST_D3;)==""\n"
R"==(po_dims0[2] = gws_dim % DST_D2;)==""\n"
R"==(gws_dim /= DST_D2;)==""\n"
R"==(po_dims0[1] = gws_dim % DST_D1;)==""\n"
R"==(gws_dim /= DST_D1;)==""\n"
R"==(if (gws_dim >= DST_D0) { return; })==""\n"
R"==(po_dims0[0] = gws_dim;)==""\n"
R"==(#else)==""\n"
R"==(int po_dims0[6])==""\n"
R"==(= {dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]};)==""\n"
R"==(po_dims0[NDIMS - 1] += local_id;)==""\n"
R"==(#endif)==""\n"
R"==(unroll_for(unsigned idx = 0; idx < NVECT; ++idx) {)==""\n"
R"==(float d_i = tmp[idx];)==""\n"
R"==(float dst_i = dst_data[idx];)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d_i, float, dst_i, float, po_dims0[0], 1,)==""\n"
R"==(po_dims0[1], 1, po_dims0[2], 1, po_dims0[3], 1, po_dims0[4], 1,)==""\n"
R"==(po_dims0[5], 1);)==""\n"
R"==(tmp[idx] = d_i;)==""\n"
R"==(po_dims0[NDIMS - 1] += SUB_GROUP_SIZE;)==""\n"
R"==(})==""\n"
R"==(WRITE_DATA(NVECT, DST, (&tmp[0]), (&dst[0]));)==""\n"
R"==(})==""\n"
R"==(#elif PLAIN_TO_ABCD4AXB)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_binary(__global SRC0_DATA_T *src0,)==""\n"
R"==(__global SRC1_DATA_T *src1, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global float *src0_scale, __global float *src1_scale) {)==""\n"
R"==(src0 += SRC0_OFFSET0;)==""\n"
R"==(src1 += SRC1_OFFSET0;)==""\n"
R"==(dst += DST_OFFSET0;)==""\n"
R"==(int sglid = get_sub_group_local_id();)==""\n"
R"==(const int d0 = GWS_GET_D0();)==""\n"
R"==(const int d1 = GWS_GET_D1();)==""\n"
R"==(const int d2 = GWS_GET_D2();)==""\n"
R"==(const int d3 = GWS_GET_D3();)==""\n"
R"==(const int d4 = GWS_GET_D3();)==""\n"
R"==(const int d5 = GWS_GET_D3();)==""\n"
R"==(const int d0_block = GWS_GET_D0_BLOCK();)==""\n"
R"==(const int d1_block = GWS_GET_D1_BLOCK();)==""\n"
R"==(const int d01_block = d0_block * d1_block;)==""\n"
R"==(SRC0_DATA_T tmp_buf0[d01_block] = {0};)==""\n"
R"==(SRC1_DATA_T tmp_buf1[d01_block] = {0};)==""\n"
R"==(DST_DATA_T res_buf[d01_block] = {0};)==""\n"
R"==(const int d0_inner_block = min(d0_block, SRC0_D0);)==""\n"
R"==(const int d1_inner_block = min(d1_block, SRC0_D1);)==""\n"
R"==(for (int d0_inner = 0; d0_inner < d0_inner_block; d0_inner++) {)==""\n"
R"==(for (int d1_inner = 0; d1_inner < d1_inner_block; d1_inner++) {)==""\n"
R"==(if (SRC0_D0 % d0_inner_block != 0 && d0 + d0_inner >= SRC0_D0))==""\n"
R"==(continue;)==""\n"
R"==(if (SRC0_D1 % d1_inner_block != 0 && d1 + d1_inner >= SRC0_D1))==""\n"
R"==(continue;)==""\n"
R"==(int src0_off;)==""\n"
R"==(int src1_off;)==""\n"
R"==(if (SRC0_S3_0 == 1) {)==""\n"
R"==(src0_off = SRC0_OFF(d0 + d0_inner, d1 + d1_inner, d2, d3, 0, 0);)==""\n"
R"==(tmp_buf0[d0_inner * d1_block + d1_inner])==""\n"
R"==(= SRC0_BLOCK_READ(&src0[src0_off]);)==""\n"
R"==(src1_off = SRC1_OFF((d0 + d0_inner) * (!BCAST_DIM0),)==""\n"
R"==((d1 + d1_inner) * (!BCAST_DIM1), d2 * (!BCAST_DIM2),)==""\n"
R"==(d3 * (!BCAST_DIM3), 0, 0);)==""\n"
R"==(} else {)==""\n"
R"==(src0_off = SRC0_OFF()==""\n"
R"==(d0 + d0_inner, d1 + d1_inner, d2, d3 + sglid, 0, 0);)==""\n"
R"==(tmp_buf0[d0_inner * d1_block + d1_inner] = src0[src0_off];)==""\n"
R"==(src1_off = SRC1_OFF((d0 + d0_inner) * (!BCAST_DIM0),)==""\n"
R"==((d1 + d1_inner) * (!BCAST_DIM1), d2 * (!BCAST_DIM2),)==""\n"
R"==((d3 + sglid) * (!BCAST_DIM3), 0, 0);)==""\n"
R"==(})==""\n"
R"==(#if BCAST_AT_INNERMOST_DIM == 1)==""\n"
R"==(tmp_buf1[d0_inner * d1_block + d1_inner] = src1[src1_off];)==""\n"
R"==(#else)==""\n"
R"==(tmp_buf1[d0_inner * d1_block + d1_inner])==""\n"
R"==(= SRC1_BLOCK_READ(&src1[src1_off]);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(int i = 0;)==""\n"
R"==(for (int d0_i = 0; d0_i < d0_block; d0_i++) {)==""\n"
R"==(for (int d1_i = 0; d1_i < d1_block; d1_i++) {)==""\n"
R"==(float tmp_src0 = CONVERT_FLOAT_T(tmp_buf0[i]);)==""\n"
R"==(float tmp_src1 = CONVERT_FLOAT_T(tmp_buf1[i]);)==""\n"
R"==(float res;)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * src0_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * src1_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(res = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(APPLY_POST_OPS_SERIAL(res, float, dst_data, float, d0 + d0_i, 1,)==""\n"
R"==(d1 + d1_i, 1, d2, 1, d3 + sglid, 1, d4, 1, d5, 1);)==""\n"
R"==(res_buf[i] = TO_DST(res);)==""\n"
R"==(++i;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(DST_DATA_T res_all[d01_block][SUB_GROUP_SIZE];)==""\n"
R"==(for (int i = 0; i < d01_block; i++))==""\n"
R"==(for (int j = 0; j < SUB_GROUP_SIZE; j++))==""\n"
R"==(res_all[i][j] = intel_sub_group_shuffle(res_buf[i], j);)==""\n"
R"==(for (int d = 0; d < SUB_GROUP_SIZE; d += 8) {)==""\n"
R"==(DST_DATA8_T res_tmp;)==""\n"
R"==(for (int i = 0; i < 8; i++))==""\n"
R"==(res_tmp[i] = res_all[sglid][d + i];)==""\n"
R"==(int dst_off = DST_OFF(d0, d1, d2, d3 + d, 0, 0);)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[dst_off], res_tmp);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#elif IS_XA16B)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_binary(__global SRC0_DATA_T *src0,)==""\n"
R"==(__global SRC1_DATA_T *src1, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global float *src0_scale, __global float *src1_scale) {)==""\n"
R"==(int dims0[6] = {0};)==""\n"
R"==(dims0[0] = GWS_GET_D0();)==""\n"
R"==(dims0[1] = GWS_GET_D1();)==""\n"
R"==(dims0[2] = GWS_GET_D2();)==""\n"
R"==(dims0[3] = GWS_GET_D3();)==""\n"
R"==(dims0[4] = GWS_GET_D4();)==""\n"
R"==(dims0[5] = GWS_GET_D5();)==""\n"
R"==(int src0_off = SRC0_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(int dst_off = DST_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(int src1_off = SRC1_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(int sub_grp_id = get_sub_group_local_id();)==""\n"
R"==(for (int channels = 0; channels < SRC0_PD1; channels += GWS_LWS0_DEFAULT) {)==""\n"
R"==(float8 d = 0;)==""\n"
R"==(float8 dst_data;)==""\n"
R"==(__global SRC1_DATA_T *t_src1 = src1 + src1_off;)==""\n"
R"==(__global DST_DATA_T *t_dst = dst + dst_off;)==""\n"
R"==(__global SRC0_DATA_T *t_src0 = src0 + src0_off;)==""\n"
R"==(if ((SRC0_D1 % SUB_GROUP_SIZE != 0))==""\n"
R"==(&& (dims0[1] + sub_grp_id) >= SRC0_D1) {)==""\n"
R"==(d = 0;)==""\n"
R"==(} else {)==""\n"
R"==(float8 tmp_src0 = CONVERT_FLOAT8_T(SRC0_BLOCK_READ8(&t_src0[0]));)==""\n"
R"==(float8 tmp_src1 = CONVERT_FLOAT8_T(SRC1_BLOCK_READ8(&t_src1[0]));)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * src0_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * src1_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = CONVERT_FLOAT8_T(DST_BLOCK_READ8(&t_dst[0]));)==""\n"
R"==(#endif)==""\n"
R"==(const int po_mb = dims0[0];)==""\n"
R"==(const int po_oc = dims0[1] + sub_grp_id;)==""\n"
R"==(for (int lcl_mb = 0; lcl_mb < NVECT; ++lcl_mb) {)==""\n"
R"==(if (po_mb + lcl_mb >= SRC0_D0) {)==""\n"
R"==(d[lcl_mb] = 0;)==""\n"
R"==(} else {)==""\n"
R"==(float d_i = d[lcl_mb];)==""\n"
R"==(float dst_i = dst_data[lcl_mb];)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d_i, float, dst_i, float,)==""\n"
R"==(po_mb + lcl_mb, 1, po_oc, 1, dims0[2], 1, dims0[3],)==""\n"
R"==(1, dims0[4], 1, dims0[5], 1);)==""\n"
R"==(d[lcl_mb] = d_i;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(DST_BLOCK_WRITE8(&t_dst[0], TO_DST8(d));)==""\n"
R"==(src0_off += MB_BLOCK * SUB_GROUP_SIZE * SRC0_PD2 * SRC0_PD3 * SRC0_PD4)==""\n"
R"==(* SRC0_PD5;)==""\n"
R"==(src1_off += MB_BLOCK * SUB_GROUP_SIZE * SRC1_PD2 * SRC1_PD3 * SRC1_PD4)==""\n"
R"==(* SRC1_PD5;)==""\n"
R"==(dst_off += MB_BLOCK * SUB_GROUP_SIZE * DST_PD2 * DST_PD3 * DST_PD4)==""\n"
R"==(* DST_PD5;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_binary(__global SRC0_DATA_T *src0,)==""\n"
R"==(__global SRC1_DATA_T *src1, __global DST_DATA_T *dst POST_OP_ARGS,)==""\n"
R"==(__global float *src0_scale, __global float *src1_scale) {)==""\n"
R"==(int dims0[6] = {0};)==""\n"
R"==(dims0[0] = GWS_GET_D0();)==""\n"
R"==(dims0[1] = GWS_GET_D1();)==""\n"
R"==(dims0[2] = GWS_GET_D2();)==""\n"
R"==(dims0[3] = GWS_GET_D3();)==""\n"
R"==(dims0[4] = GWS_GET_D4();)==""\n"
R"==(dims0[5] = GWS_GET_D5();)==""\n"
R"==(#if IS_SRC1_BROADCAST)==""\n"
R"==(int src0_off = SRC0_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(src0 += src0_off;)==""\n"
R"==(int dst_off = DST_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(dst += dst_off;)==""\n"
R"==(int src1_off = SRC1_OFF(dims0[0] * (!BCAST_DIM0), dims0[1] * (!BCAST_DIM1),)==""\n"
R"==(dims0[2] * (!BCAST_DIM2), dims0[3] * (!BCAST_DIM3),)==""\n"
R"==(dims0[4] * (!BCAST_DIM4), dims0[5] * (!BCAST_DIM5));)==""\n"
R"==(src1 += src1_off;)==""\n"
R"==(#if NVECT == 1)==""\n"
R"==(float d = 0;)==""\n"
R"==(float dst_data;)==""\n"
R"==(float tmp_src0 = CONVERT_FLOAT_T(SRC0_BLOCK_READ(&src0[0]));)==""\n"
R"==(#elif NVECT == 2)==""\n"
R"==(float2 d = 0;)==""\n"
R"==(float2 dst_data;)==""\n"
R"==(float2 tmp_src0 = CONVERT_FLOAT2_T(SRC0_BLOCK_READ2(&src0[0]));)==""\n"
R"==(#elif NVECT == 4)==""\n"
R"==(float4 d = 0;)==""\n"
R"==(float4 dst_data;)==""\n"
R"==(float4 tmp_src0 = CONVERT_FLOAT4_T(SRC0_BLOCK_READ4(&src0[0]));)==""\n"
R"==(#elif NVECT == 8)==""\n"
R"==(float8 d = 0;)==""\n"
R"==(float8 dst_data;)==""\n"
R"==(float8 tmp_src0 = CONVERT_FLOAT8_T(SRC0_BLOCK_READ8(&src0[0]));)==""\n"
R"==(#endif)==""\n"
R"==(#if BCAST_DIM1)==""\n"
R"==(float tmp_src1 = CONVERT_FLOAT_T(src1[0]);)==""\n"
R"==(#else)==""\n"
R"==(#if BCAST_AT_INNERMOST_DIM == 1 || NVECT == 1)==""\n"
R"==(float tmp_src1 = CONVERT_FLOAT_T(SRC1_BLOCK_READ(&src1[0]));)==""\n"
R"==(#elif NVECT == 2)==""\n"
R"==(float2 tmp_src1 = CONVERT_FLOAT2_T(SRC1_BLOCK_READ2(&src1[0]));)==""\n"
R"==(#elif NVECT == 4)==""\n"
R"==(float4 tmp_src1 = CONVERT_FLOAT4_T(SRC1_BLOCK_READ4(&src1[0]));)==""\n"
R"==(#elif NVECT == 8)==""\n"
R"==(float8 tmp_src1 = CONVERT_FLOAT8_T(SRC1_BLOCK_READ8(&src1[0]));)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * src0_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * src1_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(#if NVECT == 1)==""\n"
R"==(dst_data = CONVERT_FLOAT_T(DST_BLOCK_READ(&dst[0]));)==""\n"
R"==(#elif NVECT == 2)==""\n"
R"==(dst_data = CONVERT_FLOAT2_T(DST_BLOCK_READ2(&dst[0]));)==""\n"
R"==(#elif NVECT == 4)==""\n"
R"==(dst_data = CONVERT_FLOAT4_T(DST_BLOCK_READ4(&dst[0]));)==""\n"
R"==(#elif NVECT == 8)==""\n"
R"==(dst_data = CONVERT_FLOAT8_T(DST_BLOCK_READ8(&dst[0]));)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(const int po_mb = dims0[0];)==""\n"
R"==(const int po_oc = dims0[1] + get_sub_group_local_id();)==""\n"
R"==(#if NVECT == 1)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d, float, dst_data, float, po_mb, 1, po_oc, 1,)==""\n"
R"==(dims0[2], 1, dims0[3], 1, dims0[4], 1, dims0[5], 1);)==""\n"
R"==(#else)==""\n"
R"==(for (int vidx = 0; vidx < NVECT; ++vidx) {)==""\n"
R"==(float d_i = d[vidx];)==""\n"
R"==(float dst_i = dst_data[vidx];)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d_i, float, dst_i, float, po_mb, 1, po_oc, 1,)==""\n"
R"==(dims0[2], 1, dims0[3], 1, dims0[4], 1, dims0[5], 1);)==""\n"
R"==(d[vidx] = d_i;)==""\n"
R"==(++dims0[NDIMS - 1];)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if NVECT == 1)==""\n"
R"==(DST_BLOCK_WRITE(&dst[0], TO_DST(d));)==""\n"
R"==(#elif NVECT == 2)==""\n"
R"==(DST_BLOCK_WRITE2(&dst[0], TO_DST2(d));)==""\n"
R"==(#elif NVECT == 4)==""\n"
R"==(DST_BLOCK_WRITE4(&dst[0], TO_DST4(d));)==""\n"
R"==(#elif NVECT == 8)==""\n"
R"==(DST_BLOCK_WRITE8(&dst[0], TO_DST8(d));)==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(int local_channel = get_sub_group_local_id();)==""\n"
R"==(int channel_block = get_sub_group_id();)==""\n"
R"==(const int sub_group_size = 16;)==""\n"
R"==(const int CHANNELS = SRC1_PD1;)==""\n"
R"==(int src0_off, src1_off;)==""\n"
R"==(#if IS_SRC0_BLOCKED)==""\n"
R"==(src0_off = SRC0_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(src0 += src0_off;)==""\n"
R"==(src1_off = dims0[0] * CHANNELS * SRC1_PD2 * SRC1_PD3 * SRC1_PD4)==""\n"
R"==(+ (channel_block * sub_group_size + local_channel) * SRC1_PD2)==""\n"
R"==(* SRC1_PD3 * SRC1_PD4)==""\n"
R"==(+ dims0[2] * SRC1_PD3 * SRC1_PD4 + dims0[3] * SRC1_PD4 + dims0[4];)==""\n"
R"==(src1 += src1_off;)==""\n"
R"==(#else )==""\n"
R"==(src1_off = SRC1_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(src1 += src1_off;)==""\n"
R"==(src0_off = dims0[0] * CHANNELS * SRC0_PD2 * SRC0_PD3 * SRC0_PD4)==""\n"
R"==(+ (channel_block * sub_group_size + local_channel) * SRC0_PD2)==""\n"
R"==(* SRC0_PD3 * SRC0_PD4)==""\n"
R"==(+ dims0[2] * SRC0_PD3 * SRC0_PD4 + dims0[3] * SRC0_PD4 + dims0[4];)==""\n"
R"==(src0 += src0_off;)==""\n"
R"==(#endif)==""\n"
R"==(int dst_off = DST_OFF()==""\n"
R"==(dims0[0], dims0[1], dims0[2], dims0[3], dims0[4], dims0[5]);)==""\n"
R"==(dst += dst_off;)==""\n"
R"==(for (int idx = 0; idx < sub_group_size; idx++) {)==""\n"
R"==(float d = 0;)==""\n"
R"==(float dst_data;)==""\n"
R"==(#if IS_SRC0_BLOCKED)==""\n"
R"==(float tmp_src0)==""\n"
R"==(= CONVERT_FLOAT_T(src0[local_channel + sub_group_size * idx]);)==""\n"
R"==(float tmp_src1 = CONVERT_FLOAT_T(src1[idx]);)==""\n"
R"==(#else )==""\n"
R"==(float tmp_src0 = CONVERT_FLOAT_T(src0[idx]);)==""\n"
R"==(float tmp_src1)==""\n"
R"==(= CONVERT_FLOAT_T(src1[local_channel + sub_group_size * idx]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC0_SCALE)==""\n"
R"==(tmp_src0 = tmp_src0 * src0_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC1_SCALE)==""\n"
R"==(tmp_src1 = tmp_src1 * src1_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(d = binary_op(BINARY_ALG, tmp_src0, tmp_src1);)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_data = CONVERT_FLOAT_T()==""\n"
R"==(DST_BLOCK_READ(&dst[local_channel + sub_group_size * idx]));)==""\n"
R"==(#endif)==""\n"
R"==(const int po_mb = dims0[0];)==""\n"
R"==(const int po_oc = dims0[1] + get_sub_group_local_id();)==""\n"
R"==(APPLY_POST_OPS_SERIAL(d, float, dst_data, float, po_mb, 1, po_oc, 1,)==""\n"
R"==(dims0[2], 1, dims0[3], 1, dims0[4], 1, dims0[5], 1);)==""\n"
R"==(++dims0[NDIMS - 1];)==""\n"
R"==(DST_BLOCK_WRITE(&dst[local_channel + sub_group_size * idx], TO_DST(d));)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}