namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_fwd_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm.h")==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm_reduce.h")==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_IDX(n, dest, src, idx) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; ++k) { \)==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[(k + idx) * IC]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(n, dest, src, idx) \)==""\n"
R"==({ \)==""\n"
R"==(for (int k = 0; k < n; k += 2) { \)==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[(k + idx) * IC]); \)==""\n"
R"==(} \)==""\n"
R"==(})==""\n"
R"==(#if USE_STATS_ONE_PASS)==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_mean_var(__global DATA_T *src,)==""\n"
R"==(__global ACCUM_DATA_T *reduce_temp,)==""\n"
R"==(volatile __global atomic_float *mean,)==""\n"
R"==(volatile __global atomic_float *variance) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx;)==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(const int ver_offs = REDUCE_STAT_NBLOCKS * IC;)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(#else)==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP)==""\n"
R"==(+ mb * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(SUM_DATA_T sum;)==""\n"
R"==(SUM_DATA_T sum_sq;)==""\n"
R"==(sum.s0 = 0;)==""\n"
R"==(sum.s1 = 0;)==""\n"
R"==(sum_sq.s0 = 0;)==""\n"
R"==(sum_sq.s1 = 0;)==""\n"
R"==(#if HAS_STAT_SP_TAIL)==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) {)==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK;)==""\n"
R"==(while (sp >= 16) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(s0[k] = LOAD_DATA_1x16(&src[k * IC]);)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(s1[k] = LOAD_DATA_1x16(&src[(k + 8) * IC]);)==""\n"
R"==(#else)==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(sum = summation(s0[i], sum);)==""\n"
R"==(sum = summation(s1[i], sum);)==""\n"
R"==(sum_sq = summation(s0[i] * s0[i], sum_sq);)==""\n"
R"==(sum_sq = summation(s1[i] * s1[i], sum_sq);)==""\n"
R"==(})==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(sp -= 16;)==""\n"
R"==(})==""\n"
R"==(while (sp >= 1) {)==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(sum = summation(s0, sum);)==""\n"
R"==(sum_sq = summation(s0 * s0, sum_sq);)==""\n"
R"==(src += IC_BLOCK_STRIDE;)==""\n"
R"==(--sp;)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(s0[k] = LOAD_DATA_1x16(&src[k * IC]);)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(s1[k] = LOAD_DATA_1x16(&src[(k + 8) * IC]);)==""\n"
R"==(#else)==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(sum = summation(s0[i], sum);)==""\n"
R"==(sum = summation(s1[i], sum);)==""\n"
R"==(sum_sq = summation(s0[i] * s0[i], sum_sq);)==""\n"
R"==(sum_sq = summation(s1[i] * s1[i], sum_sq);)==""\n"
R"==(})==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local SUM_DATA_T local_sum[2 * CALC_SLM_SIZE];)==""\n"
R"==(__local SUM_DATA_T *local_sum_sq = local_sum + CALC_SLM_SIZE;)==""\n"
R"==(gen9_mean_var_calc_fused_reduction()==""\n"
R"==(mean, variance, c, &sum, &sum_sq, local_sum, local_sum_sq);)==""\n"
R"==(#else)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], sum.s0);)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[ver_offs + group_c_offset + mb_sp_idx * 16],)==""\n"
R"==(sum_sq.s0);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#else )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_mean(__global DATA_T *src, __global float *reduce_temp,)==""\n"
R"==(volatile __global atomic_float *mean) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx;)==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1);)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(#else)==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP)==""\n"
R"==(+ mb * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(float8 res0 = 0.0f, res1 = 0.0f;)==""\n"
R"==(float v_mean = 0.0f;)==""\n"
R"==(#if HAS_STAT_SP_TAIL)==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) {)==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK;)==""\n"
R"==(while (sp >= 16) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8);)==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8);)==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(s0[k + 1] = t0[k];)==""\n"
R"==(s1[k + 1] = t1[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp = sp == 16;)==""\n"
R"==(if (is_last_sp && is_last_ic_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0);)==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8);)==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif )==""\n"
R"==(res0 += s0;)==""\n"
R"==(res1 += s1;)==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(sp -= 16;)==""\n"
R"==(})==""\n"
R"==(while (sp >= 1) {)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(float s0;)==""\n"
R"==(if (sp == 1 && is_last_ic_block))==""\n"
R"==(s0 = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f;)==""\n"
R"==(else)==""\n"
R"==(s0 = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#else)==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#endif)==""\n"
R"==(v_mean += s0;)==""\n"
R"==(src += IC_BLOCK_STRIDE;)==""\n"
R"==(--sp;)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==({)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8);)==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8);)==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(s0[k + 1] = t0[k];)==""\n"
R"==(s1[k + 1] = t1[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp = sp == STAT_SP_BLOCK / 16 - 1;)==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0);)==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8);)==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif )==""\n"
R"==(res0 += s0;)==""\n"
R"==(res1 += s1;)==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(v_mean += res0[i] + res1[i];)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE];)==""\n"
R"==(gen9_calc_fused_reduction(mean, c, &v_mean, local_sum);)==""\n"
R"==(#else)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], v_mean);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calc_variance(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *reduce_temp, __global atomic_float *variance) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx;)==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16);)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1);)==""\n"
R"==(#endif)==""\n"
R"==(reduce_temp += REDUCE_STAT_NBLOCKS * PADDED_IC;)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(#else)==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP)==""\n"
R"==(+ mb * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(float8 res0 = 0.0f, res1 = 0.0f;)==""\n"
R"==(float v_var = 0.0f;)==""\n"
R"==(float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c);)==""\n"
R"==(#if HAS_STAT_SP_TAIL)==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) {)==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK;)==""\n"
R"==(while (sp >= 16) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8);)==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8);)==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(s0[k + 1] = t0[k];)==""\n"
R"==(s1[k + 1] = t1[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp = sp == 16;)==""\n"
R"==(if (is_last_sp && is_last_ic_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0);)==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8);)==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(#endif)==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif)==""\n"
R"==(float8 v0 = s0 - v_mean;)==""\n"
R"==(float8 v1 = s1 - v_mean;)==""\n"
R"==(res0 = fma(v0, v0, res0);)==""\n"
R"==(res1 = fma(v1, v1, res1);)==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(sp -= 16;)==""\n"
R"==(})==""\n"
R"==(while (sp >= 1) {)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(float s0;)==""\n"
R"==(if (sp == 1 && is_last_ic_block))==""\n"
R"==(s0 = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f;)==""\n"
R"==(else)==""\n"
R"==(s0 = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#else)==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]);)==""\n"
R"==(#endif)==""\n"
R"==(float v0 = s0 - v_mean;)==""\n"
R"==(v_var = fma(v0, v0, v_var);)==""\n"
R"==(src += IC_BLOCK_STRIDE;)==""\n"
R"==(--sp;)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==({)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) {)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(float8 s0, s1;)==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8);)==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8);)==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2) {)==""\n"
R"==(s0[k + 1] = t0[k];)==""\n"
R"==(s1[k + 1] = t1[k];)==""\n"
R"==(})==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(const bool is_last_sp = sp == STAT_SP_BLOCK / 16 - 1;)==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0);)==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8);)==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0);)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]);)==""\n"
R"==(#endif )==""\n"
R"==(float8 v0 = s0 - v_mean;)==""\n"
R"==(float8 v1 = s1 - v_mean;)==""\n"
R"==(res0 = fma(v0, v0, res0);)==""\n"
R"==(res1 = fma(v1, v1, res1);)==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(for (int i = 0; i < 8; i++) {)==""\n"
R"==(v_var += res0[i] + res1[i];)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE];)==""\n"
R"==(gen9_calc_fused_reduction(variance, c, &v_var, local_sum);)==""\n"
R"==(#else)==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], v_var);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(inline float8 read_src_block(__global DATA_T *src, int c, int sp) {)==""\n"
R"==(float8 blockS0 = 0.0f;)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(const bool is_last_sp_block = sp >= SP - VECT_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_SP_TAIL)==""\n"
R"==(if (sp == SP_TAIL) {)==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k))==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (k == SP - SP_TAIL - 1 && is_last_ic_block))==""\n"
R"==(blockS0[k] = simd_id < 8)==""\n"
R"==(? CONVERT_FLOAT_T(src[k * IC_BLOCK_STRIDE + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(else)==""\n"
R"==(#endif)==""\n"
R"==(blockS0[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]);)==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==({)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(#if IS_IC_EQ_8)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, blockS0, src, 0);)==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(blockS0, blockS0, 8);)==""\n"
R"==(for (int k = 0; k < 7; k += 2))==""\n"
R"==(blockS0[k + 1] = t0[k];)==""\n"
R"==(#elif HAS_IC_TAIL)==""\n"
R"==(if (is_last_ic_block && is_last_sp_block) {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, blockS0, src, 0);)==""\n"
R"==(blockS0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]))==""\n"
R"==(: 0.0f;)==""\n"
R"==(} else {)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, blockS0, src, 0);)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, blockS0, src, 0);)==""\n"
R"==(#endif )==""\n"
R"==(#else)==""\n"
R"==(blockS0 = LOAD_DATA_8x16(&src[0]);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(return blockS0;)==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_bnorm_fwd(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *dst,)==""\n"
R"==(__global float *scaleshift, __global float *shift, __global char *ws,)==""\n"
R"==(float eps, __global DATA_T *src_add, float relu_alpha) {)==""\n"
R"==(const int n = GWS_GET_MB();)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int sp = GWS_GET_SP() * VECT_SIZE;)==""\n"
R"==(const int simd_id = get_sub_group_local_id();)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC;)==""\n"
R"==(const bool is_last_sp_block = sp >= SP - VECT_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(const uint d_off = sp * IC + c;)==""\n"
R"==(#else)==""\n"
R"==(const uint d_off = (c & 15) + sp * 16 + (c & ~15) * SP + n * SP * IC;)==""\n"
R"==(#endif)==""\n"
R"==(src += d_off;)==""\n"
R"==(dst += d_off;)==""\n"
R"==(float8 blockS0 = read_src_block(src, c, sp);)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(src_add += d_off;)==""\n"
R"==(float8 block_S0_Add = read_src_block(src_add, c, sp);)==""\n"
R"==(#endif)==""\n"
R"==(float8 blockD0;)==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(float sm = MAYBE_LAST_IC_LOAD_FLOAT_1x16(scaleshift, c);)==""\n"
R"==(#else)==""\n"
R"==(float sm = 1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_SHIFT == 1)==""\n"
R"==(float sv = MAYBE_LAST_IC_LOAD_FLOAT_1x16(shift, c);)==""\n"
R"==(#else)==""\n"
R"==(float sv = 0.0f;)==""\n"
R"==(#endif)==""\n"
R"==(float v_mean, v_variance;)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (is_last_ic_block) {)==""\n"
R"==(v_mean = simd_id < 8 ? mean[c + simd_id] : 0.0f;)==""\n"
R"==(v_variance = simd_id < 8 ? variance[c + simd_id] : 0.0f;)==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(v_mean = LOAD_FLOAT_1x16(&mean[c]);)==""\n"
R"==(v_variance = LOAD_FLOAT_1x16(&variance[c]);)==""\n"
R"==(})==""\n"
R"==(float sqrt_variance = sm / sqrt(v_variance + eps);)==""\n"
R"==(blockD0 = fma(blockS0 - (float8)v_mean, (float8)sqrt_variance, (float8)sv);)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(blockD0 += block_S0_Add;)==""\n"
R"==(#endif)==""\n"
R"==(int8 blockWS0 = isgreater(blockD0, (float8)0.0f);)==""\n"
R"==(blockD0 = select((float8)0.0f, blockD0, blockWS0);)==""\n"
R"==(#if IS_TRAINING)==""\n"
R"==(ws += d_off;)==""\n"
R"==(#if HAS_SP_TAIL)==""\n"
R"==(if (sp == SP_TAIL) {)==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k) {)==""\n"
R"==(STORE_CHAR_1x16()==""\n"
R"==(&ws[k * IC_BLOCK_STRIDE], convert_char(blockWS0[k]));)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==({)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(STORE_CHAR_1x16()==""\n"
R"==(&ws[k * IC_BLOCK_STRIDE], convert_char(blockWS0[k]));)==""\n"
R"==(#else)==""\n"
R"==(STORE_CHAR_8x16(&ws[0], convert_char8(blockWS0));)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_RELU)==""\n"
R"==(#if WITH_LEAKY_RELU)==""\n"
R"==(int8 blockWS0_2 = isless(blockD0, (float8)0.0f);)==""\n"
R"==(blockD0 = select(blockD0, blockD0 * (float8)relu_alpha, blockWS0_2);)==""\n"
R"==(#else)==""\n"
R"==(blockD0 = max(blockD0, (VECT_FLOAT_T)0.0f);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_SP_TAIL)==""\n"
R"==(if (sp == SP_TAIL) {)==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k) {)==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (is_last_ic_block) {)==""\n"
R"==(if (simd_id < 8))==""\n"
R"==(dst[k * IC_BLOCK_STRIDE + simd_id])==""\n"
R"==(= CONVERT_DATA_T(blockD0[k]);)==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==(STORE_DATA_1x16(&dst[k * IC_BLOCK_STRIDE], blockD0[k]);)==""\n"
R"==(})==""\n"
R"==(} else)==""\n"
R"==(#endif )==""\n"
R"==({)==""\n"
R"==(#if USE_NHWC)==""\n"
R"==(for (int k = 0; k < 8; ++k))==""\n"
R"==(#if HAS_IC_TAIL)==""\n"
R"==(if (is_last_ic_block) {)==""\n"
R"==(if (simd_id < 8))==""\n"
R"==(dst[k * IC_BLOCK_STRIDE + simd_id])==""\n"
R"==(= CONVERT_DATA_T(blockD0[k]);)==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==(STORE_DATA_1x16(&dst[k * IC_BLOCK_STRIDE], blockD0[k]);)==""\n"
R"==(#else)==""\n"
R"==(STORE_DATA_8x16(&dst[0], blockD0);)==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}