namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *gen9_bnorm_nhwc_bwd_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm.h")==""\n"
R"==(#include "gpu/intel/ocl/bnorm/gen9_bnorm_reduce.h")==""\n"
R"==(NAMED_KERNEL_ATTR(CALC))==""\n"
R"==(__kernel void gen9_calculate_stats_nhwc(__global DATA_T *src,)==""\n"
R"==(__global float *mean, __global DATA_T *diff_dst, __global char *ws,)==""\n"
R"==(__global float *temp_reduce, volatile __global atomic_float *diff_scale,)==""\n"
R"==(volatile __global atomic_float *diff_shift) {)==""\n"
R"==(const int mb = GWS_GET_STAT_MB();)==""\n"
R"==(const int c = GWS_GET_STAT_IC();)==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP();)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(const int offset = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC;)==""\n"
R"==(mean += ic_block_offset;)==""\n"
R"==(src += offset;)==""\n"
R"==(diff_dst += offset;)==""\n"
R"==(ws += offset;)==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS];)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(v_mean[sg] = as_float(intel_sub_group_block_read()==""\n"
R"==((const __global uint *)(&mean[(sg * SG_SIZE)])));)==""\n"
R"==(})==""\n"
R"==(VECT_FLOAT_T diff_gamma[IC_BLOCK_SGROUPS / VECT_SIZE] = {0.0f};)==""\n"
R"==(VECT_FLOAT_T diff_beta[IC_BLOCK_SGROUPS / VECT_SIZE] = {0.0f};)==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(float diff_gamma_tail[IC_TAIL_SGROUPS] = {0.0f};)==""\n"
R"==(float diff_beta_tail[IC_TAIL_SGROUPS] = {0.0f};)==""\n"
R"==(#else)==""\n"
R"==(float *diff_gamma_tail = NULL;)==""\n"
R"==(float *diff_beta_tail = NULL;)==""\n"
R"==(#endif)==""\n"
R"==(#if USE_WORKAROUND)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) {)==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break;)==""\n"
R"==(#else )==""\n"
R"==(#if HAS_STAT_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp = 0; sp < min(STAT_SP_BLOCK, SP - sp_block_idx * STAT_SP_BLOCK);)==""\n"
R"==(++sp) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) {)==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(const int sg_idx = sg * SG_SIZE * VECT_SIZE;)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(VECT_CHAR_T ws_vect = LOAD_VECT_CHAR(&ws[sg_idx]);)==""\n"
R"==(#endif)==""\n"
R"==(VECT_FLOAT_T src_vect = LOAD_VECT_DATA(&src[sg_idx]);)==""\n"
R"==(VECT_FLOAT_T dd_vect = LOAD_VECT_DATA(&diff_dst[sg_idx]);)==""\n"
R"==(VECT_FLOAT_T v0;)==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) {)==""\n"
R"==(int sg_idx = sg * VECT_SIZE + vect;)==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(v0[vect] = src_vect[vect] - v_mean[sg_idx];)==""\n"
R"==(#else)==""\n"
R"==(v0 = src_vect - v_mean[sg_idx];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(dd_vect = select()==""\n"
R"==((VECT_FLOAT_T)0.0f, dd_vect, CONVERT_VECT_INT_T(ws_vect));)==""\n"
R"==(#endif)==""\n"
R"==(diff_gamma[sg] = fma(v0, dd_vect, diff_gamma[sg]);)==""\n"
R"==(diff_beta[sg] += dd_vect;)==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg;)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(char ws_tail = LOAD_CHAR_1x16(&ws[sg_idx * SG_SIZE]);)==""\n"
R"==(#endif)==""\n"
R"==(float src_tail = LOAD_DATA_1x16(&src[sg_idx * SG_SIZE]);)==""\n"
R"==(float dd_tail = LOAD_DATA_1x16(&diff_dst[sg_idx * SG_SIZE]);)==""\n"
R"==(float v0 = src_tail - v_mean[sg_idx];)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(dd_tail = select(0.0f, dd_tail, convert_int(ws_tail));)==""\n"
R"==(#endif)==""\n"
R"==(diff_gamma_tail[sg] = fma(v0, dd_tail, diff_gamma_tail[sg]);)==""\n"
R"==(diff_beta_tail[sg] += dd_tail;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(src += IC;)==""\n"
R"==(diff_dst += IC;)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(ws += IC;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION)==""\n"
R"==(__local float local_gamma[2 * CALC_SLM_SIZE];)==""\n"
R"==(__local float *local_beta = local_gamma + CALC_SLM_SIZE;)==""\n"
R"==(gen9_calc_fused_reduction(diff_scale, diff_shift, ic_block_offset,)==""\n"
R"==(diff_gamma, diff_beta, diff_gamma_tail, diff_beta_tail, local_gamma,)==""\n"
R"==(local_beta);)==""\n"
R"==(#else)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) {)==""\n"
R"==(const int reduce_off = sp_block_idx * SG_SIZE)==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * SG_SIZE)==""\n"
R"==(* (sg + (int)(c / SG_SIZE) * (IC_BLOCK / SG_SIZE));)==""\n"
R"==(const int diff_gamma_offset = PADDED_IC + reduce_off;)==""\n"
R"==(const int diff_beta_offset)==""\n"
R"==(= 2 * PADDED_IC + REDUCE_STAT_NBLOCKS * PADDED_IC + reduce_off;)==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(if (sg >= IC_VECT_SGROUPS) {)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset],)==""\n"
R"==(diff_gamma_tail[sg - IC_VECT_SGROUPS]);)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset],)==""\n"
R"==(diff_beta_tail[sg - IC_VECT_SGROUPS]);)==""\n"
R"==(} else)==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(#if VECT_SIZE > 1)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset],)==""\n"
R"==(diff_gamma[sg / VECT_SIZE][sg % VECT_SIZE]);)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset],)==""\n"
R"==(diff_beta[sg / VECT_SIZE][sg % VECT_SIZE]);)==""\n"
R"==(#else)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset], diff_gamma[sg]);)==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset], diff_beta[sg]);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void gen9_bnorm_bwd_nhwc(__global DATA_T *src, __global float *mean,)==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst,)==""\n"
R"==(__global float *scaleshift, __global char *ws,)==""\n"
R"==(__global DATA_T *diff_src, __global float *diff_scale,)==""\n"
R"==(__global float *diff_shift, float eps, __global DATA_T *diff_src_add) {)==""\n"
R"==(const int c = GWS_GET_IC();)==""\n"
R"==(const int ic_block_offset = (c / SG_SIZE) * IC_BLOCK;)==""\n"
R"==(variance += ic_block_offset;)==""\n"
R"==(mean += ic_block_offset;)==""\n"
R"==(diff_scale += ic_block_offset;)==""\n"
R"==(diff_shift += ic_block_offset;)==""\n"
R"==(scaleshift += ic_block_offset;)==""\n"
R"==(VECT_FLOAT_T v_variance[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(v_mean[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(diff_gamma[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(diff_beta[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(sqrt_variance[IC_BLOCK_SGROUPS / VECT_SIZE],)==""\n"
R"==(gamma[IC_BLOCK_SGROUPS / VECT_SIZE];)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(const int sg_idx = sg * SG_SIZE * VECT_SIZE;)==""\n"
R"==(v_variance[sg] = LOAD_VECT_FLOAT(&variance[sg_idx]);)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(v_mean[sg] = LOAD_VECT_FLOAT(&mean[sg_idx]);)==""\n"
R"==(diff_gamma[sg] = LOAD_VECT_FLOAT(&diff_scale[sg_idx]);)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(diff_beta[sg] = LOAD_VECT_FLOAT(&diff_shift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(diff_beta[sg] = LOAD_VECT_FLOAT()==""\n"
R"==(&diff_shift[IC + REDUCE_STAT_NBLOCKS * IC + sg_idx]);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(gamma[sg] = LOAD_VECT_FLOAT(&scaleshift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(gamma[sg] = (VECT_FLOAT_T)1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(sqrt_variance[sg])==""\n"
R"==(= (VECT_FLOAT_T)1.0f / sqrt(v_variance[sg] + (VECT_FLOAT_T)eps);)==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(float v_variance_tail[IC_TAIL_SGROUPS], v_mean_tail[IC_TAIL_SGROUPS],)==""\n"
R"==(diff_gamma_tail[IC_TAIL_SGROUPS], diff_beta_tail[IC_TAIL_SGROUPS],)==""\n"
R"==(sqrt_variance_tail[IC_TAIL_SGROUPS], gamma_tail[IC_TAIL_SGROUPS];)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * SG_SIZE;)==""\n"
R"==(v_variance_tail[sg] = LOAD_FLOAT_1x16(&variance[sg_idx]);)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(v_mean_tail[sg] = LOAD_FLOAT_1x16(&mean[sg_idx]);)==""\n"
R"==(diff_gamma_tail[sg] = LOAD_FLOAT_1x16(&diff_scale[sg_idx]);)==""\n"
R"==(#if DIFF_SHIFT == 1)==""\n"
R"==(diff_beta_tail[sg] = LOAD_FLOAT_1x16(&diff_shift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(diff_beta_tail[sg] = LOAD_FLOAT_1x16()==""\n"
R"==(&diff_shift[IC + REDUCE_STAT_NBLOCKS * IC + sg_idx]);)==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SCALE == 1)==""\n"
R"==(gamma_tail[sg] = LOAD_FLOAT_1x16(&scaleshift[sg_idx]);)==""\n"
R"==(#else)==""\n"
R"==(gamma_tail[sg] = 1.0f;)==""\n"
R"==(#endif)==""\n"
R"==(sqrt_variance_tail[sg] = 1.0f / sqrt(v_variance_tail[sg] + eps);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(const int sp_block_idx = GWS_GET_SP();)==""\n"
R"==(const int offset = ic_block_offset + sp_block_idx * UPDATE_SP_BLOCK * IC;)==""\n"
R"==(src += offset;)==""\n"
R"==(diff_dst += offset;)==""\n"
R"==(ws += offset;)==""\n"
R"==(diff_src += offset;)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(diff_src_add += offset;)==""\n"
R"==(#endif)==""\n"
R"==(#if HAS_UPDATE_SP_BLOCK_TAIL)==""\n"
R"==(for (int sp = 0;)==""\n"
R"==(sp < min(UPDATE_SP_BLOCK, SP - sp_block_idx * UPDATE_SP_BLOCK);)==""\n"
R"==(sp += UPDATE_SP_UNROLL) {)==""\n"
R"==(#else)==""\n"
R"==(for (int sp = 0; sp < UPDATE_SP_BLOCK; sp += UPDATE_SP_UNROLL) {)==""\n"
R"==(#endif)==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) {)==""\n"
R"==(const int sg_idx = sg * SG_SIZE * VECT_SIZE;)==""\n"
R"==(VECT_FLOAT_T src_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(src_vect[i] = LOAD_VECT_DATA(&src[sg_idx + IC * i]);)==""\n"
R"==(})==""\n"
R"==(VECT_FLOAT_T dd_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_vect[i] = LOAD_VECT_DATA(&diff_dst[sg_idx + IC * i]);)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(VECT_CHAR_T ws_vect[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(ws_vect[i] = LOAD_VECT_CHAR(&ws[sg_idx + IC * i]);)==""\n"
R"==(dd_vect[i] = select((VECT_FLOAT_T)0.0f, dd_vect[i],)==""\n"
R"==(CONVERT_VECT_INT_T(ws_vect[i]));)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(STORE_VECT_DATA(&diff_src_add[sg_idx + IC * i], dd_vect[i]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_vect[i])==""\n"
R"==(-= (diff_beta[sg])==""\n"
R"==(+ (src_vect[i] - v_mean[sg]) * diff_gamma[sg])==""\n"
R"==(* sqrt_variance[sg]))==""\n"
R"==(/ (MB * ID * IH * IW);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_vect[i] *= gamma[sg] * sqrt_variance[sg];)==""\n"
R"==(})==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(STORE_VECT_DATA(&diff_src[sg_idx + IC * i], dd_vect[i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if HAS_IC_VECT_TAIL)==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) {)==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * SG_SIZE;)==""\n"
R"==(float src_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(src_tail[i] = LOAD_DATA_1x16(&src[sg_idx + IC * i]);)==""\n"
R"==(})==""\n"
R"==(float dd_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_tail[i] = LOAD_DATA_1x16(&diff_dst[sg_idx + IC * i]);)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(char ws_tail[UPDATE_SP_UNROLL];)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(ws_tail[i] = LOAD_CHAR_1x16(&ws[sg_idx + IC * i]);)==""\n"
R"==(dd_tail[i] = select(0.0f, dd_tail[i], convert_int(ws_tail[i]));)==""\n"
R"==(})==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(STORE_DATA_1x16(&diff_src_add[sg_idx + IC * i], dd_tail[i]);)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1)==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_tail[i] -= (diff_beta_tail[sg])==""\n"
R"==(+ (src_tail[i] - v_mean_tail[sg]))==""\n"
R"==(* diff_gamma_tail[sg])==""\n"
R"==(* sqrt_variance_tail[sg]))==""\n"
R"==(/ (MB * ID * IH * IW);)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < UPDATE_SP_UNROLL; i++) {)==""\n"
R"==(dd_tail[i] *= gamma_tail[sg] * sqrt_variance_tail[sg];)==""\n"
R"==(STORE_DATA_1x16(&diff_src[sg_idx + IC * i], dd_tail[i]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(src += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(diff_dst += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(diff_src += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#if FUSE_BN_RELU)==""\n"
R"==(#if FUSE_BN_ADD_RELU)==""\n"
R"==(diff_src_add += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#endif)==""\n"
R"==(ws += IC * UPDATE_SP_UNROLL;)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}