namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *generic_reorder_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2021-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define USE_CUSTOM_GWS_GET_ID)==""\n"
R"==(#undef cl_future_bf16_cvt)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/reorder_common.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(#define GWS_GET_THREAD_ID(index) (get_global_id(index) + offset.array[index]))==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void generic_reorder(__global SRC_DATA_T *restrict src,)==""\n"
R"==(__global DST_DATA_T *restrict dst, __global float *restrict src_scales,)==""\n"
R"==(__global int *restrict src_zps, __global float *restrict dst_scales,)==""\n"
R"==(__global int *restrict dst_zps, float sum_scale, int sum_zp,)==""\n"
R"==(int64x3_t offset) {)==""\n"
R"==(const int src_zp = GET_SRC_ZP(src_zps);)==""\n"
R"==(const int dst_zp = GET_DST_ZP(dst_zps);)==""\n"
R"==(float src_scale = 1.0f;)==""\n"
R"==(float dst_scale = 1.0f;)==""\n"
R"==(src += SRC_OFFSET0;)==""\n"
R"==(dst += DST_OFFSET0;)==""\n"
R"==(#define LOOP_NEST_LEVEL 4)==""\n"
R"==(const uint sgId = get_sub_group_local_id();)==""\n"
R"==(off_t d[6]; )==""\n"
R"==(off_t b[6])==""\n"
R"==(= {0, 0, 0, 0, 0, 0}; )==""\n"
R"==(d[0] = GWS_GET_D0();)==""\n"
R"==(d[1] = GWS_GET_D1();)==""\n"
R"==(d[2] = GWS_GET_D2();)==""\n"
R"==(d[3] = GWS_GET_D3();)==""\n"
R"==(d[4] = GWS_GET_D4();)==""\n"
R"==(d[5] = GWS_GET_D5();)==""\n"
R"==(d[VECT_DIM] /= RESCALE_COEFF;)==""\n"
R"==(const uint cache_size_per_sg = D_BLK_SIZE_0 * D_BLK_SIZE_1 * D_BLK_SIZE_2)==""\n"
R"==(* D_BLK_SIZE_3 * VECT_SIZE;)==""\n"
R"==(const uint sg_off = get_sub_group_id() * cache_size_per_sg;)==""\n"
R"==(__local SRC_DATA_T cache[SG_PER_WG * cache_size_per_sg];)==""\n"
R"==(uint iter[LOOP_NEST_LEVEL] = {0, 0, 0, 0};)==""\n"
R"==(#if S_BLK_SIZE_3 > 1)==""\n"
R"==(for_(iter[3] = 0; iter[3] < S_BLK_SIZE_3; iter[3]++))==""\n"
R"==(#endif)==""\n"
R"==(#if S_BLK_SIZE_2 > 1)==""\n"
R"==(for_(iter[2] = 0; iter[2] < S_BLK_SIZE_2; iter[2]++))==""\n"
R"==(#endif)==""\n"
R"==(#if S_BLK_SIZE_1 > 1)==""\n"
R"==(for_(iter[1] = 0; iter[1] < S_BLK_SIZE_1; iter[1]++))==""\n"
R"==(#endif)==""\n"
R"==(#if S_BLK_SIZE_0 > 1)==""\n"
R"==(for_(iter[0] = 0; iter[0] < S_BLK_SIZE_0; iter[0]++))==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(b[0] = 0;)==""\n"
R"==(b[1] = 0;)==""\n"
R"==(b[2] = 0;)==""\n"
R"==(b[3] = 0;)==""\n"
R"==(b[4] = 0;)==""\n"
R"==(b[5] = 0;)==""\n"
R"==(b[S_BLK_IDX_0] += iter[0] * S_BLK_STEP_0;)==""\n"
R"==(b[S_BLK_IDX_1] += iter[1] * S_BLK_STEP_1;)==""\n"
R"==(b[S_BLK_IDX_2] += iter[2] * S_BLK_STEP_2;)==""\n"
R"==(b[S_BLK_IDX_3] += iter[3] * S_BLK_STEP_3;)==""\n"
R"==(#if S_MOD_3 > 1)==""\n"
R"==(b[S_IDX_3] += S_MUL_3 * ((sgId / S_DIV_3) % S_MOD_3);)==""\n"
R"==(#endif)==""\n"
R"==(#if S_MOD_2 > 1)==""\n"
R"==(b[S_IDX_2] += S_MUL_2 * ((sgId / S_DIV_2) % S_MOD_2);)==""\n"
R"==(#endif)==""\n"
R"==(#if S_MOD_1 > 1)==""\n"
R"==(b[S_IDX_1] += S_MUL_1 * ((sgId / S_DIV_1) % S_MOD_1);)==""\n"
R"==(#endif)==""\n"
R"==(#if S_MOD_0 > 1)==""\n"
R"==(b[S_IDX_0] += S_MUL_0 * ((sgId / S_DIV_0) % S_MOD_0);)==""\n"
R"==(#endif)==""\n"
R"==(const off_t src_off = SRC_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(uint cache_idx = sg_off + b[5] * CACHE_STRIDE_5 + b[4] * CACHE_STRIDE_4)==""\n"
R"==(+ b[3] * CACHE_STRIDE_3 + b[2] * CACHE_STRIDE_2)==""\n"
R"==(+ b[1] * CACHE_STRIDE_1 + b[0] * CACHE_STRIDE_0;)==""\n"
R"==(const int pad_d0 = d[0] + b[0] >= SRC_D0;)==""\n"
R"==(const int pad_d1 = NDIMS > 1 && d[1] + b[1] >= SRC_D1;)==""\n"
R"==(const int pad_d2 = NDIMS > 2 && d[2] + b[2] >= SRC_D2;)==""\n"
R"==(const int pad_d3 = NDIMS > 3 && d[3] + b[3] >= SRC_D3;)==""\n"
R"==(const int pad_d4 = NDIMS > 4 && d[4] + b[4] >= SRC_D4;)==""\n"
R"==(const int pad_d5 = NDIMS > 5 && d[5] + b[5] >= SRC_D5;)==""\n"
R"==(const bool pad_sgid = sgId >= LIMIT_SSGID;)==""\n"
R"==(const int pad)==""\n"
R"==(= pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5;)==""\n"
R"==(if (!pad_sgid) {)==""\n"
R"==(SRC_DATA_T src_tmp = pad ? 0 : src[src_off];)==""\n"
R"==(cache[cache_idx] = src_tmp;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(for (uint i = 0; i < LOOP_NEST_LEVEL; i++) {)==""\n"
R"==(iter[i] = 0;)==""\n"
R"==(})==""\n"
R"==(#if D_BLK_SIZE_3 > 1)==""\n"
R"==(for_(iter[3] = 0; iter[3] < D_BLK_SIZE_3; iter[3]++))==""\n"
R"==(#endif)==""\n"
R"==(#if D_BLK_SIZE_2 > 1)==""\n"
R"==(for_(iter[2] = 0; iter[2] < D_BLK_SIZE_2; iter[2]++))==""\n"
R"==(#endif)==""\n"
R"==(#if D_BLK_SIZE_1 > 1)==""\n"
R"==(for_(iter[1] = 0; iter[1] < D_BLK_SIZE_1; iter[1]++))==""\n"
R"==(#endif)==""\n"
R"==(#if D_BLK_SIZE_0 > 1)==""\n"
R"==(for_(iter[0] = 0; iter[0] < D_BLK_SIZE_0; iter[0]++))==""\n"
R"==(#endif)==""\n"
R"==({)==""\n"
R"==(b[0] = 0;)==""\n"
R"==(b[1] = 0;)==""\n"
R"==(b[2] = 0;)==""\n"
R"==(b[3] = 0;)==""\n"
R"==(b[4] = 0;)==""\n"
R"==(b[5] = 0;)==""\n"
R"==(b[D_BLK_IDX_0] += iter[0] * D_BLK_STEP_0;)==""\n"
R"==(b[D_BLK_IDX_1] += iter[1] * D_BLK_STEP_1;)==""\n"
R"==(b[D_BLK_IDX_2] += iter[2] * D_BLK_STEP_2;)==""\n"
R"==(b[D_BLK_IDX_3] += iter[3] * D_BLK_STEP_3;)==""\n"
R"==(#if D_MOD_3 > 1)==""\n"
R"==(b[D_IDX_3] += D_MUL_3 * ((sgId / D_DIV_3) % D_MOD_3);)==""\n"
R"==(#endif)==""\n"
R"==(#if D_MOD_2 > 1)==""\n"
R"==(b[D_IDX_2] += D_MUL_2 * ((sgId / D_DIV_2) % D_MOD_2);)==""\n"
R"==(#endif)==""\n"
R"==(#if D_MOD_1 > 1)==""\n"
R"==(b[D_IDX_1] += D_MUL_1 * ((sgId / D_DIV_1) % D_MOD_1);)==""\n"
R"==(#endif)==""\n"
R"==(#if D_MOD_0 > 1)==""\n"
R"==(b[D_IDX_0] += D_MUL_0 * ((sgId / D_DIV_0) % D_MOD_0);)==""\n"
R"==(#endif)==""\n"
R"==(const off_t dst_off = DST_OFF(d[0] + b[0], d[1] + b[1], d[2] + b[2],)==""\n"
R"==(d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(DST_DATA_T dst_tmp;)==""\n"
R"==(uint cache_idx = sg_off + b[5] * CACHE_STRIDE_5 + b[4] * CACHE_STRIDE_4)==""\n"
R"==(+ b[3] * CACHE_STRIDE_3 + b[2] * CACHE_STRIDE_2)==""\n"
R"==(+ b[1] * CACHE_STRIDE_1 + b[0] * CACHE_STRIDE_0;)==""\n"
R"==(const int pad_d0 = d[0] + b[0] >= DST_PD0;)==""\n"
R"==(const int pad_d1 = NDIMS > 1 && d[1] + b[1] >= DST_PD1;)==""\n"
R"==(const int pad_d2 = NDIMS > 2 && d[2] + b[2] >= DST_PD2;)==""\n"
R"==(const int pad_d3 = NDIMS > 3 && d[3] + b[3] >= DST_PD3;)==""\n"
R"==(const int pad_d4 = NDIMS > 4 && d[4] + b[4] >= DST_PD4;)==""\n"
R"==(const int pad_d5 = NDIMS > 5 && d[5] + b[5] >= DST_PD5;)==""\n"
R"==(const bool pad_sgid = sgId >= LIMIT_DSGID;)==""\n"
R"==(const int pad = pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5)==""\n"
R"==(|| pad_sgid;)==""\n"
R"==(if (!pad) {)==""\n"
R"==(SRC_DATA_T from_cache = cache[cache_idx];)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(dst_tmp = dst[dst_off];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE)==""\n"
R"==(off_t src_scale_idx = SCALE_OFF(SRC, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(src_scale = src_scale_idx < SRC_NUM_SCALES)==""\n"
R"==(? src_scales[src_scale_idx])==""\n"
R"==(: 0.0;)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE)==""\n"
R"==(off_t dst_scale_idx = SCALE_OFF(DST, d[0] + b[0], d[1] + b[1],)==""\n"
R"==(d[2] + b[2], d[3] + b[3], d[4] + b[4], d[5] + b[5]);)==""\n"
R"==(dst_scale = dst_scale_idx < DST_NUM_SCALES)==""\n"
R"==(? dst_scales[dst_scale_idx])==""\n"
R"==(: 0.0;)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(DEFAULT_ROUND, dst_tmp, from_cache, src_scale, dst_scale,)==""\n"
R"==(sum_scale, src_zp, dst_zp, sum_zp);)==""\n"
R"==(dst[dst_off] = dst_tmp;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}