namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *many_inputs_sum_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2022-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define INIT_N_INPUTS(i) \)==""\n"
R"==(if (i < N_INPUTS) inputs[i] = input##i;)==""\n"
R"==(#define INIT_MAX_N_INPUTS(i) \)==""\n"
R"==(if (i < MAX_N_INPUTS) inputs[i] = input##i;)==""\n"
R"==(float get_value(__global SRC_DATA_T *src, ptrdiff_t offset) {)==""\n"
R"==(if (offset >= N_ELEMS) return 0;)==""\n"
R"==(return CONVERT_FLOAT_T(src[offset]);)==""\n"
R"==(})==""\n"
R"==(#define many_inputs_sum_impl(inputs, output, scales, num_inputs, local_val) \)==""\n"
R"==(const uint group_id = get_group_id(0); \)==""\n"
R"==(const uint group_size = get_local_size(0); \)==""\n"
R"==(const uint gid = get_global_id(0); \)==""\n"
R"==(ptrdiff_t offset = gid / num_inputs; \)==""\n"
R"==(const int tensor_idx = gid % num_inputs; \)==""\n"
R"==(const int local_id = get_local_id(0); \)==""\n"
R"==(local_val[local_id] \)==""\n"
R"==(= get_value(inputs[tensor_idx], offset) * scales[tensor_idx]; \)==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); \)==""\n"
R"==(if (tensor_idx == 0 && offset < N_ELEMS) { \)==""\n"
R"==(float final_val = 0; \)==""\n"
R"==(for (int i = 0; i < num_inputs; i++) { \)==""\n"
R"==(final_val += local_val[local_id + i]; \)==""\n"
R"==(} \)==""\n"
R"==(output[offset] = TO_DST(final_val + CONVERT_FLOAT_T(output[offset])); \)==""\n"
R"==(})==""\n"
R"==(__kernel void many_inputs_sum(__global SRC_DATA_T *input0,)==""\n"
R"==(__global SRC_DATA_T *input1, __global SRC_DATA_T *input2,)==""\n"
R"==(__global SRC_DATA_T *input3, __global SRC_DATA_T *input4,)==""\n"
R"==(__global SRC_DATA_T *input5, __global SRC_DATA_T *input6,)==""\n"
R"==(__global SRC_DATA_T *input7, __global SRC_DATA_T *input8,)==""\n"
R"==(__global SRC_DATA_T *input9, __global SRC_DATA_T *input10,)==""\n"
R"==(__global SRC_DATA_T *input11, __global SRC_DATA_T *input12,)==""\n"
R"==(__global SRC_DATA_T *input13, __global SRC_DATA_T *input14,)==""\n"
R"==(__global SRC_DATA_T *input15, __global DST_DATA_T *output,)==""\n"
R"==(__global float *scales) {)==""\n"
R"==(__local float local_val[256];)==""\n"
R"==(__global SRC_DATA_T *inputs[16];)==""\n"
R"==(INIT_N_INPUTS(0);)==""\n"
R"==(INIT_N_INPUTS(1);)==""\n"
R"==(INIT_N_INPUTS(2);)==""\n"
R"==(INIT_N_INPUTS(3);)==""\n"
R"==(INIT_N_INPUTS(4);)==""\n"
R"==(INIT_N_INPUTS(5);)==""\n"
R"==(INIT_N_INPUTS(6);)==""\n"
R"==(INIT_N_INPUTS(7);)==""\n"
R"==(INIT_N_INPUTS(8);)==""\n"
R"==(INIT_N_INPUTS(9);)==""\n"
R"==(INIT_N_INPUTS(10);)==""\n"
R"==(INIT_N_INPUTS(11);)==""\n"
R"==(INIT_N_INPUTS(12);)==""\n"
R"==(INIT_N_INPUTS(13);)==""\n"
R"==(INIT_N_INPUTS(14);)==""\n"
R"==(INIT_N_INPUTS(15);)==""\n"
R"==(many_inputs_sum_impl(inputs, output, scales, N_INPUTS, local_val);)==""\n"
R"==(})==""\n"
R"==(__kernel void many_inputs_sum_batched(__global SRC_DATA_T *input0,)==""\n"
R"==(__global SRC_DATA_T *input1, __global SRC_DATA_T *input2,)==""\n"
R"==(__global SRC_DATA_T *input3, __global SRC_DATA_T *input4,)==""\n"
R"==(__global SRC_DATA_T *input5, __global SRC_DATA_T *input6,)==""\n"
R"==(__global SRC_DATA_T *input7, __global SRC_DATA_T *input8,)==""\n"
R"==(__global SRC_DATA_T *input9, __global SRC_DATA_T *input10,)==""\n"
R"==(__global SRC_DATA_T *input11, __global SRC_DATA_T *input12,)==""\n"
R"==(__global SRC_DATA_T *input13, __global SRC_DATA_T *input14,)==""\n"
R"==(__global SRC_DATA_T *input15, __global DST_DATA_T *output,)==""\n"
R"==(__global float *scales) {)==""\n"
R"==(__local float local_val[256];)==""\n"
R"==(__global SRC_DATA_T *inputs[16];)==""\n"
R"==(INIT_MAX_N_INPUTS(0);)==""\n"
R"==(INIT_MAX_N_INPUTS(1);)==""\n"
R"==(INIT_MAX_N_INPUTS(2);)==""\n"
R"==(INIT_MAX_N_INPUTS(3);)==""\n"
R"==(INIT_MAX_N_INPUTS(4);)==""\n"
R"==(INIT_MAX_N_INPUTS(5);)==""\n"
R"==(INIT_MAX_N_INPUTS(6);)==""\n"
R"==(INIT_MAX_N_INPUTS(7);)==""\n"
R"==(INIT_MAX_N_INPUTS(8);)==""\n"
R"==(INIT_MAX_N_INPUTS(9);)==""\n"
R"==(INIT_MAX_N_INPUTS(10);)==""\n"
R"==(INIT_MAX_N_INPUTS(11);)==""\n"
R"==(INIT_MAX_N_INPUTS(12);)==""\n"
R"==(INIT_MAX_N_INPUTS(13);)==""\n"
R"==(INIT_MAX_N_INPUTS(14);)==""\n"
R"==(INIT_MAX_N_INPUTS(15);)==""\n"
R"==(many_inputs_sum_impl(inputs, output, scales, MAX_N_INPUTS, local_val);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}