namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *nhwc_reusable_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_BNORM_NHWC_REUSABLE_H)==""\n"
R"==(#define GPU_INTEL_OCL_BNORM_NHWC_REUSABLE_H)==""\n"
R"==(#define MAX_IC_BLOCK_SGROUPS (MAX_IC_BLOCK / SUB_GROUP_SIZE))==""\n"
R"==(#define MAX_IC_TAIL_SGROUPS (VECT_SIZE - 1))==""\n"
R"==(#define MAY_HAVE_IC_TAIL (MAX_IC_TAIL_SGROUPS > 0))==""\n"
R"==(#define VECT_DT_N VECT_SIZE)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#define LOAD_FLOAT_1x16(ptr) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(ptr))))==""\n"
R"==(#define LOAD_UINT_1x16(ptr) \)==""\n"
R"==(as_uint(intel_sub_group_block_read((const __global uint *)(ptr))))==""\n"
R"==(#define LOAD_UINT_8x16(ptr) \)==""\n"
R"==(convert_uint8(as_uint8( \)==""\n"
R"==(intel_sub_group_block_read8((const __global uint *)(ptr)))))==""\n"
R"==(#define LOAD_CHAR_1x16(ptr) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(ptr))))==""\n"
R"==(#define LOAD_CHAR_8x16(ptr) \)==""\n"
R"==(convert_char8(as_char8( \)==""\n"
R"==(intel_sub_group_block_read_uc8((const __global uchar *)(ptr)))))==""\n"
R"==(#define LOAD_DATA_1x16(ptr) \)==""\n"
R"==(CONVERT_FLOAT_T(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_DATA_8x16(ptr) \)==""\n"
R"==(CONVERT_FLOAT8_T( \)==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_DATA(ptr) \)==""\n"
R"==(CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( \)==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_CHAR(ptr) \)==""\n"
R"==(CONVERT_VECT_CHAR_T( \)==""\n"
R"==(AS_VECT_CHAR_T(VECT_UCHAR_READ((const __global uchar *)(ptr)))))==""\n"
R"==(#define LOAD_VECT_FLOAT(ptr) \)==""\n"
R"==(AS_VECT_FLOAT_T(VECT_UINT_READ((const __global uint *)(ptr))))==""\n"
R"==(#define STORE_DATA_1x16(ptr, val) \)==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \)==""\n"
R"==(AS_BLOCK_DATA_T(CONVERT_DATA_T(val))))==""\n"
R"==(#define STORE_DATA_8x16(ptr, val) \)==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)ptr, \)==""\n"
R"==(AS_BLOCK_DATA8_T(CONVERT_DATA8_T(val))))==""\n"
R"==(#define STORE_VECT_DATA(ptr, val) \)==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \)==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(val))))==""\n"
R"==(#define STORE_FLOAT_1x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(ptr), as_uint(val)))==""\n"
R"==(#define STORE_FLOAT_8x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(ptr), as_uint8(val)))==""\n"
R"==(#define STORE_CHAR_1x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(ptr), as_uchar(val)))==""\n"
R"==(#define STORE_CHAR_8x16(ptr, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(ptr), as_uchar8(val)))==""\n"
R"==(#define STORE_VECT_CHAR(ptr, val) \)==""\n"
R"==(VECT_UCHAR_WRITE((__global uchar *)(ptr), \)==""\n"
R"==(AS_VECT_UCHAR_T(CONVERT_VECT_CHAR_T(val))))==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define ISGREATER(x, y) ((x) > (y) ? -1 : 0))==""\n"
R"==(#else)==""\n"
R"==(#define ISGREATER(x, y) isgreater((x), (y)))==""\n"
R"==(#endif)==""\n"
R"==(#define ACCUM_DATA_T float)==""\n"
R"==(#define ACCUM_DATA8_T float8)==""\n"
R"==(#define ACCUM_DATA2_T float2)==""\n"
R"==(#define SUM_DATA_T ACCUM_DATA2_T)==""\n"
R"==(#define AS_VECT_FLOAT(a) *(VECT_FLOAT_T *)(a))==""\n"
R"==(SUM_DATA_T summation(ACCUM_DATA_T input, SUM_DATA_T state) {)==""\n"
R"==(ACCUM_DATA2_T ret;)==""\n"
R"==(ACCUM_DATA_T y = input - state.s1;)==""\n"
R"==(ACCUM_DATA_T t = state.s0 + y;)==""\n"
R"==(ret.s1 = (t - state.s0) - y;)==""\n"
R"==(ret.s0 = t;)==""\n"
R"==(return ret;)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}