namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_utils_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_UTILS_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_UTILS_H)==""\n"
R"==(#define CONCAt2(a, b) a##b)==""\n"
R"==(#define CONCAT2(a, b) CONCAt2(a, b))==""\n"
R"==(#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c))==""\n"
R"==(#ifdef cl_khr_fp64)==""\n"
R"==(#define IF_DOUBLE_SUPPORTED(x) x)==""\n"
R"==(#else)==""\n"
R"==(#define IF_DOUBLE_SUPPORTED(x))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef cl_khr_fp16)==""\n"
R"==(#define IF_HALF_SUPPORTED(x) x)==""\n"
R"==(#else)==""\n"
R"==(#define IF_HALF_SUPPORTED(x))==""\n"
R"==(#endif)==""\n"
R"==(#if __OPENCL_C_VERSION__ >= CL_VERSION_2_0)==""\n"
R"==(#define ATOMICS_SUPPORTED 1)==""\n"
R"==(#else)==""\n"
R"==(#define ATOMICS_SUPPORTED 0)==""\n"
R"==(#endif)==""\n"
R"==(#if defined(cl_ext_float_atomics) && ATOMICS_SUPPORTED)==""\n"
R"==(#define ATOMIC_FLOAT_SUPPORTED 1)==""\n"
R"==(#else)==""\n"
R"==(#define ATOMIC_FLOAT_SUPPORTED 0)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef OCL_DEBUG)==""\n"
R"==(#define DEBUG_PRINT(...) printf(__VA_ARGS__);)==""\n"
R"==(#else)==""\n"
R"==(#define DEBUG_PRINT(...))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef __has_builtin)==""\n"
R"==(#define HAS_BUILTIN(x) __has_builtin(x))==""\n"
R"==(#else)==""\n"
R"==(#define HAS_BUILTIN(x) false)==""\n"
R"==(#endif)==""\n"
R"==(#define DEF_special_vals(dt, zero_val, one_val, min_val, max_val) \)==""\n"
R"==(__constant dt CONCAT2(dt, _zero) = zero_val; \)==""\n"
R"==(__constant dt CONCAT2(dt, _one) = one_val; \)==""\n"
R"==(__constant dt CONCAT2(dt, _min) = min_val; \)==""\n"
R"==(__constant dt CONCAT2(dt, _max) = max_val;)==""\n"
R"==(DEF_special_vals(float, 0.0f, 1.0f, -FLT_MAX, FLT_MAX);)==""\n"
R"==(DEF_special_vals(int, 0, 1, INT_MIN, INT_MAX);)==""\n"
R"==(IF_DOUBLE_SUPPORTED(DEF_special_vals(double, 0.0, 1.0, -DBL_MAX, DBL_MAX));)==""\n"
R"==(IF_HALF_SUPPORTED(DEF_special_vals(half, 0.0h, 1.0h, -HALF_MAX, HALF_MAX));)==""\n"
R"==(#define SPECIAL(dt, val) CONCAT3(dt, _, val))==""\n"
R"==(#ifdef ENABLE_CHECK_ASSUMPTIONS)==""\n"
R"==(#define ASSUME(x) \)==""\n"
R"==(if (!(x)) { \)==""\n"
R"==(printf("Error - GWS indices (%ld,%ld,%ld): Runtime assumption \"%s\" " \)==""\n"
R"==("violated\n", \)==""\n"
R"==(get_global_id(0), get_global_id(1), get_global_id(2), #x); \)==""\n"
R"==(return; \)==""\n"
R"==(})==""\n"
R"==(#elif HAS_BUILTIN(__builtin_assume))==""\n"
R"==(#define ASSUME(x) __builtin_assume(x))==""\n"
R"==(#else)==""\n"
R"==(#define ASSUME(x))==""\n"
R"==(#endif)==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}