namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *offsets_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OFFSETS_H)==""\n"
R"==(#define GPU_INTEL_OCL_OFFSETS_H)==""\n"
R"==(int off_ncdhw(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += n * C * D * H * W;)==""\n"
R"==(off += c * D * H * W;)==""\n"
R"==(off += d * H * W;)==""\n"
R"==(off += h * W;)==""\n"
R"==(off += w;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_ndhwc(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += n * D * H * W * C;)==""\n"
R"==(off += d * H * W * C;)==""\n"
R"==(off += h * W * C;)==""\n"
R"==(off += w * C;)==""\n"
R"==(off += c;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_nCdhw16c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += n * (C / 16) * D * H * W * 16;)==""\n"
R"==(off += (c / 16) * D * H * W * 16;)==""\n"
R"==(off += d * H * W * 16;)==""\n"
R"==(off += h * W * 16;)==""\n"
R"==(off += w * 16;)==""\n"
R"==(off += c % 16;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_NCdhw16n16c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += (n / 16) * (C / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (c / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += d * H * W * 16 * 16;)==""\n"
R"==(off += h * W * 16 * 16;)==""\n"
R"==(off += w * 16 * 16;)==""\n"
R"==(off += (n % 16) * 16;)==""\n"
R"==(off += (c % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_nCdhw32c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int c_32_block = OC % 32 ? (32 + OC - (OC % 32)) : OC;)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += n * (c_32_block / 32) * G * D * H * W * 32;)==""\n"
R"==(off += (c / 32) * D * H * W * 32;)==""\n"
R"==(off += d * H * W * 32;)==""\n"
R"==(off += h * W * 32;)==""\n"
R"==(off += w * 32;)==""\n"
R"==(off += c % 32;)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_NCdhw32n16c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += (n / 32) * (C / 16) * D * H * W * 32 * 16;)==""\n"
R"==(off += (c / 16) * D * H * W * 32 * 16;)==""\n"
R"==(off += d * H * W * 32 * 16;)==""\n"
R"==(off += h * W * 32 * 16;)==""\n"
R"==(off += w * 32 * 16;)==""\n"
R"==(off += (n % 32) * 16;)==""\n"
R"==(off += (c % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_NCdhw32n32c()==""\n"
R"==(int n, int c, int d, int h, int w, int C, int D, int H, int W) {)==""\n"
R"==(int c_32_block = OC % 32 ? (32 + OC - (OC % 32)) : OC;)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += (n / 32) * (c_32_block / 32) * D * H * W * 32 * 32;)==""\n"
R"==(off += (c / 32) * D * H * W * 32 * 32;)==""\n"
R"==(off += d * H * W * 32 * 32;)==""\n"
R"==(off += h * W * 32 * 32;)==""\n"
R"==(off += w * 32 * 32;)==""\n"
R"==(off += (n % 32) * 32;)==""\n"
R"==(off += (c % 32);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_gOdhwi16o(int g, int o, int i, int d, int h, int w, int O, int I, int D,)==""\n"
R"==(int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += g * (O / 16) * D * H * W * I * 16;)==""\n"
R"==(off += (o / 16) * D * H * W * I * 16;)==""\n"
R"==(off += d * H * W * I * 16;)==""\n"
R"==(off += h * W * I * 16;)==""\n"
R"==(off += w * I * 16;)==""\n"
R"==(off += i * 16;)==""\n"
R"==(off += (o % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_gOIdhw16i16o(int g, int o, int i, int d, int h, int w, int O, int I,)==""\n"
R"==(int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += g * (O / 16) * (I / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (o / 16) * (I / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (i / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += d * H * W * 16 * 16;)==""\n"
R"==(off += h * W * 16 * 16;)==""\n"
R"==(off += w * 16 * 16;)==""\n"
R"==(off += (i % 16) * 16;)==""\n"
R"==(off += (o % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int off_gIOdhw16i16o(int g, int o, int i, int d, int h, int w, int O, int I,)==""\n"
R"==(int D, int H, int W) {)==""\n"
R"==(int off = 0;)==""\n"
R"==(off += g * (I / 16) * (O / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (i / 16) * (O / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += (o / 16) * D * H * W * 16 * 16;)==""\n"
R"==(off += d * H * W * 16 * 16;)==""\n"
R"==(off += h * W * 16 * 16;)==""\n"
R"==(off += w * 16 * 16;)==""\n"
R"==(off += (i % 16) * 16;)==""\n"
R"==(off += (o % 16);)==""\n"
R"==(return off;)==""\n"
R"==(})==""\n"
R"==(int src_off(int n, int c, int d, int h, int w) {)==""\n"
R"==(#if SRC_NCHW)==""\n"
R"==(return off_ncdhw(n, c, d, h, w, G * IC, ID, IH, IW);)==""\n"
R"==(#elif SRC_NHWC)==""\n"
R"==(return off_ndhwc(n, c, d, h, w, G * IC, ID, IH, IW);)==""\n"
R"==(#elif SRC_W16C)==""\n"
R"==(return off_nCdhw16c(n, c, d, h, w, G * IC, ID, IH, IW);)==""\n"
R"==(#elif SRC_16N16C)==""\n"
R"==(return off_NCdhw16n16c(n, c, d, h, w, G * IC, ID, IH, IW);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unknown layout")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(int wei_off(int g, int o, int i, int d, int h, int w) {)==""\n"
R"==(#if WEI_I16O)==""\n"
R"==(return off_gOdhwi16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);)==""\n"
R"==(#elif WEI_16I16O)==""\n"
R"==(return off_gOIdhw16i16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);)==""\n"
R"==(#elif WEI_16I16O_FLIPPED)==""\n"
R"==(return off_gIOdhw16i16o(g, o, i, d, h, w, OC, IC, KD, KH, KW);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unknown layout")==""\n"
R"==(#endif)==""\n"
R"==(return 0;)==""\n"
R"==(})==""\n"
R"==(int dst_off(int n, int c, int d, int h, int w) {)==""\n"
R"==(#if DST_NCHW)==""\n"
R"==(return off_ncdhw(n, c, d, h, w, G * OC_WO_PADDING, OD, OH, OW);)==""\n"
R"==(#elif DST_NHWC)==""\n"
R"==(return off_ndhwc(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#elif DST_W16C)==""\n"
R"==(return off_nCdhw16c(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#elif DST_16N16C)==""\n"
R"==(return off_NCdhw16n16c(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#elif DST_W32C)==""\n"
R"==(return off_nCdhw32c(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#elif DST_32N16C)==""\n"
R"==(return off_NCdhw32n16c(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#elif DST_32N32C)==""\n"
R"==(return off_NCdhw32n32c(n, c, d, h, w, G * OC, OD, OH, OW);)==""\n"
R"==(#else)==""\n"
R"==(#error "Unknown layout")==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}