namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_reduction_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_post_ops.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN))==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE))==""\n"
R"==(#else)==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MAX))==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8))==""\n"
R"==(#define ACCUMULATE(x, y) max(x, y))==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE(x, y) fmax(x, y))==""\n"
R"==(#endif)==""\n"
R"==(#elif defined(IS_MIN))==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8))==""\n"
R"==(#define ACCUMULATE(x, y) min(x, y))==""\n"
R"==(#elif defined(SRC_DT_BF8) || defined(SRC_DT_HF8))==""\n"
R"==(#define ACCUMULATE(x, y) fmin(TO_DEF_ACC_DATA(x), TO_DEF_ACC_DATA(y)))==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE(x, y) fmin(x, y))==""\n"
R"==(#endif)==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM))==""\n"
R"==(#define ACCUMULATE(x, y) (x + y))==""\n"
R"==(#elif defined(IS_MUL))==""\n"
R"==(#define ACCUMULATE(x, y) (x * y))==""\n"
R"==(#else)==""\n"
R"==(#define ACCUMULATE(x, y) (x + pow(fabs(y), POWER)))==""\n"
R"==(#endif)==""\n"
R"==(#if defined(IS_MEAN))==""\n"
R"==(#define FINALIZE(x) (x / DIV))==""\n"
R"==(#elif defined(IS_LP_MAX))==""\n"
R"==(#define FINALIZE(x) rootn(fmax(x, EPS), POWER))==""\n"
R"==(#elif defined(IS_LP_SUM))==""\n"
R"==(#define FINALIZE(x) rootn(x + EPS, POWER))==""\n"
R"==(#elif defined(IS_P_MAX))==""\n"
R"==(#define FINALIZE(x) fmax(x, EPS))==""\n"
R"==(#elif defined(IS_P_SUM))==""\n"
R"==(#define FINALIZE(x) (x + EPS))==""\n"
R"==(#else)==""\n"
R"==(#define FINALIZE(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#define _SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5))==""\n"
R"==(#define _DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5))==""\n"
R"==(__kernel void ref_reduce()==""\n"
R"==(__global SRC_DATA_T *src, __global DST_DATA_T *dst POST_OP_ARGS) {)==""\n"
R"==(off_t d0 = GWS_GET_D0();)==""\n"
R"==(off_t d1 = GWS_GET_D1();)==""\n"
R"==(off_t d2 = GWS_GET_D2();)==""\n"
R"==(off_t d3 = GWS_GET_D3();)==""\n"
R"==(off_t d4 = GWS_GET_D4();)==""\n"
R"==(off_t d5 = GWS_GET_D5();)==""\n"
R"==(const off_t dst_off = _DST_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(if (d0 >= DST_D0 || d1 >= DST_D1 || d2 >= DST_D2 || d3 >= DST_D3)==""\n"
R"==(|| d4 >= DST_D4 || d5 >= DST_D5) {)==""\n"
R"==(dst[dst_off] = TO_DST(0.0f);)==""\n"
R"==(return;)==""\n"
R"==(})==""\n"
R"==(DEF_ACC_DATA_T acc = INIT_ACC;)==""\n"
R"==(for_(off_t d0_off = 0; d0_off < REDUCTION_D0; d0_off++))==""\n"
R"==(for_(off_t d1_off = 0; d1_off < REDUCTION_D1; d1_off++))==""\n"
R"==(for_(off_t d2_off = 0; d2_off < REDUCTION_D2; d2_off++))==""\n"
R"==(for_(off_t d3_off = 0; d3_off < REDUCTION_D3; d3_off++))==""\n"
R"==(for_(off_t d4_off = 0; d4_off < REDUCTION_D4; d4_off++))==""\n"
R"==(for_(off_t d5_off = 0; d5_off < REDUCTION_D5; d5_off++))==""\n"
R"==({)==""\n"
R"==(const off_t src_off = _SRC_OFF(d0 + d0_off, d1 + d1_off, d2 + d2_off,)==""\n"
R"==(d3 + d3_off, d4 + d4_off, d5 + d5_off);)==""\n"
R"==(acc = ACCUMULATE(acc, TO_DEF_ACC_DATA_T(src[src_off]));)==""\n"
R"==(})==""\n"
R"==(float res = convert_float(acc);)==""\n"
R"==(res = FINALIZE(res);)==""\n"
R"==(float dst_val;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(dst_val = DST_TO_REF(dst[dst_off]);)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(res, float, dst_val, float, d0, 1, d1, 1, d2, 1, d3,)==""\n"
R"==(1, d4, 1, d5, 1);)==""\n"
R"==(dst[dst_off] = TO_DST(res);)==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}