namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ref_reorder_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define USE_CUSTOM_GWS_GET_ID)==""\n"
R"==(#undef cl_future_bf16_cvt)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_philox.h")==""\n"
R"==(#include "gpu/intel/ocl/reorder_common.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(#define FROM_I4 (SRC_DT_U4 || SRC_DT_S4))==""\n"
R"==(#define GWS_GET_THREAD_ID(index) \)==""\n"
R"==((off_t)(get_global_id(index) + offset.array[index]))==""\n"
R"==(KERNEL_ATTR)==""\n"
R"==(__kernel void ref_reorder(__global SRC_DATA_T *restrict src,)==""\n"
R"==(__global DST_DATA_T *restrict dst,)==""\n"
R"==(__global SRC_SCALES_DATA_T *restrict src_scales,)==""\n"
R"==(__global SRC_ZP_DATA_T *restrict src_zps,)==""\n"
R"==(__global float *restrict dst_scales, __global int *dst_zps,)==""\n"
R"==(float sum_scale, int sum_zp,)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(__global uint *sround_seed_buf,)==""\n"
R"==(#endif)==""\n"
R"==(int64x3_t offset) {)==""\n"
R"==(int src_zp = 0;)==""\n"
R"==(const int dst_zp = GET_DST_ZP(dst_zps);)==""\n"
R"==(float src_scale = 1.0f;)==""\n"
R"==(float dst_scale = 1.0f;)==""\n"
R"==(src += SRC_OFFSET0;)==""\n"
R"==(dst += DST_OFFSET0;)==""\n"
R"==(const off_t d0_blk_start = GWS_GET_D0();)==""\n"
R"==(const off_t d1_blk_start = GWS_GET_D1();)==""\n"
R"==(const off_t d2_blk_start = GWS_GET_D2();)==""\n"
R"==(const off_t d3_blk_start = GWS_GET_D3();)==""\n"
R"==(const off_t d4_blk_start = GWS_GET_D4();)==""\n"
R"==(const off_t d5_blk_start = GWS_GET_D5();)==""\n"
R"==(const off_t d0_blk_end = d0_blk_start + GWS_GET_D0_BLOCK();)==""\n"
R"==(const off_t d1_blk_end = d1_blk_start + GWS_GET_D1_BLOCK();)==""\n"
R"==(const off_t d2_blk_end = d2_blk_start + GWS_GET_D2_BLOCK();)==""\n"
R"==(const off_t d3_blk_end = d3_blk_start + GWS_GET_D3_BLOCK();)==""\n"
R"==(const off_t d4_blk_end = d4_blk_start + GWS_GET_D4_BLOCK();)==""\n"
R"==(const off_t d5_blk_end = d5_blk_start + GWS_GET_D5_BLOCK();)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(const uint sround_seed = *sround_seed_buf;)==""\n"
R"==(#endif)==""\n"
R"==(for_(off_t d0 = d0_blk_start; d0 < d0_blk_end; ++d0))==""\n"
R"==(for_(off_t d1 = d1_blk_start; d1 < d1_blk_end; ++d1))==""\n"
R"==(for_(off_t d2 = d2_blk_start; d2 < d2_blk_end; ++d2))==""\n"
R"==(for_(off_t d3 = d3_blk_start; d3 < d3_blk_end; ++d3))==""\n"
R"==(for_(off_t d4 = d4_blk_start; d4 < d4_blk_end; ++d4))==""\n"
R"==(for (off_t d5 = d5_blk_start; d5 < d5_blk_end; ++d5) {)==""\n"
R"==(const off_t src_off = SRC_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(const off_t dst_off = DST_OFF(d0, d1, d2, d3, d4, d5);)==""\n"
R"==(#if PAD_FILL_ZERO == 1)==""\n"
R"==(int pad_d0 = d0 >= SRC_D0;)==""\n"
R"==(int pad_d1 = NDIMS > 1 && d1 >= SRC_D1;)==""\n"
R"==(int pad_d2 = NDIMS > 2 && d2 >= SRC_D2;)==""\n"
R"==(int pad_d3 = NDIMS > 3 && d3 >= SRC_D3;)==""\n"
R"==(int pad_d4 = NDIMS > 4 && d4 >= SRC_D4;)==""\n"
R"==(int pad_d5 = NDIMS > 5 && d5 >= SRC_D5;)==""\n"
R"==(if (pad_d0 || pad_d1 || pad_d2 || pad_d3 || pad_d4 || pad_d5) {)==""\n"
R"==(dst[dst_off] = 0;)==""\n"
R"==(continue;)==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_ZPOINT)==""\n"
R"==(off_t zp_off = ZPOINT_OFF(SRC, d0, d1, d2, d3, d4, d5);)==""\n"
R"==(src_zp = SRC_ZP_TO_REF(src_zps, zp_off);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SRC_SCALE)==""\n"
R"==(off_t scale_off = SCALE_OFF(SRC, d0, d1, d2, d3, d4, d5);)==""\n"
R"==(src_scale = SRC_SCALES_TO_REF(src_scales[scale_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE)==""\n"
R"==(dst_scale = dst_scales[SCALE_OFF(DST, d0, d1, d2, d3, d4, d5)];)==""\n"
R"==(#endif)==""\n"
R"==(#if FROM_I4 || SRC_DT_F4_E2M1)==""\n"
R"==(SRC_DATA_T src_value = GET_HALF_BYTE(src, src_off);)==""\n"
R"==(#else)==""\n"
R"==(SRC_DATA_T src_value = src[src_off];)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SROUND)==""\n"
R"==(#define ROUND(f) stochastic_round_fwd(f, dst_off, sround_seed))==""\n"
R"==(#else)==""\n"
R"==(#define ROUND DEFAULT_ROUND)==""\n"
R"==(#endif)==""\n"
R"==(REORDER(ROUND, dst[dst_off], src_value, src_scale, dst_scale, sum_scale,)==""\n"
R"==(src_zp, dst_zp, sum_zp);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}