namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reorder_common_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define DT_UNDEF 1)==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_math_utils.h")==""\n"
R"==(#if SRC_DT_F16 || DST_DT_F16)==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#if SRC_DT_F64 || DST_DT_F64)==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp64 : enable)==""\n"
R"==(#endif)==""\n"
R"==(#undef SRC_OFF)==""\n"
R"==(#undef DST_OFF)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(OFF_MD(SRC, (x0), (x1), (x2), (x3), (x4), (x5)))==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==(OFF_MD(DST, (x0), (x1), (x2), (x3), (x4), (x5)))==""\n"
R"==(#define SRC_OFF_G(gr, x0, x1, x2, x3, x4) \)==""\n"
R"==(OFF_MD(SRC, gr, (x0), (x1), (x2), (x3), (x4)))==""\n"
R"==(#define DST_OFF_G(gr, x0, x1, x2, x3, x4) \)==""\n"
R"==(OFF_MD(DST, gr, (x0), (x1), (x2), (x3), (x4)))==""\n"
R"==(#if SRC_DT_S8)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_U8 || SRC_DT_HF8 || SRC_DT_BF8)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_F16)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_half(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_S32)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_int(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_F32)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_F64)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_double(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==((double8)((as_double4(intel_sub_group_block_read8( \)==""\n"
R"==((const __global uint *)(src)))), \)==""\n"
R"==((as_double4(intel_sub_group_block_read8( \)==""\n"
R"==((const __global uint *)(src + 8))))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(dst), as_uint2(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(do { \)==""\n"
R"==(intel_sub_group_block_write8( \)==""\n"
R"==((__global uint *)(dst), as_uint8(val.lo)); \)==""\n"
R"==(intel_sub_group_block_write8( \)==""\n"
R"==((__global uint *)(dst + 8), as_uint8(val.hi)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_BF16)==""\n"
R"==(#define SRC_BLOCK_READ(src) \)==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define SRC_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define SRC_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define SRC_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_S8)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_char8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8 || DST_DT_BF8 || DST_DT_HF8)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_uchar(intel_sub_group_block_read_uc((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_uchar8(intel_sub_group_block_read_uc8((const __global uchar *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(dst), as_uchar(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(dst), as_uchar8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F16)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_half(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_half8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_S32)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_int(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_int8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F32)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_float8(intel_sub_group_block_read8((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)(dst), as_uint(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(dst), as_uint8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_F64)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_double(intel_sub_group_block_read2((const __global uint *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==((double8)((as_double4(intel_sub_group_block_read8( \)==""\n"
R"==((const __global uint *)(src)))), \)==""\n"
R"==((as_double4(intel_sub_group_block_read8( \)==""\n"
R"==((const __global uint *)(src))))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(dst), as_uint2(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(do { \)==""\n"
R"==(intel_sub_group_block_write8( \)==""\n"
R"==((__global uint *)(dst), as_uint8(val.lo)); \)==""\n"
R"==(intel_sub_group_block_write8( \)==""\n"
R"==((__global uint *)(dst + 8), as_uint8(val.hi)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF16)==""\n"
R"==(#define DST_BLOCK_READ(src) \)==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_READ8(src) \)==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((const __global ushort *)(src))))==""\n"
R"==(#define DST_BLOCK_WRITE(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)(dst), as_ushort(val)))==""\n"
R"==(#define DST_BLOCK_WRITE8(dst, val) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)(dst), as_ushort8(val)))==""\n"
R"==(#endif )==""\n"
R"==(#if (SRC_DT_S8 && DST_DT_S8) || (SRC_DT_U8 && DST_DT_U8) \)==""\n"
R"==(|| (SRC_DT_BF16 && DST_DT_BF16) || (SRC_DT_F16 && DST_DT_F16) \)==""\n"
R"==(|| (SRC_DT_F32 && DST_DT_F32) || (SRC_DT_S32 && DST_DT_S32) \)==""\n"
R"==(|| (SRC_DT_F64 && DST_DT_F64) || (SRC_DT_BF8 && DST_DT_BF8) \)==""\n"
R"==(|| (SRC_DT_HF8 && DST_DT_HF8))==""\n"
R"==(#define SRC_TO_DST(x) (x))==""\n"
R"==(#define SRC_TO_DST8(x) (x))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_TO_DST(x) TO_DST(SRC_TO_REF(x)))==""\n"
R"==(#define SRC_TO_DST8(x) TO_DST8(SRC_TO_REF8(x)))==""\n"
R"==(#endif)==""\n"
R"==(#define SCALE_MUL(x, s) (x) * (s))==""\n"
R"==(#define SCALE_DIV(x, s) (x) / (s))==""\n"
R"==(#define SCALE_NONE(x, s) (x))==""\n"
R"==(#if WITH_SRC_SCALE)==""\n"
R"==(#define SRC_SCALE SCALE_MUL)==""\n"
R"==(#else)==""\n"
R"==(#define SRC_SCALE SCALE_NONE)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE)==""\n"
R"==(#define DST_SCALE SCALE_DIV)==""\n"
R"==(#else)==""\n"
R"==(#define DST_SCALE SCALE_NONE)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SUM_SCALE)==""\n"
R"==(#define SUM_SCALE SCALE_MUL)==""\n"
R"==(#else)==""\n"
R"==(#define SUM_SCALE SCALE_NONE)==""\n"
R"==(#endif)==""\n"
R"==(#define ZP_SHIFT(x, x0) (x) - (float)(x0))==""\n"
R"==(#define ZP_UNSHIFT(x, x0) (x) + (float)(x0))==""\n"
R"==(#define ZP_NO_SHIFT(x, x0) (x))==""\n"
R"==(#define ZP_READ_VAL(x) x)==""\n"
R"==(#define ZP_READ_PTR(x) x[0])==""\n"
R"==(#define ZP_ZERO(x) 0)==""\n"
R"==(#if WITH_SRC_ZPOINT)==""\n"
R"==(#define SRC_SHIFT ZP_SHIFT)==""\n"
R"==(#define GET_SRC_ZP ZP_READ_PTR)==""\n"
R"==(#else)==""\n"
R"==(#define SRC_SHIFT ZP_NO_SHIFT)==""\n"
R"==(#define GET_SRC_ZP ZP_ZERO)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_ZPOINT)==""\n"
R"==(#define DST_SHIFT ZP_UNSHIFT)==""\n"
R"==(#define GET_DST_ZP ZP_READ_PTR)==""\n"
R"==(#else)==""\n"
R"==(#define DST_SHIFT ZP_NO_SHIFT)==""\n"
R"==(#define GET_DST_ZP ZP_ZERO)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SUM_ZPOINT)==""\n"
R"==(#define SUM_SHIFT ZP_SHIFT)==""\n"
R"==(#define GET_SUM_ZP ZP_READ_VAL)==""\n"
R"==(#else)==""\n"
R"==(#define SUM_SHIFT ZP_NO_SHIFT)==""\n"
R"==(#define GET_SUM_ZP ZP_ZERO)==""\n"
R"==(#endif)==""\n"
R"==(#define SRC_AXPY(a, x, x0) SRC_SCALE(SRC_SHIFT(x, x0), a))==""\n"
R"==(#define DST_AXPY(a, x, x0) DST_SHIFT(DST_SCALE(x, a), x0))==""\n"
R"==(#define SUM_AXPY(a, x, x0) SUM_SCALE(SUM_SHIFT(x, x0), a))==""\n"
R"==(#define AXPY(src, dst, a, b, c, x0, y0, z0) \)==""\n"
R"==(DST_AXPY(b, (SRC_AXPY(a, src, x0) + SUM_AXPY(c, dst, y0 + z0)), y0))==""\n"
R"==(#if WITH_SRC_SCALE || WITH_SRC_ZPOINT)==""\n"
R"==(#define WITH_SRC_MOD 1)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_DST_SCALE || WITH_DST_ZPOINT)==""\n"
R"==(#define WITH_DST_MOD 1)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SUM_SCALE || WITH_SUM_ZPOINT)==""\n"
R"==(#define WITH_SUM_MOD 1)==""\n"
R"==(#endif)==""\n"
R"==(#if WITH_SUM_MOD)==""\n"
R"==(#define REORDER(round, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(const float _x = SRC_TO_REF(_src); \)==""\n"
R"==(const float _y = DST_TO_REF(_dst); \)==""\n"
R"==(const float _s = AXPY(_x, _y, _a, _b, _c, _x0, _y0, _z0); \)==""\n"
R"==(_dst = TO_DST(round(_s)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define REORDER8(round8, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(const float8 _x = convert_float8(SRC_TO_REF8(_src)); \)==""\n"
R"==(const float8 _y = convert_float8(DST_TO_REF8(_dst)); \)==""\n"
R"==(const float8 _s = AXPY(_x, _y, _a, _b, _c, _x0, _y0, _z0); \)==""\n"
R"==(_dst = TO_DST8(round8(_s)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#elif WITH_SRC_MOD || WITH_DST_MOD)==""\n"
R"==(#define REORDER(round, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(const float _x = SRC_TO_REF(_src); \)==""\n"
R"==(const float _s = AXPY(_x, 0.f, _a, _b, _c, _x0, _y0, _z0); \)==""\n"
R"==(_dst = TO_DST(round(_s)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define REORDER8(round8, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(const float8 _x = convert_float8(SRC_TO_REF8(_src)); \)==""\n"
R"==(const float8 _s = AXPY(_x, 0.f, _a, _b, _c, _x0, _y0, _z0); \)==""\n"
R"==(_dst = TO_DST8(round8(_s)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#elif WITH_SROUND)==""\n"
R"==(#define REORDER(round, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(_dst = TO_DST(round(SRC_TO_REF(_src))); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define REORDER8(round8, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(_dst = TO_DST8(round8(SRC_TO_REF8(_src)); \)==""\n"
R"==(} while (0))==""\n"
R"==(#else)==""\n"
R"==(#define REORDER(round, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(_dst = SRC_TO_DST(_src); \)==""\n"
R"==(} while (0))==""\n"
R"==(#define REORDER8(round8, _dst, _src, _a, _b, _c, _x0, _y0, _z0) \)==""\n"
R"==(do { \)==""\n"
R"==(_dst = SRC_TO_DST8(_src); \)==""\n"
R"==(} while (0))==""\n"
R"==(#endif )==""\n"
R"==(#define DEFAULT_ROUND(f) f)==""\n"
R"==(#if WITH_SRC_SCALE || WITH_DST_SCALE || WITH_SRC_ZPOINT || WITH_DST_ZPOINT)==""\n"
R"==(#define MASK_DIM(prefix, mask, dim) ((CONCAT2(prefix, mask) >> dim) & 1))==""\n"
R"==(#define QUANT_DIM(prefix, mask, dim) \)==""\n"
R"==((MASK_DIM(prefix, mask, dim) ? CONCAT3(prefix, _D, dim) : 1))==""\n"
R"==(#define GROUP_DIM(prefix, quant_group_dim, quant_group, dim) \)==""\n"
R"==(((CONCAT2(prefix, quant_group_dim) == dim) ? CONCAT2(prefix, quant_group) \)==""\n"
R"==(: 1))==""\n"
R"==(#define QUANT_S5(prefix, mask, quant_group_dim, quant_group) (1))==""\n"
R"==(#define QUANT_S4(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(((QUANT_DIM(prefix, mask, 5) \)==""\n"
R"==(/ GROUP_DIM(prefix, quant_group_dim, quant_group, 5)) \)==""\n"
R"==(* QUANT_S5(prefix, mask, quant_group_dim, quant_group)))==""\n"
R"==(#define QUANT_S3(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(((QUANT_DIM(prefix, mask, 4) \)==""\n"
R"==(/ GROUP_DIM(prefix, quant_group_dim, quant_group, 4)) \)==""\n"
R"==(* QUANT_S4(prefix, mask, quant_group_dim, quant_group)))==""\n"
R"==(#define QUANT_S2(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(((QUANT_DIM(prefix, mask, 3) \)==""\n"
R"==(/ GROUP_DIM(prefix, quant_group_dim, quant_group, 3)) \)==""\n"
R"==(* QUANT_S3(prefix, mask, quant_group_dim, quant_group)))==""\n"
R"==(#define QUANT_S1(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(((QUANT_DIM(prefix, mask, 2) \)==""\n"
R"==(/ GROUP_DIM(prefix, quant_group_dim, quant_group, 2)) \)==""\n"
R"==(* QUANT_S2(prefix, mask, quant_group_dim, quant_group)))==""\n"
R"==(#define QUANT_S0(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(((QUANT_DIM(prefix, mask, 1) \)==""\n"
R"==(/ GROUP_DIM(prefix, quant_group_dim, quant_group, 1)) \)==""\n"
R"==(* QUANT_S1(prefix, mask, quant_group_dim, quant_group)))==""\n"
R"==(#define QUANT_STRIDE(prefix, mask, quant_group_dim, quant_group, dim) \)==""\n"
R"==((CONCAT2(QUANT_S, dim)(prefix, mask, quant_group_dim, quant_group) \)==""\n"
R"==(* MASK_DIM(prefix, mask, dim)))==""\n"
R"==(#if WITH_SRC_SCALE || WITH_DST_SCALE)==""\n"
R"==(#define SCALE_OFF(prefix, x0, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x0) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 0)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 0) \)==""\n"
R"==(+ ((x1) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 1)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 1) \)==""\n"
R"==(+ ((x2) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 2)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 2) \)==""\n"
R"==(+ ((x3) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 3)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 3) \)==""\n"
R"==(+ ((x4) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 4)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 4) \)==""\n"
R"==(+ ((x5) / GROUP_DIM(prefix, _SCALE_GROUP_DIM, _SCALE_GROUP, 5)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _SCALE_MASK, _SCALE_GROUP_DIM, \)==""\n"
R"==(_SCALE_GROUP, 5)))==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SRC_ZPOINT || WITH_DST_ZPOINT)==""\n"
R"==(#define ZPOINT_OFF(prefix, x0, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x0) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 0)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 0) \)==""\n"
R"==(+ ((x1) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 1)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 1) \)==""\n"
R"==(+ ((x2) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 2)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 2) \)==""\n"
R"==(+ ((x3) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 3)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 3) \)==""\n"
R"==(+ ((x4) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 4)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 4) \)==""\n"
R"==(+ ((x5) / GROUP_DIM(prefix, _ZPOINT_GROUP_DIM, _ZPOINT_GROUP, 5)) \)==""\n"
R"==(* QUANT_STRIDE(prefix, _ZPOINT_MASK, _ZPOINT_GROUP_DIM, \)==""\n"
R"==(_ZPOINT_GROUP, 5)))==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}
}