namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_simple_concat_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#if USE_LARGE_INDEX == 1)==""\n"
R"==(typedef long idx_t;)==""\n"
R"==(#else)==""\n"
R"==(typedef int idx_t;)==""\n"
R"==(#endif)==""\n"
R"==(#include "gpu/intel/ocl/concat_common.h")==""\n"
R"==(#define unroll_for __attribute__((opencl_unroll_hint)) for)==""\n"
R"==(#define SRC_PARAM(n) \)==""\n"
R"==(CS_PARAM(__global const DATA_T *src##n, const idx_t src_ext_offset##n, \)==""\n"
R"==(const idx_t offset##n, const idx_t padded_offset##n, \)==""\n"
R"==(const idx_t src_concat_axis##n))==""\n"
R"==(#define SRC_PARAMS REDUCE(N_INPUTS, JOIN_COMMA, SRC_PARAM))==""\n"
R"==(idx_t get_concat_idx(idx_t inner_idx, idx_t inner_offset) {)==""\n"
R"==(idx_t block = 1;)==""\n"
R"==(idx_t idx = 0;)==""\n"
R"==(#define HANDLE(n) \)==""\n"
R"==(idx += block * ((inner_idx / (BLOCK_S##n)) % (BLOCK_B##n)); \)==""\n"
R"==(block *= BLOCK_B##n)==""\n"
R"==(REDUCE(BLOCK_DEPTH, JOIN_SEMICOLON, HANDLE);)==""\n"
R"==(#undef HANDLE)==""\n"
R"==(return idx + block * (inner_idx / inner_offset);)==""\n"
R"==(})==""\n"
R"==(idx_t get_concat_offset(idx_t concat_idx, idx_t inner_offset) {)==""\n"
R"==(idx_t block = 1;)==""\n"
R"==(idx_t idx = 0;)==""\n"
R"==(#define HANDLE(n) \)==""\n"
R"==(idx += (BLOCK_S##n) * ((concat_idx / block) % (BLOCK_B##n)); \)==""\n"
R"==(block *= BLOCK_B##n)==""\n"
R"==(REDUCE(BLOCK_DEPTH, JOIN_SEMICOLON, HANDLE);)==""\n"
R"==(#undef HANDLE)==""\n"
R"==(return idx + inner_offset * (concat_idx / block);)==""\n"
R"==(})==""\n"
R"==(struct write_info_t {)==""\n"
R"==(idx_t idx;)==""\n"
R"==(bool write;)==""\n"
R"==(};)==""\n"
R"==(struct write_info_t get_write_info(const idx_t src_idx,)==""\n"
R"==(const idx_t src_ext_offset, const idx_t concat_offset,)==""\n"
R"==(const idx_t dst_ext_offset, const idx_t thread_offset,)==""\n"
R"==(const idx_t concat_axis, const idx_t last_concat_axis,)==""\n"
R"==(const idx_t zero_pad_offset, const idx_t zero_pad_concat_axis,)==""\n"
R"==(const idx_t inner_offset, bool must_compute_ext_idx) {)==""\n"
R"==(idx_t inner_idx, ext_idx;)==""\n"
R"==(if (must_compute_ext_idx) {)==""\n"
R"==(ext_idx = (src_ext_offset == 1) ? src_idx : src_idx / src_ext_offset;)==""\n"
R"==(inner_idx = (src_ext_offset == 1) ? 0 : src_idx % src_ext_offset;)==""\n"
R"==(} else {)==""\n"
R"==(ext_idx = 0;)==""\n"
R"==(inner_idx = src_idx;)==""\n"
R"==(})==""\n"
R"==(struct write_info_t info;)==""\n"
R"==(#if BLOCK_DEPTH > 0)==""\n"
R"==(idx_t concat_idx = get_concat_idx(inner_idx, inner_offset);)==""\n"
R"==(bool write_value = concat_offset + concat_idx < concat_axis;)==""\n"
R"==(idx_t write_offset;)==""\n"
R"==(if (last_concat_axis < zero_pad_concat_axis) {)==""\n"
R"==(idx_t zero_pad_start = zero_pad_offset - concat_axis + thread_offset;)==""\n"
R"==(bool write_zeropad = zero_pad_start + concat_idx < zero_pad_concat_axis;)==""\n"
R"==(write_offset = write_value ? concat_offset : zero_pad_start;)==""\n"
R"==(info.write = write_value || write_zeropad;)==""\n"
R"==(} else {)==""\n"
R"==(write_offset = concat_offset;)==""\n"
R"==(info.write = write_value;)==""\n"
R"==(})==""\n"
R"==(info.idx = ext_idx * dst_ext_offset + inner_idx)==""\n"
R"==(+ get_concat_offset(concat_idx + write_offset, inner_offset))==""\n"
R"==(- get_concat_offset(concat_idx, inner_offset);)==""\n"
R"==(#else)==""\n"
R"==(info.write = true;)==""\n"
R"==(info.idx = ext_idx * dst_ext_offset + inner_offset * concat_offset)==""\n"
R"==(+ inner_idx;)==""\n"
R"==(#endif)==""\n"
R"==(return info;)==""\n"
R"==(})==""\n"
R"==(#if SIMD != 1)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SIMD))))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void)==""\n"
R"==(reusable_simple_concat(__global DATA_T *dst, const ulong dst_offset0,)==""\n"
R"==(const ulong dst_ext_offset, SRC_PARAMS, const idx_t zero_pad_offset,)==""\n"
R"==(const idx_t zero_pad_concat_axis, const idx_t read_overlap,)==""\n"
R"==(const idx_t gws0_block, const idx_t inner_offset,)==""\n"
R"==(const uchar must_compute_ext_idx) {)==""\n"
R"==(__global const DATA_T *src;)==""\n"
R"==(idx_t src_ext_offset, input_offset;)==""\n"
R"==(idx_t input_padded_offset, concat_axis_size;)==""\n"
R"==(#define CHECK_AND_GET(n) \)==""\n"
R"==(if (get_global_id(2) >= padded_offset##n) { \)==""\n"
R"==(src = src##n; \)==""\n"
R"==(input_offset = offset##n; \)==""\n"
R"==(input_padded_offset = padded_offset##n; \)==""\n"
R"==(concat_axis_size = src_concat_axis##n; \)==""\n"
R"==(src_ext_offset = src_ext_offset##n; \)==""\n"
R"==(})==""\n"
R"==(REDUCE(N_INPUTS, JOIN_ELSE, CHECK_AND_GET);)==""\n"
R"==(#undef CHECK_AND_GET)==""\n"
R"==(const idx_t block_offset)==""\n"
R"==(= gws0_block * (get_global_id(2) - input_padded_offset))==""\n"
R"==(+ (get_global_id(0) / SIMD) * READ_BLOCK;)==""\n"
R"==(const idx_t thr_elems = READ_BLOCK / SIMD;)==""\n"
R"==(src += read_overlap * get_global_id(1) * src_ext_offset + block_offset;)==""\n"
R"==(#define CONCAT_AXIS(n) src_concat_axis##n)==""\n"
R"==(#define RIGHT(x, y) y)==""\n"
R"==(#define WRITE_INFO(idx) \)==""\n"
R"==(get_write_info(block_offset + (idx), src_ext_offset, input_offset, \)==""\n"
R"==(dst_ext_offset, input_padded_offset, concat_axis_size, \)==""\n"
R"==(REDUCE(N_INPUTS, RIGHT, CONCAT_AXIS), zero_pad_offset, \)==""\n"
R"==(zero_pad_concat_axis, inner_offset, must_compute_ext_idx))==""\n"
R"==(#if SIMD == 1)==""\n"
R"==(dst += dst_offset0 + read_overlap * get_global_id(1) * dst_ext_offset;)==""\n"
R"==(for (int i = 0; i < thr_elems; ++i) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(i);)==""\n"
R"==(if (info.write) dst[info.idx] = src[i];)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const uint lane = get_sub_group_local_id() % SIMD;)==""\n"
R"==(buffer_t buf;)==""\n"
R"==(if (READ_BLOCK * DATA_TYPE_SIZE % 4 != 0) {)==""\n"
R"==(for (int i = 0; i < thr_elems; ++i))==""\n"
R"==(buf.v1[i] = src[i * SIMD + lane];)==""\n"
R"==(} else {)==""\n"
R"==(#define MAYBE_BLOCK_READ(n, read, elems) \)==""\n"
R"==(do { \)==""\n"
R"==(if ((elems) & (n)) { \)==""\n"
R"==(const uint rel = (elems) & ~(((n) << 1) - 1); \)==""\n"
R"==(buf.v##n[rel / (n)] = read(&src[rel * SIMD]); \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(for (int i = 0; i < thr_elems / 16; ++i))==""\n"
R"==(buf.v16[i] = BLOCK_READ16(&src[16 * i * SIMD]);)==""\n"
R"==(MAYBE_BLOCK_READ(8, BLOCK_READ8, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(4, BLOCK_READ4, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(2, BLOCK_READ2, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(1, BLOCK_READ, thr_elems);)==""\n"
R"==(#undef MAYBE_BLOCK_READ)==""\n"
R"==(})==""\n"
R"==(if (lane < READ_BLOCK % SIMD))==""\n"
R"==(buf.v1[thr_elems] = src[thr_elems * SIMD + lane];)==""\n"
R"==(dst += dst_offset0 + read_overlap * get_global_id(1) * dst_ext_offset;)==""\n"
R"==(if (WRITE_BLOCK * DATA_TYPE_SIZE % 16 != 0) {)==""\n"
R"==(for (int i = 0; i < thr_elems; ++i) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(i * SIMD + lane);)==""\n"
R"==(if (info.write) dst[info.idx] = buf.v1[i];)==""\n"
R"==(})==""\n"
R"==(if (lane < READ_BLOCK % SIMD) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(thr_elems * SIMD + lane);)==""\n"
R"==(if (info.write) dst[info.idx] = buf.v1[thr_elems];)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(const uint elems_per_iteration = MAX(SIMD, WRITE_BLOCK);)==""\n"
R"==(const uint iterations = DIV_UP(READ_BLOCK, elems_per_iteration);)==""\n"
R"==(unroll_for(int j = 0; j < iterations; ++j) {)==""\n"
R"==(const uint buf_off = DIV_UP(j * elems_per_iteration, SIMD);)==""\n"
R"==(const uint block_off = buf_off * SIMD;)==""\n"
R"==(const uint iter_elems = WRITE_BLOCK - (block_off % WRITE_BLOCK);)==""\n"
R"==(const uint thr_iter_elems = iter_elems / SIMD;)==""\n"
R"==(struct write_info_t info = WRITE_INFO(block_off);)==""\n"
R"==(__global DATA_T *iter_dst = dst + info.idx;)==""\n"
R"==(#define MAYBE_BLOCK_WRITE(n, write, elems) \)==""\n"
R"==(do { \)==""\n"
R"==(if ((elems) & (n)) { \)==""\n"
R"==(const uint rel = (elems) & ~(((n) << 1) - 1); \)==""\n"
R"==(write(&iter_dst[rel * SIMD], load_vec##n(&buf, buf_off + rel)); \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(if (info.write) {)==""\n"
R"==(for (int i = 0; i < thr_iter_elems / 16; ++i))==""\n"
R"==(BLOCK_WRITE16(&iter_dst[16 * i * SIMD],)==""\n"
R"==(load_vec16(&buf, buf_off + i * 16));)==""\n"
R"==(MAYBE_BLOCK_WRITE(8, BLOCK_WRITE8, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(4, BLOCK_WRITE4, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(2, BLOCK_WRITE2, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(1, BLOCK_WRITE, thr_iter_elems);)==""\n"
R"==(})==""\n"
R"==(#undef MAYBE_BLOCK_WRITE)==""\n"
R"==(if (iter_elems % SIMD) {)==""\n"
R"==(const uint written = block_off + thr_iter_elems * SIMD;)==""\n"
R"==(struct write_info_t info = WRITE_INFO(written + lane);)==""\n"
R"==(if (info.write && lane < MIN(SIMD, READ_BLOCK - written)))==""\n"
R"==(dst[info.idx] = buf.v1[buf_off + thr_iter_elems];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}