namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *reusable_softmax_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/dispatch.h")==""\n"
R"==(#include "gpu/intel/ocl/ocl_types.h")==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(#if ONE_REDUCTION_PER_SUBGROUP == 1)==""\n"
R"==(__attribute__((reqd_work_group_size(16, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void)==""\n"
R"==(reusable_softmax_fwd_generic(__global SRC_DATA_T *src, __global DST_DATA_T *dst,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale,)==""\n"
R"==(dim_t softmax_axis_size, dim_t softmax_axis_stride,)==""\n"
R"==(dim_t softmax_axis_chunk_size, dispatch_gws_rt_params_t gws_params) {)==""\n"
R"==(dst = GWS_GET_BUFFER_POS(DST, gws_params, dst);)==""\n"
R"==(FLT_ACC_DATA_T max_ = TO_FLT_ACC_DATA_T(DATA_MIN);)==""\n"
R"==(FLT_ACC_DATA_T denom_ = TO_FLT_ACC_DATA_T(DATA_ZERO);)==""\n"
R"==(const size_t begin)==""\n"
R"==(= GWS_GET_OFF_NAMED(SRC, DEFAULT_DISPATCHER_SUFFIX, gws_params);)==""\n"
R"==(#if MANY_REDUCTIONS_PER_WORKGROUP == 1)==""\n"
R"==(const size_t end = begin + softmax_axis_stride * softmax_axis_size;)==""\n"
R"==(#else)==""\n"
R"==(const size_t axis_begin = GWS_GET_OFF_NAMED()==""\n"
R"==(ORIGINAL, DEFAULT_DISPATCHER_SUFFIX, gws_params);)==""\n"
R"==(const size_t end = min(axis_begin + softmax_axis_stride * softmax_axis_size,)==""\n"
R"==(begin + softmax_axis_stride * softmax_axis_chunk_size);)==""\n"
R"==(#endif)==""\n"
R"==(for (off_t c = begin; c < end; c += softmax_axis_stride) {)==""\n"
R"==(max_ = max(max_, TO_FLT_ACC_DATA_T(src[c]));)==""\n"
R"==(})==""\n"
R"==(if (USE_WORKGROUP_REDUCTION) { max_ = work_group_reduce_max(max_); })==""\n"
R"==(if (USE_SUBGROUP_REDUCTION) { max_ = sub_group_reduce_max(max_); })==""\n"
R"==(for (off_t c = begin; c < end; c += softmax_axis_stride) {)==""\n"
R"==(denom_ += exp(TO_FLT_ACC_DATA_T(src[c]) - max_);)==""\n"
R"==(})==""\n"
R"==(if (USE_WORKGROUP_REDUCTION) { denom_ = work_group_reduce_add(denom_); })==""\n"
R"==(if (USE_SUBGROUP_REDUCTION) { denom_ = sub_group_reduce_add(denom_); })==""\n"
R"==(denom_ = LOGSOFTMAX ? log(denom_) : 1.0f / denom_;)==""\n"
R"==(for (off_t c = begin; c < end; c += softmax_axis_stride) {)==""\n"
R"==(FLT_ACC_DATA_T unscaled = LOGSOFTMAX)==""\n"
R"==(? TO_FLT_ACC_DATA_T(src[c]) - max_ - denom_)==""\n"
R"==(: exp(TO_FLT_ACC_DATA_T(src[c]) - max_) * denom_;)==""\n"
R"==(float scale = 1.0f;)==""\n"
R"==(if (src_scale) { scale = *src_scale; })==""\n"
R"==(if (dst_scale) { scale /= *dst_scale; })==""\n"
R"==(dst[c - begin] = TO_DST(unscaled * scale);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}