namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_concat_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#define ZERO_PAD_OFFSET CAT(OFFSET, N_INPUTS))==""\n"
R"==(#define ZERO_PAD_CONCAT_DIM CAT(PADDED_OFFSET, N_INPUTS))==""\n"
R"==(#include "gpu/intel/ocl/concat_common.h")==""\n"
R"==(#define SRC_PTR(n) __global const DATA_T *src##n)==""\n"
R"==(#define SRC_PTRS REDUCE(N_INPUTS, JOIN_COMMA, SRC_PTR))==""\n"
R"==(size_t get_concat_idx(size_t inner_idx) {)==""\n"
R"==(size_t block = 1;)==""\n"
R"==(size_t idx = 0;)==""\n"
R"==(#define HANDLE(n) \)==""\n"
R"==(idx += block * ((inner_idx / (BLOCK_S##n)) % (BLOCK_B##n)); \)==""\n"
R"==(block *= BLOCK_B##n)==""\n"
R"==(REDUCE(BLOCK_DEPTH, JOIN_SEMICOLON, HANDLE);)==""\n"
R"==(#undef HANDLE)==""\n"
R"==(return idx + block * (inner_idx / INNER_OFFSET);)==""\n"
R"==(})==""\n"
R"==(size_t get_concat_offset(size_t concat_idx) {)==""\n"
R"==(size_t block = 1;)==""\n"
R"==(size_t idx = 0;)==""\n"
R"==(#define HANDLE(n) \)==""\n"
R"==(idx += (BLOCK_S##n) * ((concat_idx / block) % (BLOCK_B##n)); \)==""\n"
R"==(block *= BLOCK_B##n)==""\n"
R"==(REDUCE(BLOCK_DEPTH, JOIN_SEMICOLON, HANDLE);)==""\n"
R"==(#undef HANDLE)==""\n"
R"==(return idx + INNER_OFFSET * (concat_idx / block);)==""\n"
R"==(})==""\n"
R"==(struct write_info_t {)==""\n"
R"==(size_t idx;)==""\n"
R"==(bool write;)==""\n"
R"==(};)==""\n"
R"==(struct write_info_t get_write_info(size_t src_idx, size_t src_ext_offset,)==""\n"
R"==(size_t concat_offset, size_t thread_offset, size_t concat_axis) {)==""\n"
R"==(#define LOGICAL_OR(x, y) (x) || (y))==""\n"
R"==(#define HANDLE(n) CAT(OFFSET, n) % READ_OVERLAP != 0)==""\n"
R"==(#define CUTOFF REDUCE(N_INPUTS, LOGICAL_OR, HANDLE) || HANDLE(N_INPUTS))==""\n"
R"==(#if READ_OVERLAP * GWS0_BLOCK > INNER_OFFSET || CUTOFF)==""\n"
R"==(const size_t ext_idx = src_idx / src_ext_offset;)==""\n"
R"==(const size_t inner_idx = src_idx % src_ext_offset;)==""\n"
R"==(#else)==""\n"
R"==(const size_t ext_idx = 0;)==""\n"
R"==(const size_t inner_idx = src_idx;)==""\n"
R"==(#endif)==""\n"
R"==(#undef CUTOFF)==""\n"
R"==(#undef HANDLE)==""\n"
R"==(#undef LOGICAL_OR)==""\n"
R"==(struct write_info_t info;)==""\n"
R"==(#if BLOCK_DEPTH > 0)==""\n"
R"==(size_t concat_idx = get_concat_idx(inner_idx);)==""\n"
R"==(bool write_value = concat_offset + concat_idx < concat_axis;)==""\n"
R"==(#define CONCAT_AXIS(n) SRC##n##_CONCAT_AXIS)==""\n"
R"==(#define RIGHT(x, y) y)==""\n"
R"==(#if REDUCE(N_INPUTS, RIGHT, CONCAT_AXIS) < ZERO_PAD_CONCAT_DIM)==""\n"
R"==(size_t zero_pad_offset = ZERO_PAD_OFFSET - concat_axis + thread_offset;)==""\n"
R"==(bool write_zeropad = zero_pad_offset + concat_idx < ZERO_PAD_CONCAT_DIM;)==""\n"
R"==(size_t write_offset = write_value ? concat_offset : zero_pad_offset;)==""\n"
R"==(info.write = write_value || write_zeropad;)==""\n"
R"==(#else)==""\n"
R"==(size_t write_offset = concat_offset;)==""\n"
R"==(info.write = write_value;)==""\n"
R"==(#endif)==""\n"
R"==(#undef RIGHT)==""\n"
R"==(#undef CONCAT_AXIS)==""\n"
R"==(info.idx = ext_idx * DST_EXT_OFFSET + inner_idx)==""\n"
R"==(+ get_concat_offset(concat_idx + write_offset))==""\n"
R"==(- get_concat_offset(concat_idx);)==""\n"
R"==(#else)==""\n"
R"==(info.write = true;)==""\n"
R"==(info.idx = ext_idx * DST_EXT_OFFSET + INNER_OFFSET * concat_offset)==""\n"
R"==(+ inner_idx;)==""\n"
R"==(#endif)==""\n"
R"==(return info;)==""\n"
R"==(})==""\n"
R"==(#if SIMD != 1)==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SIMD))))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void)==""\n"
R"==(simple_concat(__global DATA_T *dst, long dst_offset0, SRC_PTRS) {)==""\n"
R"==(__global const DATA_T *src;)==""\n"
R"==(size_t src_ext_offset, input_offset;)==""\n"
R"==(size_t input_padded_offset, concat_axis_size;)==""\n"
R"==(#define CHECK_AND_GET(n) \)==""\n"
R"==(if (get_global_id(2) >= PADDED_OFFSET##n) { \)==""\n"
R"==(src = src##n; \)==""\n"
R"==(input_offset = OFFSET##n; \)==""\n"
R"==(input_padded_offset = PADDED_OFFSET##n; \)==""\n"
R"==(concat_axis_size = SRC##n##_CONCAT_AXIS; \)==""\n"
R"==(src_ext_offset = SRC##n##_EXT_OFFSET; \)==""\n"
R"==(})==""\n"
R"==(REDUCE(N_INPUTS, JOIN_ELSE, CHECK_AND_GET);)==""\n"
R"==(#undef CHECK_AND_GET)==""\n"
R"==(const size_t block_offset)==""\n"
R"==(= GWS0_BLOCK * (get_global_id(2) - input_padded_offset))==""\n"
R"==(+ (get_global_id(0) / SIMD) * READ_BLOCK;)==""\n"
R"==(const size_t thr_elems = READ_BLOCK / SIMD;)==""\n"
R"==(src += READ_OVERLAP * get_global_id(1) * src_ext_offset + block_offset;)==""\n"
R"==(#define WRITE_INFO(idx) \)==""\n"
R"==(get_write_info(block_offset + (idx), src_ext_offset, input_offset, \)==""\n"
R"==(input_padded_offset, concat_axis_size))==""\n"
R"==(#if SIMD == 1)==""\n"
R"==(dst += dst_offset0 + READ_OVERLAP * get_global_id(1) * DST_EXT_OFFSET;)==""\n"
R"==(for (int i = 0; i < thr_elems; ++i) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(i);)==""\n"
R"==(if (info.write) dst[info.idx] = src[i];)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const size_t lane = get_sub_group_local_id() % SIMD;)==""\n"
R"==(buffer_t buf;)==""\n"
R"==(#if (READ_BLOCK * DATA_TYPE_SIZE % 4 != 0))==""\n"
R"==(for (int i = 0; i < thr_elems; ++i))==""\n"
R"==(buf.v1[i] = src[i * SIMD + lane];)==""\n"
R"==(#else)==""\n"
R"==(#define MAYBE_BLOCK_READ(n, read, elems) \)==""\n"
R"==(do { \)==""\n"
R"==(if ((elems) & (n)) { \)==""\n"
R"==(const uint rel = (elems) & ~(((n) << 1) - 1); \)==""\n"
R"==(buf.v##n[rel / (n)] = read(&src[rel * SIMD]); \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(for (int i = 0; i < thr_elems / 16; ++i))==""\n"
R"==(buf.v16[i] = BLOCK_READ16(&src[16 * i * SIMD]);)==""\n"
R"==(MAYBE_BLOCK_READ(8, BLOCK_READ8, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(4, BLOCK_READ4, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(2, BLOCK_READ2, thr_elems);)==""\n"
R"==(MAYBE_BLOCK_READ(1, BLOCK_READ, thr_elems);)==""\n"
R"==(#undef MAYBE_BLOCK_READ)==""\n"
R"==(#endif )==""\n"
R"==(if (lane < READ_BLOCK % SIMD))==""\n"
R"==(buf.v1[thr_elems] = src[thr_elems * SIMD + lane];)==""\n"
R"==(dst += dst_offset0 + READ_OVERLAP * get_global_id(1) * DST_EXT_OFFSET;)==""\n"
R"==(#if (WRITE_BLOCK * DATA_TYPE_SIZE % 16 != 0))==""\n"
R"==(for (int i = 0; i < thr_elems; ++i) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(i * SIMD + lane);)==""\n"
R"==(if (info.write) dst[info.idx] = buf.v1[i];)==""\n"
R"==(})==""\n"
R"==(if (lane < READ_BLOCK % SIMD) {)==""\n"
R"==(struct write_info_t info = WRITE_INFO(thr_elems * SIMD + lane);)==""\n"
R"==(if (info.write) dst[info.idx] = buf.v1[thr_elems];)==""\n"
R"==(})==""\n"
R"==(#else)==""\n"
R"==(const size_t elems_per_iteration = MAX(SIMD, WRITE_BLOCK);)==""\n"
R"==(const size_t iterations = DIV_UP(READ_BLOCK, elems_per_iteration);)==""\n"
R"==(#pragma unroll)==""\n"
R"==(for (int j = 0; j < iterations; ++j) {)==""\n"
R"==(const size_t buf_off = DIV_UP(j * elems_per_iteration, SIMD);)==""\n"
R"==(const size_t block_off = buf_off * SIMD;)==""\n"
R"==(const size_t iter_elems = WRITE_BLOCK - (block_off % WRITE_BLOCK);)==""\n"
R"==(const size_t thr_iter_elems = iter_elems / SIMD;)==""\n"
R"==(struct write_info_t info = WRITE_INFO(block_off);)==""\n"
R"==(__global DATA_T *iter_dst = dst + info.idx;)==""\n"
R"==(#define MAYBE_BLOCK_WRITE(n, write, elems) \)==""\n"
R"==(do { \)==""\n"
R"==(if ((elems) & (n)) { \)==""\n"
R"==(const uint rel = (elems) & ~(((n) << 1) - 1); \)==""\n"
R"==(write(&iter_dst[rel * SIMD], load_vec##n(&buf, buf_off + rel)); \)==""\n"
R"==(} \)==""\n"
R"==(} while (0))==""\n"
R"==(if (info.write) {)==""\n"
R"==(for (int i = 0; i < thr_iter_elems / 16; ++i))==""\n"
R"==(BLOCK_WRITE16(&iter_dst[16 * i * SIMD],)==""\n"
R"==(load_vec16(&buf, buf_off + i * 16));)==""\n"
R"==(MAYBE_BLOCK_WRITE(8, BLOCK_WRITE8, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(4, BLOCK_WRITE4, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(2, BLOCK_WRITE2, thr_iter_elems);)==""\n"
R"==(MAYBE_BLOCK_WRITE(1, BLOCK_WRITE, thr_iter_elems);)==""\n"
R"==(})==""\n"
R"==(#undef MAYBE_BLOCK_WRITE)==""\n"
R"==(if (iter_elems % SIMD) {)==""\n"
R"==(const size_t written = block_off + thr_iter_elems * SIMD;)==""\n"
R"==(struct write_info_t info = WRITE_INFO(written + lane);)==""\n"
R"==(if (info.write && lane < MIN(SIMD, READ_BLOCK - written)))==""\n"
R"==(dst[info.idx] = buf.v1[buf_off + thr_iter_elems];)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}