namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_softmax_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2019-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/simple_softmax.h")==""\n"
R"==(#if IS_FWD)==""\n"
R"==(#if SUB_GROUP_SIZE == 16)==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))))==""\n"
R"==(#endif)==""\n"
R"==(__kernel void)==""\n"
R"==(simple_softmax_fwd_generic(__global SRC_DATA_T *src, __global DATA_T *dst,)==""\n"
R"==(__global float *src_scale, __global float *dst_scale POST_OP_ARGS) {)==""\n"
R"==(const int dim[] = {)==""\n"
R"==((get_global_id(0) / GROUP_SIZE) % BLOCK_0,)==""\n"
R"==(get_global_id(1) % BLOCK_1,)==""\n"
R"==(get_global_id(2) % BLOCK_2,)==""\n"
R"==((get_global_id(0) / GROUP_SIZE) / BLOCK_0,)==""\n"
R"==(get_global_id(1) / BLOCK_1,)==""\n"
R"==(get_global_id(2) / BLOCK_2,)==""\n"
R"==(};)==""\n"
R"==(float scale = 1.0f;)==""\n"
R"==(#if WITH_SRC_SCALES)==""\n"
R"==(scale *= src_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(#if SUB_GROUP_SIZE == 16)==""\n"
R"==(const int local_id = get_local_id(0);)==""\n"
R"==(const int begin = local_id * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(const int end = (local_id == GROUP_SIZE - 1))==""\n"
R"==(? SOFTMAX_AXIS)==""\n"
R"==(: (local_id + 1) * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(#if SOFTMAX_AXIS - (GROUP_SIZE - 1) * (SOFTMAX_AXIS / GROUP_SIZE) \)==""\n"
R"==(> SOFTMAX_AXIS / GROUP_SIZE)==""\n"
R"==(const int buf_size)==""\n"
R"==(= SOFTMAX_AXIS - (GROUP_SIZE - 1) * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(#else)==""\n"
R"==(const int buf_size = SOFTMAX_AXIS / GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(const int begin = 0;)==""\n"
R"==(const int end = SOFTMAX_AXIS;)==""\n"
R"==(const int buf_size = SOFTMAX_AXIS;)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_HALF(SRC_DATA_T) == 1 && IS_HALF(DST_DATA_TYPE) == 1)==""\n"
R"==(typedef half acc_t;)==""\n"
R"==(const acc_t acc_max = HALF_MAX;)==""\n"
R"==(const acc_t acc_zero = 0.h;)==""\n"
R"==(#elif DT_F64 || DST_DT_F64)==""\n"
R"==(typedef double acc_t;)==""\n"
R"==(const acc_t acc_max = DBL_MAX;)==""\n"
R"==(const acc_t acc_zero = 0.0;)==""\n"
R"==(#else)==""\n"
R"==(typedef float acc_t;)==""\n"
R"==(const acc_t acc_max = FLT_MAX;)==""\n"
R"==(const acc_t acc_zero = 0.f;)==""\n"
R"==(#endif)==""\n"
R"==(acc_t d[buf_size];)==""\n"
R"==(acc_t max_ = -acc_max;)==""\n"
R"==(acc_t denom_ = acc_zero;)==""\n"
R"==(if (!(NEEDS_PADDING(dim[0], dim[1], dim[2], dim[3], dim[4], begin))) {)==""\n"
R"==(for (int i = begin; i < end && i < DD(SOFTMAX_AXIS_IDX); ++i) {)==""\n"
R"==(size_t data_off)==""\n"
R"==(= DATA_OFF(dim[0], dim[1], dim[2], dim[3], dim[4], i);)==""\n"
R"==(d[i - begin] = SRC_TO_REF(src[data_off]);)==""\n"
R"==(max_ = max(max_, d[i - begin]);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if SUB_GROUP_SIZE == 16)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(max_ = sub_group_reduce_max(max_);)==""\n"
R"==(#else)==""\n"
R"==(max_ = work_group_reduce_max(max_);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(if (!(NEEDS_PADDING(dim[0], dim[1], dim[2], dim[3], dim[4], begin))) {)==""\n"
R"==(for (int i = begin; i < end && i < DD(SOFTMAX_AXIS_IDX); ++i) {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ += exp(d[i - begin] - max_);)==""\n"
R"==(#else)==""\n"
R"==(d[i - begin] = exp(d[i - begin] - max_);)==""\n"
R"==(denom_ += d[i - begin];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if SUB_GROUP_SIZE == 16)==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(denom_ = sub_group_reduce_add(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = work_group_reduce_add(denom_);)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(denom_ = log(denom_);)==""\n"
R"==(#else)==""\n"
R"==(denom_ = 1.0 / denom_;)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = begin; i < end; ++i) {)==""\n"
R"==(size_t data_off = DATA_OFF(dim[0], dim[1], dim[2], dim[3], dim[4], i);)==""\n"
R"==(POST_OP_DATA_T tmp;)==""\n"
R"==(if (NEEDS_PADDING(dim[0], dim[1], dim[2], dim[3], dim[4], i)) {)==""\n"
R"==(tmp = (POST_OP_DATA_T)(acc_zero);)==""\n"
R"==(} else {)==""\n"
R"==(float unscaled;)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(unscaled = d[i - begin] - max_ - denom_;)==""\n"
R"==(#else)==""\n"
R"==(unscaled = d[i - begin] * denom_;)==""\n"
R"==(#endif)==""\n"
R"==(tmp = (POST_OP_DATA_T)(scale * unscaled);)==""\n"
R"==(})==""\n"
R"==(POST_OP_DATA_T sum_src;)==""\n"
R"==(#if WITH_SUM)==""\n"
R"==(sum_src = (POST_OP_DATA_T)DATA_TO_REF(dst[data_off]);)==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 3)==""\n"
R"==(#if IS_CHANNEL_LAST)==""\n"
R"==(const unsigned po_d2 = (data_off / OC) % SPATIAL_DIM_0;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = data_off % SPATIAL_DIM_0;)==""\n"
R"==(#endif)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(#if IS_CHANNEL_LAST)==""\n"
R"==(const unsigned po_d2 = data_off / OC / SPATIAL_DIM_1;)==""\n"
R"==(const unsigned po_d3 = (data_off / OC) % SPATIAL_DIM_1;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = data_off / SPATIAL_DIM_1;)==""\n"
R"==(const unsigned po_d3 = data_off % SPATIAL_DIM_1;)==""\n"
R"==(#endif)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(#if IS_CHANNEL_LAST)==""\n"
R"==(const unsigned po_d2 = (data_off / OC) / SPATIAL_DIM_1 / SPATIAL_DIM_0;)==""\n"
R"==(const unsigned po_d3 = (data_off / OC) / SPATIAL_DIM_1;)==""\n"
R"==(const unsigned po_d4 = (data_off / OC) % SPATIAL_DIM_1;)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = data_off / SPATIAL_DIM_1 / SPATIAL_DIM_0;)==""\n"
R"==(const unsigned po_d3 = data_off / SPATIAL_DIM_1;)==""\n"
R"==(const unsigned po_d4 = data_off % SPATIAL_DIM_1;)==""\n"
R"==(#endif)==""\n"
R"==(#else)==""\n"
R"==(const unsigned po_d2 = 0;)==""\n"
R"==(const unsigned po_d3 = 0;)==""\n"
R"==(const unsigned po_d4 = 0;)==""\n"
R"==(#endif)==""\n"
R"==(const int mb = data_off / SPATIAL_DIMS_SIZE / OC;)==""\n"
R"==(#if IS_CHANNEL_LAST)==""\n"
R"==(const int oc = data_off % OC;)==""\n"
R"==(#else)==""\n"
R"==(const int oc = data_off / SPATIAL_DIMS_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(APPLY_POST_OPS_SERIAL(tmp, POST_OP_DATA_T, sum_src, POST_OP_DATA_T, mb,)==""\n"
R"==(1, oc, 1, po_d2, 1, po_d3, 1, po_d4, 1, 0, 1);)==""\n"
R"==(#if WITH_DST_SCALES)==""\n"
R"==(tmp /= dst_scale[0];)==""\n"
R"==(#endif)==""\n"
R"==(dst[data_off] = TO_DST(tmp);)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==(#if IS_BWD)==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))))==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))))==""\n"
R"==(__kernel void)==""\n"
R"==(simple_softmax_bwd_generic(__global DST_DATA_T *dst,)==""\n"
R"==(__global SRC_DATA_T *diff_src, __global DST_DATA_T *diff_dst) {)==""\n"
R"==(const int dim[] = {)==""\n"
R"==((get_global_id(0) / GROUP_SIZE) % BLOCK_0,)==""\n"
R"==(get_global_id(1) % BLOCK_1,)==""\n"
R"==(get_global_id(2) % BLOCK_2,)==""\n"
R"==((get_global_id(0) / GROUP_SIZE) / BLOCK_0,)==""\n"
R"==(get_global_id(1) / BLOCK_1,)==""\n"
R"==(get_global_id(2) / BLOCK_2,)==""\n"
R"==(};)==""\n"
R"==(const int local_id = get_local_id(0);)==""\n"
R"==(const int begin = local_id * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(const int end = (local_id == GROUP_SIZE - 1))==""\n"
R"==(? SOFTMAX_AXIS)==""\n"
R"==(: (local_id + 1) * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(#if SOFTMAX_AXIS - (GROUP_SIZE - 1) * (SOFTMAX_AXIS / GROUP_SIZE) \)==""\n"
R"==(> SOFTMAX_AXIS / GROUP_SIZE)==""\n"
R"==(const int buf_size)==""\n"
R"==(= SOFTMAX_AXIS - (GROUP_SIZE - 1) * (SOFTMAX_AXIS / GROUP_SIZE);)==""\n"
R"==(#else)==""\n"
R"==(const int buf_size = SOFTMAX_AXIS / GROUP_SIZE;)==""\n"
R"==(#endif)==""\n"
R"==(#if IS_HALF(SRC_DATA_T) == 1 && IS_HALF(DST_DATA_TYPE) == 1)==""\n"
R"==(typedef half acc_t;)==""\n"
R"==(const acc_t acc_zero = 0.h;)==""\n"
R"==(#elif DT_F64 || DST_DT_F64)==""\n"
R"==(typedef double acc_t;)==""\n"
R"==(const acc_t acc_zero = 0.0;)==""\n"
R"==(#else)==""\n"
R"==(typedef float acc_t;)==""\n"
R"==(const acc_t acc_zero = 0.f;)==""\n"
R"==(#endif)==""\n"
R"==(acc_t diff_d[buf_size];)==""\n"
R"==(acc_t d[buf_size];)==""\n"
R"==(acc_t sbr = acc_zero;)==""\n"
R"==(if (!(NEEDS_PADDING(dim[0], dim[1], dim[2], dim[3], dim[4], begin))) {)==""\n"
R"==(for (int i = begin; i < end && i < DD(SOFTMAX_AXIS_IDX); ++i) {)==""\n"
R"==(size_t idx = DATA_OFF(dim[0], dim[1], dim[2], dim[3], dim[4], i);)==""\n"
R"==(diff_d[i - begin] = DST_TO_REF(diff_dst[idx]);)==""\n"
R"==(d[i - begin] = DST_TO_REF(dst[idx]);)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(sbr += diff_d[i - begin];)==""\n"
R"==(#else)==""\n"
R"==(sbr += diff_d[i - begin] * d[i - begin];)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE)==""\n"
R"==(sbr = sub_group_reduce_add(sbr);)==""\n"
R"==(#else)==""\n"
R"==(sbr = work_group_reduce_add(sbr);)==""\n"
R"==(#endif)==""\n"
R"==(for (int i = begin; i < end; ++i) {)==""\n"
R"==(size_t idx = DATA_OFF(dim[0], dim[1], dim[2], dim[3], dim[4], i);)==""\n"
R"==(if (NEEDS_PADDING(dim[0], dim[1], dim[2], dim[3], dim[4], i)) {)==""\n"
R"==(diff_src[idx] = REF_TO_SRC(acc_zero);)==""\n"
R"==(} else {)==""\n"
R"==(#if LOGSOFTMAX)==""\n"
R"==(diff_src[idx])==""\n"
R"==(= REF_TO_SRC(diff_d[i - begin] - exp(d[i - begin]) * sbr);)==""\n"
R"==(#else)==""\n"
R"==(acc_t inner_data = diff_d[i - begin] - sbr;)==""\n"
R"==(diff_src[idx] = REF_TO_SRC(d[i - begin] * inner_data);)==""\n"
R"==(#endif)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}