namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *simple_zero_pad_kernel = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2020-2024 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#include "gpu/intel/ocl/types_interop.h")==""\n"
R"==(#define DEFAULT_NELEMS_BLOCK 8)==""\n"
R"==(static inline void typed_simple_zero_pad(__global void *a, ulong type_size,)==""\n"
R"==(ulong step_nelems, ulong nelems_block, ulong step_block, ulong nsteps,)==""\n"
R"==(ulong step_size, zero_pad_mask_t step_bitmask, ulong mode) {)==""\n"
R"==(const int i0 = get_global_id(0);)==""\n"
R"==(const int istep = get_global_id(1) * step_block;)==""\n"
R"==(const int iblock = get_global_id(2);)==""\n"
R"==(int offset = iblock * step_size + (step_size - nsteps * step_nelems))==""\n"
R"==(+ istep * step_nelems;)==""\n"
R"==(const int step = ZERO_PAD_MASK_DT_BITS;)==""\n"
R"==(__global long *a8 = (__global long *)a;)==""\n"
R"==(__global int *a4 = (__global int *)a;)==""\n"
R"==(__global short *a2 = (__global short *)a;)==""\n"
R"==(__global char *a1 = (__global char *)a;)==""\n"
R"==(if (mode == ZERO_PAD_BIT_MODE) {)==""\n"
R"==(for (int k = 0; k < step_block; k++) {)==""\n"
R"==(__attribute__((opencl_unroll_hint)) )==""\n"
R"==(for (int i = i0; i < step_nelems; i += nelems_block) {)==""\n"
R"==(if (step_bitmask.mask[i / step] & (1 << (i % step))) {)==""\n"
R"==(switch (type_size) {)==""\n"
R"==(case 8: a8[offset + i] = 0; break;)==""\n"
R"==(case 4: a4[offset + i] = 0; break;)==""\n"
R"==(case 2: a2[offset + i] = 0; break;)==""\n"
R"==(case 1: a1[offset + i] = 0; break;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(offset += step_nelems;)==""\n"
R"==(})==""\n"
R"==(} else {)==""\n"
R"==(int i = step_bitmask.mask[i0];)==""\n"
R"==(for (int k = 0; k < step_block; k++) {)==""\n"
R"==(switch (type_size) {)==""\n"
R"==(case 8: a8[offset + i] = 0; break;)==""\n"
R"==(case 4: a4[offset + i] = 0; break;)==""\n"
R"==(case 2: a2[offset + i] = 0; break;)==""\n"
R"==(case 1: a1[offset + i] = 0; break;)==""\n"
R"==(})==""\n"
R"==(offset += step_nelems;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(static inline void sized_simple_zero_pad(__global void *a, ulong type_size,)==""\n"
R"==(ulong step_nelems, ulong nelems_block, ulong step_block, ulong nsteps,)==""\n"
R"==(ulong step_size, zero_pad_mask_t step_bitmask, ulong mode) {)==""\n"
R"==(switch (type_size) {)==""\n"
R"==(case 8:)==""\n"
R"==(typed_simple_zero_pad((__global float *)a, 8, step_nelems,)==""\n"
R"==(nelems_block, step_block, nsteps, step_size, step_bitmask,)==""\n"
R"==(mode);)==""\n"
R"==(break;)==""\n"
R"==(case 4:)==""\n"
R"==(typed_simple_zero_pad((__global float *)a, 4, step_nelems,)==""\n"
R"==(nelems_block, step_block, nsteps, step_size, step_bitmask,)==""\n"
R"==(mode);)==""\n"
R"==(break;)==""\n"
R"==(case 2:)==""\n"
R"==(typed_simple_zero_pad((__global float *)a, 2, step_nelems,)==""\n"
R"==(nelems_block, step_block, nsteps, step_size, step_bitmask,)==""\n"
R"==(mode);)==""\n"
R"==(break;)==""\n"
R"==(case 1:)==""\n"
R"==(typed_simple_zero_pad((__global float *)a, 1, step_nelems,)==""\n"
R"==(nelems_block, step_block, nsteps, step_size, step_bitmask,)==""\n"
R"==(mode);)==""\n"
R"==(break;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__kernel void simple_zero_pad(__global void *a, ulong type_size,)==""\n"
R"==(ulong step_nelems, ulong nelems_block, ulong step_block, ulong nsteps,)==""\n"
R"==(ulong step_size, zero_pad_mask_t step_bitmask, ulong mode) {)==""\n"
R"==(switch (step_nelems) {)==""\n"
R"==(case 16:)==""\n"
R"==(sized_simple_zero_pad(a, type_size, 16, DEFAULT_NELEMS_BLOCK,)==""\n"
R"==(step_block, nsteps, step_size, step_bitmask, mode);)==""\n"
R"==(break;)==""\n"
R"==(case 32:)==""\n"
R"==(sized_simple_zero_pad(a, type_size, 32, DEFAULT_NELEMS_BLOCK,)==""\n"
R"==(step_block, nsteps, step_size, step_bitmask, mode);)==""\n"
R"==(break;)==""\n"
R"==(case 64:)==""\n"
R"==(sized_simple_zero_pad(a, type_size, 64, DEFAULT_NELEMS_BLOCK,)==""\n"
R"==(step_block, nsteps, step_size, step_bitmask, mode);)==""\n"
R"==(break;)==""\n"
R"==(default:)==""\n"
R"==(sized_simple_zero_pad(a, type_size, step_nelems, nelems_block,)==""\n"
R"==(step_block, nsteps, step_size, step_bitmask, mode);)==""\n"
R"==(break;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) __kernel void)==""\n"
R"==(simple_zero_pad_subg_16(__global char *a, const uint type_size,)==""\n"
R"==(const ulong base_offset, const ulong b_block_size,)==""\n"
R"==(const ulong b_block_offset, const ulong d0_stride,)==""\n"
R"==(const ulong d1_stride, const ulong d2_stride, const ulong d3_stride,)==""\n"
R"==(const unsigned d0_size, const unsigned d1_size, const unsigned d2_size,)==""\n"
R"==(const unsigned d3_size, const uint b_multiplier) {)==""\n"
R"==(const unsigned a_block_id = get_global_id(0) / 16;)==""\n"
R"==(const unsigned b_block_id = get_global_id(1);)==""\n"
R"==(unsigned mixed_dims = get_global_id(2);)==""\n"
R"==(const unsigned d3_dim = mixed_dims % d3_size;)==""\n"
R"==(mixed_dims /= d3_size;)==""\n"
R"==(const unsigned d2_dim = mixed_dims % d2_size;)==""\n"
R"==(mixed_dims /= d2_size;)==""\n"
R"==(const unsigned d1_dim = mixed_dims % d1_size;)==""\n"
R"==(const unsigned d0_dim = mixed_dims / d1_size;)==""\n"
R"==(__global char *p = a + base_offset;)==""\n"
R"==(p += a_block_id * b_block_size;)==""\n"
R"==(p += b_block_id * b_block_offset;)==""\n"
R"==(p += d0_dim * d0_stride;)==""\n"
R"==(p += d1_dim * d1_stride;)==""\n"
R"==(p += d2_dim * d2_stride;)==""\n"
R"==(p += d3_dim * d3_stride;)==""\n"
R"==(const unsigned stride = 16 * type_size;)==""\n"
R"==(for (unsigned b_midx = 0; b_midx < b_multiplier; ++b_midx) {)==""\n"
R"==(switch (type_size) {)==""\n"
R"==(case 8:)==""\n"
R"==(intel_sub_group_block_write_ul((__global ulong *)p, 0);)==""\n"
R"==(break;)==""\n"
R"==(case 4: intel_sub_group_block_write((__global uint *)p, 0); break;)==""\n"
R"==(case 2:)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)p, 0);)==""\n"
R"==(break;)==""\n"
R"==(case 1:)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)p, 0);)==""\n"
R"==(break;)==""\n"
R"==(})==""\n"
R"==(p += stride;)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) __kernel void)==""\n"
R"==(simple_zero_pad_subg_16_mask_and_clear_dt_1b()==""\n"
R"==(__global char *a, const uint mask) {)==""\n"
R"==(const uint block_size = 8;)==""\n"
R"==(const uint data_stride = 32;)==""\n"
R"==(const uint simd = 16;)==""\n"
R"==(const ulong offset = get_global_id(0) * block_size;)==""\n"
R"==(const unsigned subg_local_id = get_sub_group_local_id();)==""\n"
R"==(__global char *p = a + offset;)==""\n"
R"==(const uint mask_val = mask > subg_local_id ? 1 : 0;)==""\n"
R"==(uchar val_c[block_size];)==""\n"
R"==(for (unsigned idx = 0; idx < block_size / 2; ++idx) {)==""\n"
R"==(val_c[idx * 2] = intel_sub_group_block_read_uc()==""\n"
R"==((__global uchar *)(p + data_stride * idx));)==""\n"
R"==(})==""\n"
R"==(for (unsigned idx = 1; idx < block_size; idx += 2) {)==""\n"
R"==(val_c[idx] = 0;)==""\n"
R"==(})==""\n"
R"==(for (unsigned idx = 0; idx < block_size; idx += 2) {)==""\n"
R"==(val_c[idx] *= (uchar)mask_val;)==""\n"
R"==(})==""\n"
R"==(for (unsigned idx = 0; idx < block_size; idx += 8) {)==""\n"
R"==(intel_sub_group_block_write_uc8()==""\n"
R"==((__global uchar *)(p + simd * idx), *((uchar8 *)(&val_c[idx])));)==""\n"
R"==(})==""\n"
R"==(})==""\n"
R"==()==";
}
}
}
}
}